/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQuery(document).ready(function(){
    
    var massage = '',
        pageId,
        item,
        flag = true,
        uploadMode;
    
    jQuery('#toolbar-about').find('button').on('click', function(){
        jQuery('#about-dialog').modal();
        jQuery('#about-dialog').css('z-index', '1500');
    });

    jQuery('.select-intro-image').on('click', function(){
        jQuery('#uploader-modal').modal();
        uploadMode = 'introImage';
    });
    
    jQuery('#upload-dialog').on('show', function(){
        jQuery('#themes-gallery').empty();
        if (location.protocol == 'http:') {
            var src = 'http://www.balbooa.com/demo/index.php?option=com_baupdater&view=bagrid'
        } else {
            var src = 'index.php?option=com_bagrid&view=themes&layout=upload&tmpl=component'
        }
        var iframe = jQuery('<iframe/>', {
            id:'upload-iframe',
            src: src
        });
        jQuery('#themes-gallery').append(iframe);
    });

    jQuery('#toolbar-new .category-new').on('click', function(event){
        event.preventDefault();
        jQuery('#title-modal .category-id').val(0);
        jQuery('#title-modal .ba-title').val('');
        jQuery('#title-modal .ba-alias').val('');
        jQuery('#access option').removeAttr('selected');
        jQuery('#title-modal').modal();
    });

    jQuery('#toolbar-edit .category-edit').on('click', function(event){
        event.preventDefault();
        var count = 0
        jQuery('#adminForm .table-striped tr td input[type="checkbox"]').each(function(){
            if (jQuery(this).prop('checked')) {
                var id = jQuery(this).val(),
                    alias = jQuery(this).closest('td').attr('data-alias');
                    title = jQuery(this).closest('tr').find('.title-cell a').text(),
                    access = jQuery(this).closest('tr').find('.access-cell').attr('data-access');
                jQuery('#title-modal .category-id').val(id)
                jQuery('#title-modal .ba-title').val(jQuery.trim(title));
                jQuery('#title-modal .ba-alias').val(jQuery.trim(alias));
                jQuery('#access option').each(function(){
                    if (jQuery(this).val() == access) {
                        jQuery(this).attr('selected', true);
                    } else {
                        jQuery(this).removeAttr('selected');
                    }
                });
                count++;
            }
        });
        if (count == 1) {
            jQuery('#title-modal').modal();
        } else if (count == 0) {
            jQuery('#error-dialog .not-selected').show();
            jQuery('#error-dialog .many-selected').hide();
            jQuery('#error-dialog').modal();
        } else {
            jQuery('#error-dialog .not-selected').hide();
            jQuery('#error-dialog .many-selected').show();
            jQuery('#error-dialog').modal();
        }
    });

	jQuery('.category-edit-item').on('click', function(event){
		event.preventDefault();
		var id = jQuery(this).closest('tr').find('td').first().find('input').val(),
            alias = jQuery(this).closest('tr').find('td').first().attr('data-alias');
            title = jQuery(this).text(),
            access = jQuery(this).closest('tr').find('.access-cell').attr('data-access');
        jQuery('#title-modal .category-id').val(id)
        jQuery('#title-modal .ba-title').val(jQuery.trim(title));
        jQuery('#title-modal .ba-alias').val(jQuery.trim(alias));
        jQuery('#access option').each(function(){
            if (jQuery(this).val() == access) {
                jQuery(this).attr('selected', true);
            } else {
                jQuery(this).removeAttr('selected');
            }
        });
		jQuery('#title-modal').modal();
	});
	
    jQuery('#title-modal .ba-title').on('keyup keydown', function(event){
        if (event.keyCode == 13) {
            event.preventDefault();
        }
    });
    jQuery('.apply-category').on('click', function(event){
        event.preventDefault();
        var title = jQuery('#title-modal .ba-title').val();
        if (jQuery.trim(title) == '') {
            return false;
        }
        Joomla.submitbutton('categories.save')
    });
    
    function listenMessage(event)
    {
        if (uploadMode == 'uploadTheme') {
            var http = event.data[0]+event.data[1]+event.data[2]+event.data[3],
                messageClass,
                mes,
                flag = false;
            jQuery('#upload-dialog').modal('hide');
            jQuery('.ba-message-downloading').remove();
            if (http != 'http') {
                mes = event.data;
                messageClass = 'ba-alert';
            } else {
                flag = true;
                messageClass = 'ba-notice';
                mes = 'Theme installation.';
            }
            var str = '<div class="ba-message-downloading '+messageClass+'">'+mes+'</div>';
            jQuery('#filter-bar').before(str);
            if (flag) {
                jQuery.ajax({
                    type:"POST",
                    dataType:'text',
                    url:"index.php?option=com_bagrid&task=themes.downloadTheme",
                    data:{
                        theme_url: event.data
                    },
                    success: function(msg){
                        jQuery('.ba-message-downloading').text('Theme was successfully installed!');
                        setTimeout(function(){
                            window.location.href = window.location.href
                        }, 1000)
                    }
                });
            }
        } else if (uploadMode == 'introImage') {
            jQuery('.intro-image').val(event.data);
            jQuery('#uploader-modal').modal('hide');
        }
        
    }
    
    if (window.addEventListener) {
        window.addEventListener("message", function(event){listenMessage(event)}, false);
    } else {
        window.attachEvent("onmessage", function(event){listenMessage(event)});
    }
    
    jQuery('#toolbar-about').find('.active').tooltip();
    
    jQuery('.update-link').on('click', function(){
        jQuery('#message-dialog').modal();
        jQuery('#message-dialog p').text('Gridbox is updating');
        jQuery.ajax({
            type:"POST",
            dataType:'text',
            url:"index.php?option=com_bagrid&task=bagrids.updateGrid&tmpl=component",
            data:{
                target: 'http://www.balbooa.com/updates/bagrid/com_bagrid.zip',
            },
            success: function(msg){
                msg = JSON.parse(msg);
                if (msg.success) {
                    jQuery('#message-dialog p').text('Gridbox is updated now');
                    jQuery('#update-message, .ba-update-message').remove();
                    jQuery('.update').text(msg.message);
                } else {
                    jQuery('#message-dialog p').text('Gridbox was not updated, try again');
                }
            }
        });
    });
    
    jQuery('#toolbar-new a, .title-cell a, #toolbar-edit button').on('click', function(event){
        if (jQuery('#default-template').val() != 'gridboxcore') {
            event.stopPropagation();
            event.preventDefault();
            flag = false;
            jQuery('#not-default-dialog').modal();
        }
    });
    
    jQuery('.theme-upload-new').on('click', function(){
        jQuery('#upload-dialog').modal();
        uploadMode = 'uploadTheme';
    });
    
    jQuery('.page-export').on('click', function(){
        var exportId = new Array();
        jQuery('.table-striped tbody input[type="checkbox"]').each(function(){
            if (jQuery(this).prop('checked')) {
                var id = jQuery(this).val();
                exportId.push(id);
            }
        });
        if (exportId.length == 0) {
            jQuery('#error-dialog .not-selected').show();
            jQuery('#error-dialog .many-selected').hide();
            jQuery('#error-dialog').modal();
        } else {
            jQuery('#export-dialog').modal();
        }
    });

    jQuery('.apply-export').on('click', function(){
        var exportId = new Array(),
            menuExport = 'false';
        jQuery('.table-striped tbody input[type="checkbox"]').each(function(){
            if (jQuery(this).prop('checked')) {
                var id = jQuery(this).val();
                exportId.push(id);
            }
        });
        if (jQuery('.menu-export').prop('checked')) {
            menuExport = 'export';
        }
        exportId = exportId.join(';');
        jQuery.ajax({
            type : "POST",
            dataType : 'text',
            url : "index.php?option=com_bagrid&view=bagrids&task=bagrids.exportXML",
            data : {
                'export_id' : exportId,
                'export_menu' : menuExport
            },
            success: function(msg){
                var msg = JSON.parse(msg);
                if (msg.success) {
                    var iframe = jQuery('<iframe/>', {
                        name:'download-target',
                        id : 'download-target',
                        src : 'index.php?option=com_bagrid&view=bagrids&task=bagrids.doanload&tmpl=component&file='+msg.message,
                        style : 'display:none'
                    });
                    jQuery('#download-target').remove();
                    jQuery('body').append(iframe);
                    
                }
            }
        });
        jQuery('#export-dialog').modal('hide');
    });
    
    jQuery('.page-settings').on('click', function(){
        var options = new Array();
        jQuery('.table-striped tbody input[type="checkbox"]').each(function(){
            if (jQuery(this).prop('checked')) {
                var obj = {};
                obj.id = jQuery(this).val();
                obj.option = jQuery(this).parent().find('input[type="hidden"]').val();
                options.push(obj);
                item = jQuery(this);
            }
        });
        if (options.length == 0) {
            jQuery('#error-dialog .not-selected').show();
            jQuery('#error-dialog .many-selected').hide();
            jQuery('#error-dialog').modal();
        } else if (options.length > 1) {
            jQuery('#error-dialog .not-selected').hide();
            jQuery('#error-dialog .many-selected').show();
            jQuery('#error-dialog').modal();
        } else {
            var option = JSON.parse(options[0].option);
            pageId = options[0].id;
            jQuery('#published_on').val(option.created);
            jQuery('#access option').each(function(){
                if (jQuery(this).val() == option.page_access) {
                    jQuery(this).attr('selected', true);
                } else {
                    jQuery(this).removeAttr('selected');
                }
            });
            jQuery('#language option').each(function(){
                if (jQuery(this).val() == option.language) {
                    jQuery(this).attr('selected', true);
                } else {
                    jQuery(this).removeAttr('selected');
                }
            });
            jQuery.ajax({
                type:"POST",
                dataType:'text',
                url:"index.php?option=com_bagrid&task=bagrid.getPageTags",
                data : {
                    page_id : pageId
                },
                success: function(msg){
                    msg = JSON.parse(msg)
                    msg = JSON.parse(msg.message);
                    if (msg) {
                        jQuery('.picked-tags .tags-chosen').remove();
                        jQuery('select[name="meta_tags"]').empty();
                        for (var i = 0; i < msg.length; i++) {
                            var title = msg[i].title,
                                tagId = msg[i].id;
                            var str = '<li class="tags-chosen"><span>';
                            jQuery('.all-tags li').each(function(){
                                var search = jQuery(this).text();
                                search = search.toLowerCase();
                                if (title.toLowerCase() == search) {
                                    jQuery(this).addClass('selected-tag');
                                    return false;
                                }
                            });
                            str += title+'</span><i class="icon-remove" data-remove="'+tagId+'"></i></li>';
                            jQuery('.picked-tags .search-tag').before(str);
                            str = '<option value="'+tagId+'" selected>'+title+'</option>';
                            jQuery('select.meta_tags').append(str);
                        }
                        jQuery('.meta-tags .picked-tags .search-tag span').text('');
                        jQuery('.all-tags li').hide();
                    }
                }
            });
            jQuery('#settings-dialog .page-id').val(pageId);
            jQuery('#settings-dialog .page-title').val(option.title);
            jQuery('#settings-dialog .page-meta-title').val(option.meta_title);
            jQuery('#settings-dialog .page-meta-description').val(option.meta_description);
            jQuery('#settings-dialog .page-meta-keywords').val(option.meta_keywords);
            jQuery('#settings-dialog .page-alias').val(option.page_alias);
            jQuery('#settings-dialog .image-alt').val(option.image_alt);
            jQuery('#settings-dialog .intro-text').val(option.intro_text);
            jQuery('#settings-dialog .intro-image').val(option.intro_image);
            jQuery('#settings-dialog .theme-list option').each(function() {
                if (jQuery(this).val() == item.closest('tr').find('.page-theme').attr('data-theme')) {
                    jQuery(this).attr('selected', true);
                } else {
                    jQuery(this).removeAttr('selected');
                }
            });
            jQuery('#settings-dialog .page-category option').each(function(){
                if (jQuery(this).val() == option.page_category) {
                    jQuery(this).attr('selected', true);
                } else {
                    jQuery(this).removeAttr('selected');
                }
            });
            jQuery('#settings-dialog').modal();
        }
    });

    jQuery('.remove-intro-image').on('click', function(){
        jQuery('.intro-image').val('');
    });

    jQuery('.meta-tags .picked-tags .search-tag span').on('keyup', function(event){
        var title = jQuery(this).text();
        title = jQuery.trim(title);
        if (event.keyCode == 13) {
            if (!title) {
                jQuery(this).text('');
                return false;
            }
            var str = '<li class="tags-chosen"><span>',
                tagId = 'new$'+title;
            jQuery('.all-tags li').each(function(){
                var search = jQuery(this).text();
                search = search.toLowerCase();
                if (title.toLowerCase() == search) {
                    jQuery(this).addClass('selected-tag');
                    tagId = jQuery(this).attr('data-id');
                    return false;
                }
            });
            str += title+'</span><i class="icon-remove" data-remove="'+tagId+'"></i></li>';
            jQuery('.picked-tags .search-tag').before(str);
            str = '<option value="'+tagId+'" selected>'+title+'</option>';
            jQuery('select.meta_tags').append(str);
            jQuery(this).text('');
            jQuery('.all-tags li').hide();
        } else {
            title = title.toLowerCase();
            jQuery('.all-tags li').each(function(){
                var search = jQuery(this).text();
                search = search.toLowerCase();
                if (search.indexOf(title) < 0 || title == '') {
                    jQuery(this).hide();
                } else {
                    jQuery(this).show();
                }
            });
        }
    });

    jQuery('.all-tags').on('click', 'li', function(){
        if (jQuery(this).hasClass('selected-tag')) {
            return false;
        }
        var title = jQuery(this).text(),
            tagId = jQuery(this).attr('data-id');
        title = jQuery.trim(title);
        var str = '<li class="tags-chosen"><span>';
        str += title+'</span><i class="icon-remove" data-remove="'+tagId+'"></i></li>';
        jQuery('.picked-tags .search-tag').before(str);
        str = '<option value="'+tagId+'" selected>'+title+'</option>';
        jQuery('select.meta_tags').append(str);
        jQuery('.meta-tags .picked-tags .search-tag span').text('');
        jQuery('.all-tags li').hide();
        jQuery(this).addClass('selected-tag');
    });

    jQuery('.meta-tags .picked-tags').on('click', '.icon-remove', function(){
        var del = jQuery(this).attr('data-remove');
        jQuery('select.meta_tags option[value="'+del+'"]').remove();
        jQuery(this).closest('li').remove();
        jQuery('.all-tags li[data-id="'+del+'"]').removeClass('selected-tag');
        jQuery('.all-tags li').hide();
    });
    
    jQuery('.settings-apply').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        var title = jQuery('#settings-dialog .page-title').val().replace(new RegExp(";",'g'), '')
        title = jQuery.trim(title);
        if (title == '') {
            return;
        }
        Joomla.submitbutton('bagrid.updateParams');
    });
    
    jQuery('.theme-edit').on('click', function(){
        var options = new Array();
        jQuery('.theme-grid input[type="checkbox"]').each(function(){
            if (jQuery(this).prop('checked')) {
                var obj = {};
                item = jQuery(this);
                obj.id = jQuery(this).val();
                obj.name = item.closest('label').find('p').text();
                obj.default = item.closest('label').find('p').attr('data-default');
                options.push(obj);
            }
        });
        if (options.length == 0) {
            jQuery('#error-dialog .not-selected').show();
            jQuery('#error-dialog .many-selected').hide();
            jQuery('#error-dialog').modal();
        } else if (options.length > 1) {
            jQuery('#error-dialog .not-selected').hide();
            jQuery('#error-dialog .many-selected').show();
            jQuery('#error-dialog').modal();
        } else {
            pageId = options[0].id;
            jQuery('#theme-edit-dialog .theme-name').val(options[0].name);
            if (options[0].default == 1) {
                jQuery('#theme-edit-dialog .theme-default').attr('checked', true);
                jQuery('#theme-edit-dialog .theme-default').attr('disabled', true);
            } else {
                jQuery('#theme-edit-dialog .theme-default').removeAttr('checked');
                jQuery('#theme-edit-dialog .theme-default').removeAttr('disabled');
            }
            jQuery('#theme-edit-dialog').modal();
        }
    });
    
    jQuery('.theme-apply').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        var name = jQuery('#theme-edit-dialog .theme-name').val(),
            defaultTheme = 0,
            oldDefault = 0;
        if (jQuery('#theme-edit-dialog .theme-default').prop('disabled')) {
            oldDefault = 1;
        }
        if (jQuery('#theme-edit-dialog .theme-default').prop('checked')) {
            defaultTheme = 1;
        }
        jQuery.ajax({
            type:"POST",
            dataType:'text',
            url:"index.php?option=com_bagrid&task=theme.updateParams",
            data:{
                ba_id: pageId,
                theme_title: name,
                default_theme: defaultTheme,
                old_default: oldDefault
            },
            success: function(msg){
                if (defaultTheme == 1) {
                    jQuery('.theme-grid label').each(function(){
                        jQuery(this).find('p').attr('data-default', 0);
                        jQuery(this).find('.icon-star').remove();
                    });
                    item.closest('label').find('p').attr('data-default', 1);
                    item.closest('label').append('<i class="icon-star"></i>');
                }
                item.closest('label').find('p').text(name);
                jQuery('#theme-edit-dialog').modal('hide');
            }
        });
    });
});