<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

if (!JFactory::getUser()->authorise('core.manage', 'com_bagrid')) {
	return JError::raiseWarning(404, JText::_('JERROR_ALERTNOAUTHOR'));
}

JLoader::register('bagridHelper', dirname(__FILE__) . '/helpers/bagrid.php');

JHtml::addIncludePath(dirname(__FILE__) . '/helpers/html');

// Get an instance of the controller prefixed
$controller = JControllerLegacy::getInstance('bagrid');
 
// Perform the Request task and Execute request task
$controller->execute(JFactory::getApplication()->input->getCmd('task', 'display'));
 
// Redirect if set by the controller
$controller->redirect();