<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla controlleradmin library
jimport('joomla.application.component.controlleradmin');
jimport('joomla.filesystem.folder');
jimport('joomla.filesystem.file');

class bagridControllerCategories extends JControllerAdmin
{
    public function getModel($name = 'category', $prefix = 'bagridModel', $config = array()) 
    {
        $model = parent::getModel($name, $prefix, array('ignore_request' => true));
        return $model;
    }

    public function save()
    {
        $model = $this->getModel();
        if (!$model->save($data = '')) {
            $this->setRedirect('index.php?option=com_bagrid&view=categories', JText::_('ANOTHER_ALIAS'), 'error');
            return;
        }
        $redirect = 'index.php?option=com_bagrid&view=categories';
        $this->setRedirect($redirect, JText::_('JLIB_APPLICATION_SAVE_SUCCESS'));
    }
    
    public function duplicate()
    {
        $pks = $this->input->getVar('cid', array(), 'post', 'array');
        $model = $this->getModel();
        $model->duplicate($pks);
        $this->setMessage(JText::plural('BAGRID_DUPLICATED', count($pks)));
        $this->setRedirect('index.php?option=com_bagrid&view=bagrids&view=themes');
    }    
}