<?php
/**
* @package   bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');

class JFormFieldPage extends JFormFieldList
{
    protected $type = 'page';
    
    protected function getInput()
    {
        $script = array();
        $script[] = '	function jSelectPage_' . $this->id . '(id, title) {';
        $script[] = '		document.getElementById("' . $this->id . '_id").value = id;';
        $script[] = '		document.getElementById("' . $this->id . '_name").value = title;';
        $script[] = '		jQuery("#modalPage' . $this->id . '").modal("hide");';
        $script[] = '	}';
        JFactory::getDocument()->addScriptDeclaration(implode("\n", $script));
        JFactory::getDocument()->addStyleSheet(JUri::root(). 'administrator/components/com_bagrid/assets/css/ba-admin.css');
        $html = array();
        $link = 'index.php?option=com_bagrid&amp;view=bagrids&amp;layout=modal&amp;';
        $link .= 'tmpl=component&amp;function=jSelectPage_' . $this->id;
        
        if (1*$this->value > 0) {
            $db	= JFactory::getDbo();
            $query = $db->getQuery(true)
                ->select($db->quoteName('title'))
                ->from($db->quoteName('#__bagrid_bagrids'))
                ->where($db->quoteName('id') . ' = ' . (int) $this->value);
            $db->setQuery($query);
            $title = $db->loadResult();
        }
        if (empty($title)) {
            $title = JText::_('SELECT_PAGE');
        }
        $title = htmlspecialchars($title, ENT_QUOTES, 'UTF-8');
        if (1*$this->value == 0) 		{
			$value = '';
		} else {
            $value = 1*$this->value;
        }
        $url = $link . '&amp;' . JSession::getFormToken() . '=1';
        $html = array();
        $html[] = '<span class="input-append">';
		$html[] = '<input type="text" class="input-medium" id="' . $this->id . '_name" value="' .$title. '" disabled="disabled" size="35" />';
		$html[] = '<a href="#modalPage' . $this->id . '" class="btn" role="button"  data-toggle="modal">'
			. '<span class="icon-file"></span> '
			. JText::_('JSELECT') . '</a>';
        $html[] = '</span>';
        $html[] = '<input type="hidden" id="' . $this->id . '_id" name="' . $this->name . '" value="' . $value . '" />';
        $html[] = JHtml::_(
            'bootstrap.renderModal',
            'modalPage' . $this->id,
            array(
                'url' => $url,
                'width' => '740px',
                'height' => '538px'
            )
        );
        $script = 'jQuery(document).ready(function(){jQuery("#modalPage'.$this->id.' .modal-header").remove();
            jQuery("#modalPage'.$this->id.'").width(740);jQuery("#modalPage'.$this->id.'").css("margin-left", "-370px");
            jQuery("#modalPage'.$this->id.'").height(545);
        });';
        JFactory::getDocument()->addScriptDeclaration($script);
        return implode("\n", $html);
    }
}