<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

use Joomla\Registry\Registry;

class bagridTableCategories extends JTable
{
    public function __construct(&$db)
	{
		parent::__construct('#__bagrid_categories', 'id', $db);
	}

	public function check()
    {
        jimport('joomla.filter.output');
        if (empty($this->alias)) {
            $this->alias = $this->title;
        }
        $this->alias = JFilterOutput::stringURLSafe($this->alias);
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id')
            ->from('#__bagrid_categories')
            ->where('`alias` = ' .$db->Quote($this->alias))
            ->where('`id` <> '.$this->id);
        $db->setQuery($query);
        $id = $db->loadResult();
        if (!empty($id)) {
            return false;
        }
        return true;
    }
}
