 
<?php
/**
* @package   BaGallery
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

JHtml::_('behavior.tooltip');

if (JVERSION >= '3.4.0') {
    JHtml::_('behavior.formvalidator');
} else {
    JHtml::_('behavior.formvalidation');
}

$i = 1;
?>
<link rel="stylesheet" href="components/com_bagrid/assets/css/ba-admin.css" type="text/css"/>
<link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.11.2/themes/smoothness/jquery-ui.css" />
<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.11.2/jquery-ui.min.js"></script>
<script src="components/com_bagrid/assets/js/ba-uploader.js"></script>
<form action="<?php echo JRoute::_('index.php?option=com_bagrid&layout=thubnail&id=&tmpl=component'); ?>"
    method="post" name="adminForm" id="adminForm" class="form-validate" enctype="multipart/form-data">
    <div class ="row-fluid">
        <div class="span12 upload-toolbar">
            <div class="span8">
                <input type="button" class="ba-btn-primary" value="<?php echo JText::_('UPLOAD') ?>" id="show-upload">
                <input type="button" class="ba-btn" value="<?php echo JText::_('NEW_FOLDER') ?>" id="show-folder">
                <input type="button" class="ba-btn" value="<?php echo JText::_('DELETE') ?>" onclick="Joomla.submitbutton('uploader.delete')">
                <input type="hidden" name="current-dir" value="<?php echo $this->_parent; ?>">
            </div>
            <div class="span4">
                <a href="index.php?option=com_bagrid&view=uploader&folder=<?php echo $this->_parent; ?>&layout=thubnail&tmpl=component" class="ba-btn active">
                    <i class="icon-grid-view-2"></i>
                </a>
                <a href="index.php?option=com_bagrid&view=uploader&folder=<?php echo $this->_parent; ?>&tmpl=component" class="ba-btn">
                    <i class="icon-list-view"></i>
                </a>
                
            </div>
            <div class="row-fluid">
                <div class="span12" id="upload-control" style="display:none">
                    <input type="file" multiple name="ba-files[]">
                    <input type="button" class="ba-btn-primary" value="<?php echo JText::_('UPLOAD') ?>" onclick="Joomla.submitbutton('uploader.upload')">
                </div>
            </div>
            <div class="row-fluid">
                <div class="span12" id="folder-control" style="display:none">
                    <input type="text" name="new-folder" placeholder="<?php echo JText::_('ENTER_FOLDER_NAME') ?>">
                    <input type="button" class="ba-btn-primary" value="<?php echo JText::_('CREATE_FOLDER') ?>" onclick="Joomla.submitbutton('uploader.addfolder')">
                </div>
            </div>
        </div>
        <?php 
            if (is_array($this->_folders)) {
                foreach ($this->_folders as $folder) { 
                    if ($folder->name == '../') {
        ?>
        <div class="row-fluid">
            <div class="span12">
                <div class="uploader-nav">
                    <?php
                        for ($j = 0; $j<count($folder->par); $j++) {
                    ?>
                    <a class="folder-list" 
                       href="index.php?option=com_bagrid&view=uploader&folder=<?php echo $folder->path[$j]; ?>&tmpl=component&layout=thubnail" >
                        <?php echo $folder->par[$j]; ?>
                    </a>  /
                    <?php } ?>
                    <?php echo $folder->curr; ?>
                </div>
            </div>
        </div>
        <?php 
                    }
                }
            } 
        ?>
        <div class="ba-gallery-view">
            <div class="row-fluid">
                <?php if (is_array($this->_folders)) {
                          foreach ($this->_folders as $folder) { ?>
                <?php if ($i == 5) { ?>
                </div>
                <div class="row-fluid">
                <?php   $i = 1;
                                   }
                ?>
                <?php if ($folder->name != '../') {
                          $i++;    
                ?>
                <div class="ba-items" style="width:170px; height:auto; float:left">
                    <div class="ba-preview ba-folders" style="width:170px; height:170px;">
                        <a class="folder-list" 
                       href="index.php?option=com_bagrid&view=uploader&folder=<?php echo $folder->path; ?>&layout=thubnail&tmpl=component" >
                            <i class="icon-folder-2"></i>
                        </a>
                    </div>
                    <div class="gallery-img-title">
                        <input type="checkbox" name="ba-rm[]" value="<?php echo $folder->name; ?>">
                        <a class="folder-list" 
                           href="index.php?option=com_bagrid&view=uploader&folder=<?php echo $folder->path; ?>&layout=thubnail&tmpl=component" >
                            <?php echo $folder->name; ?>
                        </a>
                    </div>
                </div>
                <?php } ?>    
                <?php }} if (is_array($this->_images)) {
                             foreach ($this->_images as $image) { ?>
                <?php if ($i == 5) { ?>
                </div>
                <div class="row-fluid">
                <?php   $i = 1;
                                   }
                    $i++;    
                ?>
                <div class="ba-items ba-images" style="width:170px; height:auto; float:left">
                    <div class="ba-preview" style="width:170px; height:170px;">
                        <img src="<?php echo $image->url; ?>" style="max-height: 100%; max-width: 100%;">
                    </div>
                    <div class="gallery-img-title">
                        <input type="checkbox" name="ba-rm[]" value="<?php echo $image->name; ?>" class="select-item">
                        <input type="hidden" value="<?php foreach ($image as $name => $value) {
                                                                          echo $name.'-_-'.$value.'|||';
                                                                      } ?>" class="ba-obj">
                        <?php echo $image->name; ?>
                    </div>
                </div>
                <?php } }?>
            </div>
        </div>
    </div>
    <div class="footer-toolbar">
        <input type="button" class="ba-btn-primary" value="<?php echo JText::_('APPLY') ?>" id="ba-apply">
        <input type="button" class="ba-btn" value="<?php echo JText::_('CLOSE') ?>" id="ba-close">
    </div>
    <input type="hidden" name="task" value="gallery.uploader" />
    <?php echo JHtml::_('form.token'); ?>
</form>
