/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQuery(document).ready(function(){
    var shown = false;
    
    jQuery('#filter_search').on('keyup', function(){
        var search = jQuery(this).val();
        jQuery('.bagrid-table tr').each(function(){
            var title = jQuery(this).find('.send-message').text();
            title = jQuery.trim(title);
            title = title.toLowerCase();
            search = search.toLowerCase();
            if (title.indexOf(search) < 0) {
                jQuery(this).hide();
            } else {
                jQuery(this).show();
            }
        });
    });
    
    jQuery('.delete-font').on('click', function(event){
        event.stopPropagation();
        event.preventDefault();
        var deleteFlag = false;
        jQuery('.ba-items').each(function(){
            if (jQuery(this).prop('checked')) {
                deleteFlag = true;
                return false;
            }
        });
        if (deleteFlag) {
            var task = '&task=fonts.delete',
                form = jQuery('#ba-grid-form'),
                action = form.attr('action');
            action = action.replace('addFont', 'delete');
            form.attr('action', action);
            form.submit();
        }
    });
    
    jQuery('.edit-fonts').on('click', function(){
        if (!shown) {
            jQuery('.edit-container').show();
            shown = true;
        } else {
            jQuery('.edit-container').hide();
            shown = false;
        }
    });
    
    jQuery('.add-font').on('click', function(){
        var form = jQuery('#ba-grid-form'),
            font = jQuery('.new-font').val();
        font = jQuery.trim(font);
        if (font != '') {
            form.submit();
        }
    });
    
    jQuery('.send-message').on('click', function(){
        var fonts = jQuery(this).closest('tr').find('.options').val();
        window.parent.postMessage(fonts, "*");
    })
}); 
