/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.accordion-accordions').on('click', function(){
    var items = {},
        obj;
    jQ('.accordion-accordions-options .slides-list tbody').empty();
    currentItem.find('.accordion-group').each(function(){
        items.title = jQ(this).find('.accordion-heading a').text();
        items.description = jQ(this).find('.accordion-inner').html();
        var str = '<tr><td><input type="checkbox" class="accordion-items"';
        str += " value=''>";
        str += '</td><td width="90%">';
        str += items.title+'</td></tr>';
        obj = JSON.stringify(items);
        jQ('.accordion-accordions-options .slides-list tbody').append(str);
        jQ('.accordion-accordions-options .slides-list tbody .accordion-items').last().val(obj);
        items = {};
    });
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.accordion-accordions-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-accordions ~ a').hide();
    jQ('.nav-accordions').show().addClass('ba-active-options');
});
jQ('.accordion-add').on('click', function(){
    tabMode = 'addAccordion';
    jQ('.tab-title').val('New Collapse');
    CKEtab.setData('');
    jQ('#tabs-add-modal .tabs-mode').hide();
    jQ('#tabs-add-modal .accordion-mode').show();
    jQ('#tabs-add-modal').modal();
});
jQ('.accordion-edit').on('click', function(){
    var index = 0,
        item;
    jQ('.accordion-items').each(function(){
        if (jQ(this).prop('checked')) {
            item = jQ(this).val();
            index++;
        }
    });
    if (index === 1) {
        item = JSON.parse(item);
        tabMode = 'editAccordion';
        jQ('#tabs-add-modal .tabs-mode').hide();
        jQ('#tabs-add-modal .accordion-mode').show();
        jQ('.tab-title').val(item.title);
        CKEtab.setData(item.description);
        jQ('#tabs-add-modal').modal();
    } else if (index > 1) {
        jQ('#notification-modal .item-notification').show();
        jQ('#notification-modal .select-item').hide();
        jQ('#notification-modal').modal();
    } else if (index === 0) {
        jQ('#notification-modal .item-notification').hide();
        jQ('#notification-modal .select-item').show();
        jQ('#notification-modal').modal();
    }
});
jQ('.accordion-delete').on('click', function(){
    var index = 0;
    jQ('.accordion-items').each(function(){
        if (jQ(this).prop('checked')) {
            item = jQ(this).val();
            index++;
        }
    });
    if (index > 0) {
        deleteItem = 'accordion';
        jQ('#login-modal').modal();
    }
});
jQ('.accordion-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.accordion-style-list').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-accordion ~ a').hide();
    jQ('.nav-style-accordion').show().addClass('ba-active-options');
});
jQ('.nav-style-accordion').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.accordion-style-list').addClass('ba-in');
    jQ('.ba-element-options .ba-fade').removeClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-accordion ~ a').hide();
    jQ('.nav-style-accordion').show().addClass('ba-active-options');
});
jQ('.accordion-heading-panel').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.accordion-heading-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-heading-accordion').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-accordion-options').val();
    options = options.split(';');
    if (!options[22]) {
        options[22] = 0;
    }
    console.dir(options)
    jQ('.accordion-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.accordion-font-family').val(options[7].replace(new RegExp('\\+','g'), ' ')+' '+options[8]);
    var color = rgb2hex(options[4]);
    jQ('.accordion-text-color').minicolors('value', color[0]);
    jQ('.accordion-text-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[11]);
    jQ('.accordion-bg-color').minicolors('value', color[0]);
    jQ('.accordion-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[12]);
    jQ('.accordion-border-color').minicolors('value', color[0]);
    jQ('.accordion-border-color').minicolors('opacity', color[1]);
    jQ('.accordion-letter-spacing').val(options[22]);
    jQ('.accordion-letter-spacing-number').val(options[22]);
    jQ('.accordion-font-size').val(options[5]);
    jQ('.accordion-font-size-number').val(options[5]);
    jQ('.accordion-line-height').val(options[6]);
    jQ('.accordion-line-height-number').val(options[6]);
    jQ('.accordion-font-style').each(function(){
        if (jQ(this).val() == 'underline') {
            if (options[17] == 'underline') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'italic') {
            if (options[10] == 'italic') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'uppercase') {
            if (options[9] == 'uppercase') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.accordion-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-accordion-options', 3, jQ(this).val(), 'text-align', '.accordion-heading a', '');
});
jQ('.select-accordion-family').on('click', function(){
    uploadMode = 'accordionFamily';
    jQ('#fonts-modal').modal();
});
jQ('.accordion-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-accordion-options', 4, hex, 'color', '.accordion-heading a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.accordion-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-accordion-options', 11, hex, 'background-color', '.accordion-heading', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.accordion-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-accordion-options', 12, hex, 'border-color', '.accordion-inner', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.accordion-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-accordion-options', 22, inputValue, 'letter-spacing', '.accordion-heading a', 'px');
        jQ('.accordion-letter-spacing-number').val(inputValue);
    }, 12);
    jQ('.accordion-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.accordion-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-accordion-options', 22, value, 'letter-spacing', '.accordion-heading a', 'px');
    jQ('.accordion-letter-spacing').val(value);
    addHistory();
});
jQ('.accordion-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-accordion-options', 5, inputValue, 'font-size', '.accordion-heading a', 'px');
        jQ('.accordion-font-size-number').val(inputValue);
    }, 12);
    jQ('.accordion-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.accordion-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-accordion-options', 5, value, 'font-size', '.accordion-heading a', 'px');
    jQ('.accordion-font-size').val(value);
    addHistory();
});
jQ('.accordion-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-accordion-options', 6, inputValue, 'line-height', '.accordion-heading a', 'px');
        jQ('.accordion-line-height-number').val(inputValue);
    }, 12);
    jQ('.accordion-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.accordion-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val())
    setValue('.ba-accordion-options', 6, value, 'line-height', '.accordion-heading a', 'px');
    jQ('.accordion-line-height').val(value);
    addHistory();
});
jQ('.accordion-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-accordion-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[17] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[17] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[17] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[9] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[9] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[9] = 'none';
        }
    } else {
        if (options[10] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[10] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[10] = 'normal';
        }
    }
    currentItem.find('.accordion-heading a').css({
        'text-decoration' : options[17],
        'text-transform' : options[9],
        'font-style' : options[10]
    });
    options = options.join(';');
    currentItem.find('.ba-accordion-options').val(options);
    addHistory();
});
jQ('li.accordion-body').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.accordion-body-options').addClass('ba-fade');
    var options = currentItem.find('.ba-accordion-options').val();
    options = options.split(';');
    var color = rgb2hex(options[13]);
    jQ('.accordion-body-bg-color').minicolors('value', color[0]);
    jQ('.accordion-body-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[14]);
    jQ('.accordion-body-border-color').minicolors('value', color[0]);
    jQ('.accordion-body-border-color').minicolors('opacity', color[1]);
    jQ('.accordion-border-radius').val(options[15]);
    jQ('.accordion-border-radius-number').val(options[15]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-accordion-body').show().addClass('ba-active-options');
    jQ('.accordion-animation option').each(function(){
        if (jQ(this).val() == options[16]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
});
jQ('.accordion-body-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-accordion-options', 13, hex, 'background-color', '.accordion-body .accordion-inner', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.accordion-body-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-accordion-options', 14, hex, 'border-color', '.accordion-group', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.accordion-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-accordion-options', 15, inputValue, 'border-radius', '.accordion-group', 'px');
        jQ('.accordion-border-radius-number').val(inputValue);
    }, 12);
    jQ('.accordion-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.accordion-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-accordion-options', 15, value, 'border-radius', '.accordion-group', 'px');
    jQ('.accordion-border-radius').val(value);
    addHistory();
});
jQ('.accordion-animation').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-accordion-options').val();
    options = options.split(';');
    currentItem.find('.'+options[16]).removeClass(options[16]);
    currentItem.find(' > .accordion').addClass(value);
    options[16] = value;
    options = options.join(';');
    currentItem.find('.ba-accordion-options').val(options);
    addHistory();
});
jQ('.accordion-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.accordion-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-accordion-options').val();
    options = options.split(';');
    jQ('.accordion-padding-top').val(options[18]);
    jQ('.accordion-padding-top-number').val(options[18]);
    jQ('.accordion-padding-right').val(options[19]);
    jQ('.accordion-padding-right-number').val(options[19]);
    jQ('.accordion-padding-bottom').val(options[20]);
    jQ('.accordion-padding-bottom-number').val(options[20]);
    jQ('.accordion-padding-left').val(options[21]);
    jQ('.accordion-padding-left-number').val(options[21]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.accordion-padding-top').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find(' > .ba-accordion-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[18] = inputValue;
        currentItem.find('.accordion-inner').css({
            'padding' : options[18]+'px '+options[19]+'px '+options[20]+'px '+options[21]+'px'
        })
        options = options.join(';');
        currentItem.find(' > .ba-accordion-options').val(options);
        jQ('.accordion-padding-top-number').val(inputValue);
    }, 12);
    jQ('.accordion-padding-top').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.accordion-padding-right').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find(' > .ba-accordion-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[19] = inputValue;
        currentItem.find('.accordion-inner').css({
            'padding' : options[18]+'px '+options[19]+'px '+options[20]+'px '+options[21]+'px'
        })
        options = options.join(';');
        currentItem.find(' > .ba-accordion-options').val(options);
        jQ('.accordion-padding-right-number').val(inputValue);
    }, 12);
    jQ('.accordion-padding-right').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.accordion-padding-bottom').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find(' > .ba-accordion-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[20] = inputValue;
        currentItem.find('.accordion-inner').css({
            'padding' : options[18]+'px '+options[19]+'px '+options[20]+'px '+options[21]+'px'
        })
        options = options.join(';');
        currentItem.find(' > .ba-accordion-options').val(options);
        jQ('.accordion-padding-bottom-number').val(inputValue);
    }, 12);
    jQ('.accordion-padding-bottom').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.accordion-padding-left').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find(' > .ba-accordion-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[21] = inputValue;
        currentItem.find('.accordion-inner').css({
            'padding' : options[18]+'px '+options[19]+'px '+options[20]+'px '+options[21]+'px'
        })
        options = options.join(';');
        currentItem.find(' > .ba-accordion-options').val(options);
        jQ('.accordion-padding-left-number').val(inputValue);
    }, 12);
    jQ('.accordion-padding-left').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.accordion-padding-top-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find(' > .ba-accordion-options').val();
    options = options.split(';');
    options[18] = value;
    currentItem.find('.accordion-inner').css({
        'padding' : options[18]+'px '+options[19]+'px '+options[20]+'px '+options[21]+'px'
    })
    options = options.join(';');
    currentItem.find(' > .ba-accordion-options').val(options);
    jQ('.accordion-padding-top').val(value);
    addHistory();
});
jQ('.accordion-padding-right-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find(' > .ba-accordion-options').val();
    options = options.split(';');
    options[19] = value;
    currentItem.find('.accordion-inner').css({
        'padding' : options[18]+'px '+options[19]+'px '+options[20]+'px '+options[21]+'px'
    });
    options = options.join(';');
    currentItem.find(' > .ba-accordion-options').val(options);
    jQ('.accordion-padding-right').val(value);
    addHistory();
});
jQ('.accordion-padding-bottom-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find(' > .ba-accordion-options').val();
    options = options.split(';');
    options[20] = value;
    currentItem.find('.accordion-inner').css({
        'padding' : options[18]+'px '+options[19]+'px '+options[20]+'px '+options[21]+'px'
    })
    options = options.join(';');
    currentItem.find(' > .ba-accordion-options').val(options);
    jQ('.accordion-padding-bottom').val(value);
    addHistory();
});
jQ('.accordion-padding-left-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find(' > .ba-accordion-options').val();
    options = options.split(';');
    options[21] = value;
    currentItem.find('.accordion-inner').css({
        'padding' : options[18]+'px '+options[19]+'px '+options[20]+'px '+options[21]+'px'
    });
    options = options.join(';');
    currentItem.find(' > .ba-accordion-options').val(options);
    jQ('.accordion-padding-left').val(value);
    addHistory();
});
jQ('.accordion-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.accordion-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-accordion-options').val();
    options = options.split(';');
    jQ('.margin-top-accordion').val(options[0]);
    jQ('.margin-top-accordion-number').val(options[0]);
    jQ('.margin-bottom-accordion').val(options[1]);
    jQ('.margin-bottom-accordion-number').val(options[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-accordion').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-accordion-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-accordion-options').val(options);
        jQ('.margin-top-accordion-number').val(inputValue);
    }, 12);
    jQ('.margin-top-accordion').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-accordion').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-accordion-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-accordion-options').val(options);
        jQ('.margin-bottom-accordion-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-accordion').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-accordion-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-accordion-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-accordion-options').val(options);
    jQ('.margin-top-accordion').val(value);
    addHistory();
});
jQ('.margin-bottom-accordion-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-accordion-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-accordion-options').val(options);
    jQ('.margin-bottom-accordion').val(value);
    addHistory();
});
jQ('.accordion-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.accordion-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-accordion-options').val();
    options = options.split(';');
    jQ('.custom-suffix-accordion').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-accordion').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-accordion-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-accordion-options').val(options);
    addHistory();
});