/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.category-list-options-options').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.category-list-options-cell').addClass('ba-fade');
    var options = currentItem.find('.ba-category-list-options').val();
    options = options.split(';');
    jQ('.categories-list .all-categories li').hide();
    if (options[14] == 1) {
        jQ('.category-list-enable-counter').attr('checked', true);
    } else {
        jQ('.category-list-enable-counter').removeAttr('checked');
    }
    jQ('.category-list-options-cell .picked-categories li').not('.search-cat').remove();
    if (options[13] == '') {
        jQ('.category-list-options-cell .all-categories li').each(function(){
            var title = jQ(this).text(),
                id = jQ(this).attr('data-id');
            title = jQ.trim(title);
            var str = '<li class="categories-chosen"><span>';
            str += title+'</span><i class="icon-remove" data-remove="'+id+'"></i></li>';
            jQ('.picked-categories .search-cat').before(str);
            str = '<option value="'+id+'" selected>'+title+'</option>';
            jQ('.picked-categories .search-cat span').text('');
            jQ('.all-categories li').hide();
            jQ(this).addClass('selected-category');
        });
    } else {
        var array = options[13].split(',');
        jQ('.category-list-options-cell .all-categories li').each(function(){
            var title = jQ(this).text(),
                id = jQ(this).attr('data-id');
            if (jQ.inArray(id, array) >= 0) {
                title = jQ.trim(title);
                var str = '<li class="categories-chosen"><span>';
                str += title+'</span><i class="icon-remove" data-remove="'+id+'"></i></li>';
                jQ('.picked-categories .search-cat').before(str);
                str = '<option value="'+id+'" selected>'+title+'</option>';
                jQ('.picked-categories .search-cat span').text('');
                jQ('.all-categories li').hide();
                jQ(this).addClass('selected-category');
            } else {
                jQ(this).removeClass('selected-category');
            }
        });

    }
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.category-list-options-cell .picked-categories').on('click', function(event){
    var src = event.target;
    if (jQ(src).hasClass('categories-chosen') || jQ(src).parent().hasClass('categories-chosen')) {
        return;
    }
    var title = jQ(this).find('.search-cat span').text();
    title = jQ.trim(title);
    if (!title) {
        jQ('.category-list-options-cell .all-categories li').show();
    }
});
jQ('.category-list-options-cell .picked-categories .search-cat span').on('keyup', function(event){
    var title = jQ(this).text();
    title = jQ.trim(title);
    if (event.keyCode == 13) {
        if (!title) {
            jQ(this).text('');
            return false;
        }
        title = title.toLowerCase();
        var tagId;
        jQ('.category-list-options-cell .all-categories li').each(function(){
            var search = jQ(this).text();
            search = search.toLowerCase();
            if (search.indexOf(title) >= 0 && title != '' && !jQ(this).hasClass('selected-category')) {
                tagId = jQ(this).attr('data-id');
                title = jQ(this).text();
                title = jQ.trim(title);
                jQ(this).addClass('selected-category');
                return false;
            }
        });
        if (!tagId) {
            jQ('.category-list-options-cell .picked-categories .search-cat span').text('');
            return false;
        }
        var str = '<li class="categories-chosen"><span>';
        str += title+'</span><i class="icon-remove" data-remove="'+tagId+'"></i></li>';
        jQ('.picked-categories .search-cat').before(str);
        str = '<option value="'+tagId+'" selected>'+title+'</option>';
        jQ('.category-list-options-cell .picked-categories .search-cat span').text('');
        jQ('.category-list-options-cell .all-categories li').hide();
        jQ(this).addClass('selected-category');
        var array = new Array();
        jQ('.category-list-options-cell .picked-categories .categories-chosen').each(function(){
            var id = jQ(this).find('.icon-remove').attr('data-remove');
            array.push(id);
        });
        options = currentItem.find('.ba-category-list-options').val();
        options = options.split(';');
        options[13] = array.join(',');
        options = options.join(';');
        currentItem.find('.ba-category-list-options').val(options);
        getcategoryList();
    } else {
        title = title.toLowerCase();
        jQ('.category-list-options-cell .all-categories li').each(function(){
            var search = jQ(this).text();
            search = search.toLowerCase();
            if (search.indexOf(title) < 0 || title == '') {
                jQ(this).hide();
            } else {
                jQ(this).show();
            }
        });
    }
});
jQ('.category-list-options-cell .all-categories').on('click', 'li', function(){
    if (jQ(this).hasClass('selected-category')) {
        jQ('.category-list-options-cell .all-categories li').hide();
        return false;
    }
    var title = jQ(this).text(),
        tagId = jQ(this).attr('data-id');
    title = jQ.trim(title);
    var str = '<li class="categories-chosen"><span>';
    str += title+'</span><i class="icon-remove" data-remove="'+tagId+'"></i></li>';
    jQ('.category-list-options-cell .picked-categories .search-cat').before(str);
    str = '<option value="'+tagId+'" selected>'+title+'</option>';
    jQ('.category-list-options-cell .picked-categories .search-cat span').text('');
    jQ('.category-list-options-cell .all-categories li').hide();
    jQ(this).addClass('selected-category');
    var array = new Array();
    jQ('.category-list-options-cell .picked-categories .categories-chosen').each(function(){
        var id = jQ(this).find('.icon-remove').attr('data-remove');
        array.push(id);
    });
    options = currentItem.find('.ba-category-list-options').val();
    options = options.split(';');
    options[13] = array.join(',');
    options = options.join(';');
    currentItem.find('.ba-category-list-options').val(options);
    getcategoryList();
});
jQ('.category-list-options-cell .picked-categories').on('click', '.icon-remove', function(){
    var del = jQ(this).attr('data-remove');
    jQ(this).closest('li').remove();
    jQ('.category-list-options-cell .all-categories li[data-id="'+del+'"]').removeClass('selected-category');
    jQ('.category-list-options-cell .picked-categories .search-cat span').text('');
    jQ('.category-list-options-cell .all-categories li').show();
    var array = new Array();
    jQ('.category-list-options-cell .picked-categories .categories-chosen').each(function(){
        var id = jQ(this).find('.icon-remove').attr('data-remove');
        array.push(id);
    });
    options = currentItem.find('.ba-category-list-options').val();
    options = options.split(';');
    options[13] = array.join(',');
    options = options.join(';');
    currentItem.find('.ba-category-list-options').val(options);
    getcategoryList();
});
jQ('.category-list-enable-counter').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
        currentItem.find('.ba-cat-count').show();
    } else {
        value = 0;
        currentItem.find('.ba-cat-count').hide();
    }
    setValue('.ba-category-list-options', 14, value);
});
jQ('.category-list-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.category-list-style-options').addClass('ba-fade');
    var options = currentItem.find('.ba-category-list-options').val();
    options = options.split(';');
    jQ('.category-list-font-family').val(options[4].replace(new RegExp('\\+','g'), ' ')+' '+options[5]);
    jQ('.category-list-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).attr('checked', true);
            jQ(this).closest('.button-alignment').addClass('active');
        } else {
            jQ(this).removeAttr('checked');
            jQ(this).closest('.button-alignment').removeClass('active');
        }
    });
    var color = rgb2hex(options[7]);
    jQ('.category-list-hover-color').minicolors('value', color[0]);
    jQ('.category-list-hover-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[6]);
    jQ('.category-list-text-color').minicolors('value', color[0]);
    jQ('.category-list-text-color').minicolors('opacity', color[1]);
    jQ('.category-list-font-size').val(options[8]);
    jQ('.category-list-font-size-number').val(options[8]);
    jQ('.category-list-line-height').val(options[9]);
    jQ('.category-list-line-height-number').val(options[9]);
    if (options[10] == 'underline') {
        jQ('.category-list-font-style[value=underline]').closest('.ba-btn').addClass('active');
        jQ('.category-list-font-style[value=underline]').attr('checked', true);
    } else {
        jQ('.category-list-font-style[value=underline]').closest('.ba-btn').removeClass('active');
        jQ('.category-list-font-style[value=underline]').removeAttr('checked', true);
    }
    if (options[11] == 'uppercase') {
        jQ('.category-list-font-style[value=uppercase]').closest('.ba-btn').addClass('active');
        jQ('.category-list-font-style[value=uppercase]').attr('checked', true);
    } else {
        jQ('.category-list-font-style[value=uppercase]').closest('.ba-btn').removeClass('active');
        jQ('.category-list-font-style[value=uppercase]').removeAttr('checked', true);
    }
    if (options[12] == 'italic') {
        jQ('.button-font-style[value=italic]').closest('.ba-btn').addClass('active');
        jQ('.button-font-style[value=italic]').attr('checked', true);
    } else {
        jQ('.button-font-style[value=italic]').closest('.ba-btn').removeClass('active');
        jQ('.button-font-style[value=italic]').removeAttr('checked', true);
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-button').show().addClass('ba-active-options');
});
jQ('.select-category-list-family').on('click', function(){
    uploadMode = 'categoryListFontUpload';
    jQ('#fonts-modal').modal();
});
jQ('.category-list-align').on('click', function(){
    jQ('.button-alignment').removeClass('active');
    jQ(this).closest('.button-alignment').addClass('active');
    setValue('.ba-category-list-options', 3, jQ(this).val(), 'text-align', '.ba-cat-item', '');
    addHistory();
});
jQ('.category-list-hover-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != ''){
            setValue('.ba-category-list-options', 7, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.category-list-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-category-list-options', 6, hex, 'color', '.ba-cat-item *', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.category-list-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-category-list-options', 8, inputValue, 'font-size', '.ba-cat-item *', 'px');
            jQ('.category-list-font-size-number').val(inputValue);
        }, 12);
    jQ('.category-list-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.category-list-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-category-list-options', 8, value, 'font-size', '.ba-cat-item *', 'px');
    jQ('.category-list-line-height').val(value);
    addHistory();
});
jQ('.category-list-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-category-list-options', 9, inputValue, 'line-height', '.ba-cat-item *', 'px');
            jQ('.category-list-line-height-number').val(inputValue);
        }, 12);
    jQ('.category-list-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.category-list-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-category-list-options', 9, value, 'line-height', '.ba-cat-item *', 'px');
    jQ('.category-list-line-height').val(value);
    addHistory();
});
jQ('.category-list-font-style').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-category-list-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-cat *').css('text-decoration', value);
            options[10] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-cat-item *').css('text-decoration', 'none');
            options[10] = 'none';
        }
    } else if (value == 'uppercase') {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-cat-item *').css('text-transform', value);
            options[11] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-cat-item *').css('text-transform', 'none');
            options[11] = 'none';
        }
    } else {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-cat-item *').css('font-style', value);
            options[12] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-cat-item *').css('font-style', 'normal');
            options[12] = 'normal';
        }
    }
    options = options.join(';');
    currentItem.find('.ba-category-list-options').val(options);
    addHistory();
});
jQ('.category-list-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.category-list-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-category-list-options').val();
    options = options.split(';');
    jQ('.margin-top-category-list').val(options[1]);
    jQ('.margin-top-category-list-number').val(options[1]);
    jQ('.margin-bottom-category-list').val(options[2]);
    jQ('.margin-bottom-category-list-number').val(options[2]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-category-list').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-category-list-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 1, 2);
        currentItem.find('.ba-category-list-options').val(options);
        jQ('.margin-top-category-list-number').val(inputValue);
    }, 12);
    jQ('.margin-top-category-list').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-category-list-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-category-list-options').val();
    options = marginAction(currentItem, options, value, 1, 1, 2);
    jQ('.margin-top-category-list').val(value);
    currentItem.find('.ba-category-list-options').val(options);
    addHistory();
});
jQ('.margin-bottom-category-list').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-category-list-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 2, 1, 2);
        currentItem.find('.ba-category-list-options').val(options);
        jQ('.margin-bottom-category-list-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-category-list').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-category-list-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-category-list-options').val();
    options = marginAction(currentItem, options, value, 2, 1, 2);
    jQ('.margin-bottom-category-list').val(value);
    currentItem.find('.ba-category-list-options').val(options);
    addHistory();
});
jQ('.category-list-css').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.category-list-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-category-list-options').val();
    options = options.split(';');
    jQ('.custom-suffix-category-list').val(options[0]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-category-list').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-category-list-options').val(), jQ(this).val(), 0);
    currentItem.find('.ba-category-list-options').val(options);
    addHistory();
});