/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.icons-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.icons-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-icon-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[10]);
    jQ('.icons-bg-color').minicolors('value', color[0]);
    jQ('.icons-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[11]);
    jQ('.icons-border-color').minicolors('value', color[0]);
    jQ('.icons-border-color').minicolors('opacity', color[1]);
    jQ('.icons-border-radius').val(options[12]);
    jQ('.icons-border-radius-number').val(options[12]);
    jQ('.icons-padding').val(options[13]);
    jQ('.icons-padding-number').val(options[13]);
    jQ('.icons-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.icons-target option').each(function(){
        if (jQ(this).val() == options[8]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.icons-link').val(options[7]);
    color = rgb2hex(options[9]);
    jQ('.icons-hover-color').minicolors('value', color[0]);
    jQ('.icons-hover-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[4]);
    jQ('.icons-text-color').minicolors('value', color[0]);
    jQ('.icons-text-color').minicolors('opacity', color[1]);
    jQ('.icons-font-size').val(options[5]);
    jQ('.icons-font-size-number').val(options[5]);
    if (options[6] == '') {
        jQ('.icons-spinning').removeAttr('checked');
    } else {
        jQ('.icons-spinning').attr('checked', true);
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.icons-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-icon-options', 10, hex, 'background-color', 'i.zmdi', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.icons-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-icon-options', 11, hex);
            currentItem.find('i.zmdi').css('border', '1px solid '+hex);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.icons-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-icon-options', 12, inputValue, 'border-radius', 'i.zmdi', 'px');
        jQ('.icons-border-radius-number').val(inputValue);
    }, 12);
    jQ('.icons-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.icons-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-icon-options', 12, value, 'border-radius', 'i.zmdi', 'px');
    jQ('.icons-border-radius').val(value);
    addHistory();
});
jQ('.icons-padding').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-icon-options', 13, inputValue, 'padding', 'i.zmdi', 'px');
        jQ('.icons-padding-number').val(inputValue);
    }, 12);
    jQ('.icons-padding').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.icons-padding-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-icon-options', 13, value, 'padding', 'i.zmdi', 'px');
    jQ('.icons-padding').val(value);
    addHistory();
});
jQ('.select-icon').on('click', function(){
    uploadMode = "reselectIcon"
    jQ('#icons-upload-modal').modal();
});
jQ('.icons-align').on('click', function(){
    setValue('.ba-icon-options', 3, jQ(this).val(), 'text-align', currentItem, '');
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    addHistory();
});
jQ('.icons-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-icon-options', 4, hex, 'color', 'i.zmdi');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.icons-hover-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-icon-options', 9, hex);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.icons-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-icon-options', 5, inputValue);
        currentItem.find('i.zmdi').css({
            'font-size' : inputValue+'px',
            'width' : inputValue+'px',
            'height' : inputValue+'px'
        });
        jQ('.icons-font-size-number').val(inputValue);
    }, 12);
    jQ('.icons-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.icons-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-icon-options', 5, value);
    currentItem.find('i.zmdi').css({
        'font-size': value+'px',
        'width': value+'px',
        'height': value+'px',
    });
    jQ('.icons-font-size').val(value);
    addHistory();
});
jQ('.icons-spinning').on('click', function(){
    var options = currentItem.find('.ba-icon-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[6] = 'zmdi-hc-spin';
        currentItem.find('i.zmdi').addClass('zmdi-hc-spin');
    } else {
        options[6] = '';
        currentItem.find('.zmdi-hc-spin').removeClass('zmdi-hc-spin');
    }
    options = options.join(';');
    currentItem.find('.ba-icon-options').val(options);
    addHistory();
});
jQ('.icons-link').on('keyup', function(){
    var link = jQ(this).val(),
        options  = currentItem.find('.ba-icon-options').val();
    options = options.split(';');
    options[7] = link;
    if (link != '') {
        if (currentItem.find('i.zmdi').parent().hasClass('ba-item-icon')) {
            currentItem.find('i.zmdi').wrap('<a href="'+link+'" target="'+options[8]+'"></a>');
        } else {
            currentItem.find('i.zmdi').parent().attr('href', link);
        }
        currentItem.find(' a[href="'+link+'"]').on('click', function(){
            return false;
        });
    } else if (!currentItem.find('i.zmdi').parent().hasClass('ba-item-icon')) {
    	currentItem.find('i.zmdi').unwrap();
    }
    options = options.join(';');
    currentItem.find('.ba-icon-options').val(options);
    addHistory();
});
jQ('.icons-target').on('change', function(){
    setValue('.ba-icon-options', 8, jQ(this).val());
    if (!currentItem.find('i.zmdi').hasClass('ba-item-icon')) {
        currentItem.find('> a').attr('target', jQ(this).val());
    }
    addHistory();
});
jQ('.icons-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.icons-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-icon-options').val();
    options = options.split(';');
    jQ('.margin-top-icons').val(options[0]);
    jQ('.margin-top-icons-number').val(options[0]);
    jQ('.margin-bottom-icons').val(options[1]);
    jQ('.margin-bottom-icons-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-icons').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-icon-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-icon-options').val(options);
        jQ('.margin-top-icons-number').val(inputValue);
    }, 12);
    jQ('.margin-top-icons').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-icons').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-icon-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-icon-options').val(options);
        jQ('.margin-bottom-icons-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-icons').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-icons-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-icon-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-icon-options').val(options);
    jQ('.margin-top-icons').val(value);
    addHistory();
});
jQ('.margin-bottom-icons-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-icon-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-icon-options').val(options);
    jQ('.margin-bottom-icons').val(value);
    addHistory();
});
jQ('.icons-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.icons-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-icon-options').val();
    options = options.split(';');
    jQ('.custom-suffix-icons').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-icons').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-icon-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-icon-options').val(options);
    addHistory();
});