/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.slider-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-slider-options-cell').addClass('ba-fade');
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    if (options[51] == 1) {
        jQ('.caption-animation').attr('checked', true);
        jQ('.slider-title-animation').removeAttr('disabled');
        jQ('.slider-description-animation').removeAttr('disabled');
        jQ('.slider-button-animation').removeAttr('disabled');
        currentItem.find('.ba-slider-title').addClass(options[52]);
        currentItem.find('.ba-slide-description').addClass(options[53]);
        currentItem.find('.slider-button a').addClass(options[54]);
    } else {
        jQ('.caption-animation').removeAttr('checked');
        jQ('.slider-title-animation').attr('disabled', true);
        jQ('.slider-description-animation').attr('disabled', true);
        jQ('.slider-button-animation').attr('disabled', true);
        currentItem.find('.ba-slider-title').removeClass(options[52]);
        currentItem.find('.ba-slide-description').removeClass(options[53]);
        currentItem.find('.slider-button a').removeClass(options[54]);
    }
    jQ('.slider-navigation-style option').each(function(){
        if(jQ(this).val() == options[50]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[0] == 'ba-fullscreen') {
        jQ('.slider-fullscreen').attr('checked', true);
    } else {
        jQ('.slider-fullscreen').removeAttr('checked');
    }
    jQ('.slider-height').val(options[1]);
    jQ('.slider-height-number').val(options[1]);
    if (options[2]*1 == 1) {
        jQ('.slider-autoplay').attr('checked', true);
        jQ('.slider-pause').removeAttr('disabled');
        jQ('.slider-delay').removeAttr('disabled');
    } else {
        jQ('.slider-autoplay').removeAttr('checked');
        jQ('.slider-pause').attr('disabled', true);
        jQ('.slider-delay').attr('disabled', true);
    }
    if (options[3]*1 == 1) {
        jQ('.slider-pause').attr('checked', true)
    } else {
        jQ('.slider-pause').removeAttr('checked');
    }
    jQ('.slider-delay').val(options[4]);
    jQ('.slider-animation option').each(function(){
        if (jQ(this).val() == options[5]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[17] == 1) {
        jQ('.dot-navigation').attr('checked', true);
    } else {
        jQ('.dot-navigation').removeAttr('checked');
    }
    if (options[18] == 1) {
        jQ('.slide-nav-mouseover').attr('checked', true);
    } else {
        jQ('.slide-nav-mouseover').removeAttr('checked');
    }
    if (options[43] == 1) {
        jQ('.slider-overlay').attr('checked', true);
        jQ('.slider-overlay-color').removeAttr('disabled');
    } else {
        jQ('.slider-overlay').removeAttr('checked');
        jQ('.slider-overlay-color').attr('disabled', true);
    }
    var color = rgb2hex(options[44]);
    jQ('.slider-overlay-color').minicolors('value', color[0]);
    jQ('.slider-overlay-color').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.caption-animation').on('click', function(){
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    if (!options[52]) {
        options[52] = 'fadeIn';
        options[53] = 'fadeIn';
        options[54] = 'fadeIn';
    }
    if (jQ(this).prop('checked')) {
        options[51] = 1;
        jQ('.slider-title-animation').removeAttr('disabled');
        jQ('.slider-description-animation').removeAttr('disabled');
        jQ('.slider-button-animation').removeAttr('disabled');
        currentItem.find('.ba-slider-title').addClass(options[52]);
        currentItem.find('.ba-slide-description').addClass(options[53]);
        currentItem.find('.slider-button a').addClass(options[54]);
    } else {
        options[51] = 0;
        jQ('.slider-title-animation').attr('disabled', true);
        jQ('.slider-description-animation').attr('disabled', true);
        jQ('.slider-button-animation').attr('disabled', true);
        currentItem.find('.ba-slider-title').removeClass(options[52]);
        currentItem.find('.ba-slide-description').removeClass(options[53]);
        currentItem.find('.slider-button a').removeClass(options[54]);
    }
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-navigation-style').on('change', function(){
    setValue('.ba-slider-options', 50, jQ(this).val());
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-overlay').on('click', function(){
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[43] = 1;
        jQ('.slider-overlay-color').removeAttr('disabled');
        var str = '<div class="ba-overlay" style="background-color: ';
        str += options[44]+';"></div>';
        currentItem.find('.slider-content').before(str);
    } else {
        options[43] = 0;
        currentItem.find('.ba-overlay').remove();
        jQ('.slider-overlay-color').attr('disabled', true);
    }
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
});
jQ('.slider-overlay-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString')
            setValue('.ba-slider-options', 44, hex, 'background-color', '.ba-overlay', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.dot-navigation').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
        currentItem.find('ul.ba-slide').removeClass('hide-dots');
    } else {
        value = 0;
        currentItem.find('ul.ba-slide').addClass('hide-dots');
    }
    setValue('.ba-slider-options', 17, value);
});
jQ('.slide-nav-mouseover').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
        currentItem.find('ul.ba-slide').addClass('nav-hover');
    } else {
        value = 0;
        currentItem.find('ul.ba-slide').removeClass('nav-hover');
    }
    setValue('.ba-slider-options', 18, value);
});
jQ('.slider-fullscreen').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        currentItem.addClass('ba-fullscreen');
        value = 'ba-fullscreen'
    } else {
        currentItem.removeClass('ba-fullscreen');
        value = '';
    }
    setValue('.ba-slider-options', 0, value);
    addHistory();
});
jQ('.slider-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-slider-options', 1, inputValue, 'height', currentItem, 'px');
        jQ('.slider-height-number').val(inputValue);
    }, 12);
    jQ('.slider-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 1, value, 'height', currentItem, 'px');
    jQ('.slider-height').val(value);
    addHistory();
});
jQ('.slider-autoplay').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
        jQ('.slider-pause').removeAttr('disabled');
        jQ('.slider-delay').removeAttr('disabled');
    } else {
        value = 0;
        jQ('.slider-pause').attr('disabled', true);
        jQ('.slider-delay').attr('disabled', true);
    }
    setValue('.ba-slider-options', 2, value);
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-pause').on('click', function(){
    var value;
    if (jQ(this).prop('checked')) {
        value = 1;
    } else {
        value = 0;
    }
    setValue('.ba-slider-options', 3, value);
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-delay').on('keyup', function(){
    var value = jQ(this).val();
    value = value*1;
    if (isNaN(value)) {
        jQ(this).val(3000);
        value = 3000;
    }
    setValue('.ba-slider-options', 4, value);
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-animation').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    currentItem.find(' > ul').removeClass(options[5]);
    currentItem.find(' > ul').addClass(value);
    options[5] = value;
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slider-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    jQ('.margin-top-slider').val(options[6]);
    jQ('.margin-top-slider-number').val(options[6]);
    jQ('.margin-bottom-slider').val(options[7]);
    jQ('.margin-bottom-slider-number').val(options[7]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-slider').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-slider-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 6, 6, 7);
        currentItem.find('.ba-slider-options').val(options);
        jQ('.margin-top-slider-number').val(inputValue);
    }, 12);
    jQ('.margin-top-slider').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-slider').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-slider-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 7, 6, 7);
        currentItem.find('.ba-slider-options').val(options);
        jQ('.margin-bottom-slider-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-slider').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-slider-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slider-options').val();
    options = marginAction(currentItem, options, value, 6, 6, 7);
    currentItem.find('.ba-slider-options').val(options);
    jQ('.margin-top-slider').val(value);
    addHistory();
});
jQ('.margin-bottom-slider-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slider-options').val();
    options = marginAction(currentItem, options, value, 7, 6, 7);
    currentItem.find('.ba-slider-options').val(options);
    jQ('.margin-bottom-slider').val(value);
    addHistory();
});
jQ('.slider-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slider-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    jQ('.custom-suffix-slider').val(options[8]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-slider').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-slider-options').val(), jQ(this).val(), 8);
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-slides').on('click', function(){
    var items = {},
        name,
        str;
    jQ('.slider-slides-options .slides-list tbody').empty();
    currentItem.find('.slider-content li.item').each(function(){
        var url = jQ(this).find('.ba-slide-img').attr('data-img-url');
        if (url && !jQ(this).find('.ba-slide-img').attr('data-slide-video')) {
            items.type = 'image';
            name = url.split('/');
            name = name[name.length - 1];
        } else {
            items.type = 'video';
            items.video = jQ(this).find('.ba-slide-img').attr('data-slide-video');
            items.start = jQ(this).find('.ba-slide-img').attr('data-video-start');
            items.id = jQ(this).find('.ba-slide-img').children().attr('id');
            items.videoImage = jQ(this).find('.ba-slide-img').attr('data-img-url');
            url = 'components/com_bagrid/assets/images/image-placeholder.png';
            name = 'Video';
            if (!items.videoImage) {
                items.videoImage = '';
            }
        }
        items.url = url;
        items.h = jQ(this).find('.ba-slider-caption .ba-slider-title').html();
        items.p = jQ(this).find('.ba-slider-caption .ba-slide-description').html();
        items.label = jQ(this).find('.ba-slider-caption .slider-button a').text();
        items.link = jQ(this).find('.ba-slider-caption .slider-button a').attr('href');
        items.target = jQ(this).find('.ba-slider-caption .slider-button a').attr('target');
        str = '<tr><td><input type="checkbox" class="slides-items"';
        str += " value=''>";
        str += '</td><td><img src="'+url+'"></td><td width="60%">';
        str += name+'</td></tr>';
        jQ('.slider-slides-options .slides-list tbody').append(str);
        jQ('.slider-slides-options .slides-list tbody tr').last().find('.slides-items').val(JSON.stringify(items));
        items = {};
    });

    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slider-slides-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slides').show().addClass('ba-active-options');
});
jQ('.slides-edit').on('click', function(){
    var count = 0,
        item;
    jQ('.slider-slides-options .slides-items').each(function(){
        if (jQ(this).prop('checked')) {
            item = jQ(this).val();
            count++;
        }
    });
    if (count === 1) {
        var type = JSON.parse(item);
        type = type.type;
        tabMode = 'slideshow';
        if (type != 'video') {
            jQ('.slideshow-video-options').hide();
            jQ('.slideshow-image-reselect').show();
        } else {
            jQ('.slideshow-video-options').show();
            jQ('.slideshow-image-reselect').hide();
        }
        jQ('.slide-item').val(item);
        item = JSON.parse(item);
        if (item.type == 'video') {
            jQ('.slideshow-video').val(item.video);
            if (!item.start || item.start == 'undefined') {
                item.start = 0;
            }
            jQ('.slideshow-video-start').val(item.start);
            jQ('.responsive-video-image').val(item.videoImage);
        }
        jQ('.slide-title').val(item.h);
        jQ('.slide-description').val(item.p);
        jQ('.slide-label').val(item.label);
        jQ('.slide-link').val(item.link);
        jQ('.slide-target option').each(function(){
            if (item.target != 'undefined') {
                if (jQ(this).val() == item.target) {
                    jQ(this).attr('selected', true);
                } else {
                    jQ(this).removeAttr('selected');
                }
            } else {
                if (jQ(this).val() == '_blank') {
                    jQ(this).attr('selected', true);
                } else {
                    jQ(this).removeAttr('selected');
                }
            }
        });
        jQ('#slides-caption-modal').modal();
    } else if (count > 1) {
        jQ('#notification-modal .item-notification').show();
        jQ('#notification-modal .select-item').hide();
        jQ('#notification-modal').modal();
    } else if (count === 0) {
        jQ('#notification-modal .item-notification').hide();
        jQ('#notification-modal .select-item').show();
        jQ('#notification-modal').modal();
    }
});
jQ('.slides-responsive-background').on('click', function(){
    uploadMode = 'responsiveSlideshowImage';
    jQ('#uploader-modal').modal();
});
jQ('.slides-delete').on('click', function(){
    deleteItem = 'slideshow';
    jQ('.slider-slides-options .slides-items').each(function(){
        if (jQ(this).prop('checked')) {
            jQ('#login-modal').modal();
            return false;
        }
    });
});
jQ('.slides-add').on('click', function(){
    jQ('#slides-upload-modal').modal();
});
jQ('#slides-video').on('click', function(){
    jQ('.slide-embed-code').val('');
    jQ('#slides-embed-modal').modal();
});
jQ('.apply-slide-embed').on('click', function(event){
    event.preventDefault();
    var embed = jQ('.slide-embed-code').val(),
        str = '',
        dotsIndex = 0,
        url = 'components/com_bagrid/assets/images/image-placeholder.png',
        item = {
            type : 'video',
            name : 'Video',
            start : 0,
            url : url,
            video : embed,
            h : '',
            p : '',
            label : '',
            link : '',
            id : 'slider-video-'+sliderIndex
        },
        empty = false;
    if (jQ('.slider-content').children().length == 0) {
        empty = true;
    }
    str += '<tr><td><input type="checkbox" class="slides-items"';
    str += " value='"+JSON.stringify(item)+"'>";
    str += '</td><td><img src="'+url+'"></td><td width="60%">';
    str += item.name+'</td></tr>';
    jQ('.slider-slides-options .slides-list tbody').append(str);
    str = '<li class="item';
    if (empty) {
        str += ' active';
    }
    str +='"><div class="ba-slide-img" data-slide-video="';
    str += embed+'"><div id="slider-video-'+sliderIndex+'"></div>';
    str += '</div><div class="ba-slider-caption"><div class="';
    str += 'slideshow-title-wrapper empty-content"><h3 class="';
    str += 'ba-slider-title"></h3></div><div class="slideshow-';
    str += 'description-wrapper empty-content"><div';
    str += ' class="ba-slide-description"></div></div></div></li>';
    currentItem.find('.slider-content').append(str);
    if (!empty) {
        currentItem.find('.ba-slider-dots div').each(function(){
            dotsIndex = jQ(this).attr('data-ba-slide-to');
        });
        dotsIndex++;
    }
    str = '<div data-ba-slide-to="'+dotsIndex+'" class="icon-circle"></div>';
    currentItem.find('.ba-slider-dots').append(str);
    addHistory();
    jQ('#slides-embed-modal').modal('hide');
    jQ('#slides-upload-modal').modal('hide');
    sliderVideo['slider-video-'+sliderIndex] = new YT.Player('slider-video-'+sliderIndex, {
        width: jQ(window).width(),
        height: Math.ceil(jQ(window).width() / defaults.ratio),
        videoId: embed,
        playerVars: {
            controls: 0,
            showinfo: 0,
            loop : 1,
            start: item.start,
            modestbranding: 1,
            autohide: 1,
            iv_load_policy: 3,
            wmode: 'transparent',
            vq: 'hd720'
        },
        events: {
            'onReady': onPlayerReadySlider,
            'onStateChange': onPlayerStateChange
        }
    });
    sliderIndex++;
    sliderOptionRecreate(currentItem);
});
jQ('#slides-image').on('click', function(){
    uploadMode = 'slider';
    var win = window.frames.ba_uploader_images;
    win.postMessage("ba_slides", "*");
    jQ('#uploader-modal').modal();
});
jQ('.slider-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slider-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.ba-workspace .nav-style').show().addClass('ba-active-options');
});
jQ('.nav-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-element-options .ba-fade').removeClass('ba-fade')
    jQ('.slider-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style ~ a').hide();
    jQ('.nav-style').addClass('ba-active-options');
});
jQ('.slider-style-title').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-slider-style-title').addClass('ba-fade');
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-title').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    jQ('.slider-title-align').each(function(){
        if (jQ(this).val() == options[9]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    if (options[51] == 1) {
        jQ('.slider-title-animation').removeAttr('disabled');
    } else {
        jQ('.slider-title-animation').attr('disabled', true);
    }
    if (!options[52]) {
        options[52] = 'fadeIn';
    }
    if (!options[55]) {
        options[55] = 0;
    }
    jQ('.slider-title-letter-spacing').val(options[55]);
    jQ('.slider-title-letter-spacing-number').val(options[55]);
    jQ('.slider-title-animation option').each(function(){
        if (jQ(this).val() == options[52]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.slider-title-font-family').val(options[10].replace(new RegExp('\\+','g'), ' ')+' '+options[11]);
    var color = rgb2hex(options[12]);
    jQ('.slider-title-text-color').minicolors('value', color[0]);
    jQ('.slider-title-text-color').minicolors('opacity', color[1]);
    jQ('.slider-title-font-size').val(options[13]);
    jQ('.slider-title-font-size-number').val(options[13]);
    jQ('.slider-title-line-height').val(options[14]);
    jQ('.slider-title-line-height-number').val(options[14]);
    jQ('.slider-title-font-style').each(function(){
        if (jQ(this).val() == 'underline') {
            if (options[47] == 'underline') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'uppercase') {
            if (options[15] == 'uppercase') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'italic') {
            if (options[16] == 'italic') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
    jQ('.slider-title-margin-bottom').val(options[45]);
    jQ('.slider-title-margin-bottom-number').val(options[45]);
});
jQ('.slider-title-animation').on('change', function(){
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    currentItem.find('.ba-slider-title').removeClass(options[52]);
    options[52] = jQ(this).val();
    currentItem.find('.ba-slider-title').addClass(options[52]);
    currentItem.find('.ba-slider-title').addClass('select-animation');
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-title-margin-bottom').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 45, inputValue, 'margin-bottom', '.ba-slider-caption .ba-slider-title', 'px');
            jQ('.slider-title-margin-bottom-number').val(inputValue);
        }, 12);
    jQ('.slider-title-margin-bottom').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-title-margin-bottom-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 45, value, 'margin-bottom', '.ba-slider-caption .ba-slider-title', 'px');
    jQ('.slider-title-margin-bottom').val(value);
    addHistory();
});
jQ('.select-slider-title-family').on('click', function(){
    uploadMode = 'sliderTitle';
    jQ('#fonts-modal').modal();
});
jQ('.select-slider-description-family').on('click', function(){
    uploadMode = 'sliderDescription';
    jQ('#fonts-modal').modal();
});
jQ('.select-slider-button-family').on('click', function(){
    uploadMode = 'sliderButton';
    jQ('#fonts-modal').modal();
});
jQ('.slider-title-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-slider-options', 9, jQ(this).val(), 'text-align', '.ba-slider-caption .slideshow-title-wrapper', '');
    addHistory();
});
jQ('.slider-title-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slider-options', 12, hex, 'color', '.ba-slider-caption .ba-slider-title', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slider-title-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 55, inputValue, 'letter-spacing', '.ba-slider-caption .ba-slider-title', 'px');
            jQ('.slider-title-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.slider-title-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-title-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 55, value, 'letter-spacing', '.ba-slider-caption .ba-slider-title', 'px');
    jQ('.slider-title-letter-spacing').val(value);
    addHistory();
});
jQ('.slider-title-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 13, inputValue, 'font-size', '.ba-slider-caption .ba-slider-title', 'px');
            jQ('.slider-title-font-size-number').val(inputValue);
        }, 12);
    jQ('.slider-title-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-title-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 13, value, 'font-size', '.ba-slider-caption .ba-slider-title', 'px');
    jQ('.slider-title-font-size').val(value);
    addHistory();
});
jQ('.slider-title-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-slider-options', 14, inputValue, 'line-height', '.ba-slider-caption .ba-slider-title', 'px');
        jQ('.slider-title-line-height-number').val(inputValue);
    }, 12);
    jQ('.slider-title-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-title-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 14, value, 'line-height', '.ba-slider-caption .ba-slider-title', 'px');
    jQ('.slider-title-line-height').val(value);
    addHistory();
});
jQ('.slider-title-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[47] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[47] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[47] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[15] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[15] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[15] = 'none';
        }
    } else {
        if (options[16] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[16] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[16] = 'normal';
        }
    }
    currentItem.find('.ba-slider-caption .ba-slider-title').css({
        'text-decoration' : options[47],
        'text-transform' : options[15],
        'font-style' : options[16]
    });
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-style-description').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-slider-style-description').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-description').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    jQ('.slider-description-align').each(function(){
        if (jQ(this).val() == options[19]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    if (options[51] == 1) {
        jQ('.slider-description-animation').removeAttr('disabled');
    } else {
        jQ('.slider-description-animation').attr('disabled', true);
    }
    if (!options[53]) {
        options[53] = 'fadeIn';
    }
    if (!options[56]) {
        options[56] = 0;
    }
    jQ('.slider-description-letter-spacing').val(options[56]);
    jQ('.slider-description-letter-spacing-number').val(options[56])
    jQ('.slider-description-animation option').each(function(){
        if (jQ(this).val() == options[53]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.slider-description-font-family').val(options[20].replace(new RegExp('\\+','g'), ' ')+' '+options[21]);
    var color = rgb2hex(options[22]);
    jQ('.slider-description-text-color').minicolors('value', color[0]);
    jQ('.slider-description-text-color').minicolors('opacity', color[1]);
    jQ('.slider-description-font-size').val(options[23]);
    jQ('.slider-description-font-size-number').val(options[23]);
    jQ('.slider-description-line-height').val(options[24]);
    jQ('.slider-description-line-height-number').val(options[24]);
    jQ('.slider-description-font-style').each(function(){
        if (jQ(this).val() == 'underline') {
            if (options[48] == 'underline') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'uppercase') {
            if (options[25] == 'uppercase') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'italic') {
            if (options[26] == 'italic') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.slider-description-animation').on('change', function(){
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    currentItem.find('.ba-slide-description').removeClass(options[53]);
    options[53] = jQ(this).val();
    currentItem.find('.ba-slide-description').addClass(options[53]);
    currentItem.find('.ba-slide-description').addClass('select-animation');
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-description-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-slider-options', 19, jQ(this).val(), 'text-align', '.ba-slider-caption .slideshow-description-wrapper', '');
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-description-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 56, inputValue, 'letter-spacing', '.ba-slider-caption .ba-slide-description', 'px');
            jQ('.slider-description-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.slider-description-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-description-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 56, value, 'letter-spacing', '.ba-slider-caption .ba-slide-description', 'px');
    jQ('.slider-description-letter-spacing').val(value);
    addHistory();
});
jQ('.slider-description-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            var hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slider-options', 22, hex, 'color', '.ba-slider-caption .ba-slide-description', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        sliderOptionRecreate(currentItem);
        addHistory();
    }
});
jQ('.slider-description-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 23, inputValue, 'font-size', '.ba-slider-caption .ba-slide-description', 'px');
            jQ('.slider-description-font-size-number').val(inputValue);
        }, 12);
    jQ('.slider-description-font-size').on('mouseup', function(){
        clearInterval(interval);
        sliderOptionRecreate(currentItem);
        addHistory();
    });
});
jQ('.slider-description-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 23, value, 'font-size', '.ba-slider-caption .ba-slide-description', 'px');
    jQ('.slider-description-font-size').val(value);
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-description-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-slider-options', 24, inputValue, 'line-height', '.ba-slider-caption .ba-slide-description', 'px');
        jQ('.slider-description-line-height-number').val(inputValue);
    }, 12);
    jQ('.slider-description-line-height').on('mouseup', function(){
        clearInterval(interval);
        sliderOptionRecreate(currentItem);
        addHistory();
    });
});
jQ('.slider-description-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 24, value, 'line-height', '.ba-slider-caption .ba-slide-description', 'px');
    jQ('.slider-description-line-height').val(value);
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-description-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[48] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[48] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[48] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[25] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[25] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[25] = 'none';
        }
    } else {
        if (options[26] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[26] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[26] = 'normal';
        }
    }
    currentItem.find('.ba-slider-caption .ba-slide-description').css({
        'text-decoration' : options[48],
        'text-transform' : options[25],
        'font-style' : options[26]
    });
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
    sliderOptionRecreate(currentItem);
    addHistory();
});
jQ('.slider-style-button').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slider-style-button-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-button').show().addClass('ba-active-options');
});
jQ('.nav-slider-button').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-element-options .ba-fade').removeClass('ba-fade');
    jQ('.slider-style-button-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-button').show().addClass('ba-active-options');
    jQ('.nav-slider-button ~ a').hide();
});
jQ('.slider-button-font').on('click', function(){
    jQ('.slider-style-button-options').removeClass('ba-in');
    jQ('.slider-button-font-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-font').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-slider-options').val(),
        color;
    options = options.split(';');
    jQ('.slider-button-align').each(function(){
        if (jQ(this).val() == options[27]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    if (options[51] == 1) {
        jQ('.slider-button-animation').removeAttr('disabled');
    } else {
        jQ('.slider-button-animation').attr('disabled', true);
    }
    if (!options[54]) {
        options[54] = 'fadeIn';
    }
    if (!options[57]) {
        options[57] = 0;
    }
    jQ('.slider-button-letter-spacing').val(options[57]);
    jQ('.slider-button-letter-spacing-number').val(options[57]);
    jQ('.slider-button-animation option').each(function(){
        if (jQ(this).val() == options[54]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.slider-button-font-family').val(options[28].replace(new RegExp('\\+','g'), ' ')+' '+options[29]);
    color = rgb2hex(options[30]);
    jQ('.slider-button-bg-color').minicolors('value', color[0]);
    jQ('.slider-button-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[31]);
    jQ('.slider-button-text-color').minicolors('value', color[0]);
    jQ('.slider-button-text-color').minicolors('opacity', color[1]);
    jQ('.slider-button-font-size').val(options[32]);
    jQ('.slider-button-font-size-number').val(options[32]);
    jQ('.slider-button-font-style').each(function(){
        var value = jQ(this).val();
        if (jQ(this).val() == 'underline') {
            if (options[49] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        } else if (jQ(this).val() == 'uppercase') {
            if (options[33] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        } else {
            if (options[34] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.slider-button-animation').on('change', function(){
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    currentItem.find('.slider-button a').removeClass(options[54]);
    options[54] = jQ(this).val();
    currentItem.find('.slider-button a').addClass(options[54]);
    currentItem.find('.slider-button a').addClass('select-animation');
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-button-align').on('click', function(){
    jQ('.button-alignment').removeClass('active');
    jQ(this).closest('.button-alignment').addClass('active');
    setValue('.ba-slider-options', 27, jQ(this).val(), 'text-align', '.ba-slider-caption .slider-button', '');
    addHistory();
});
jQ('.slider-button-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != ''){
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slider-options', 30, hex, 'background', '.ba-slider-caption .slider-button a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slider-button-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 57, inputValue, 'letter-spacing', '.ba-slider-caption .slider-button a', 'px');
            jQ('.slider-button-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.slider-button-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-button-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 57, value, 'letter-spacing', '.ba-slider-caption .slider-button a', 'px');
    jQ('.slider-button-letter-spacing').val(value);
    addHistory();
});
jQ('.slider-button-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slider-options', 31, hex, 'color', '.ba-slider-caption .slider-button a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slider-button-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 32, inputValue, 'font-size', '.ba-slider-caption .slider-button a', 'px');
            jQ('.slider-button-font-size-number').val(inputValue);
        }, 12);
    jQ('.slider-button-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-button-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 32, value, 'font-size', '.ba-slider-caption .slider-button a', 'px');
    jQ('.slider-button-font-size').val(value);
    addHistory();
});
jQ('.slider-button-font-style').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    if (jQ(this).val() == 'underline') {
        if (options[49] != value) {
            jQ(this).closest('label').addClass('active');
            options[49] = value;

        } else {
            jQ(this).closest('label').removeClass('active');
            options[49] = 'none';
        }
    } else if (jQ(this).val() == 'uppercase') {
        if (options[33] != value) {
            jQ(this).closest('label').addClass('active');
            options[33] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[33] = 'none';
        }
    } else {
        if (options[34] != value) {
            jQ(this).closest('label').addClass('active');
            options[34] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[34] = 'normal';
        }
    }
    currentItem.find('.ba-slider-caption .slider-button a').css({
        'text-decoration' : options[49],
        'text-transform' : options[33],
        'font-style' : options[34]
    });
    options = options.join(';');
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-button-border').on('click', function(){
    jQ('.slider-style-button-options').removeClass('ba-in');
    jQ('.slider-button-border-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-slider-options').val(),
        color;
    options = options.split(';');
    jQ('.slider-button-border-radius').val(options[35]);
    jQ('.slider-button-border-radius-number').val(options[35]);
    color = rgb2hex(options[36]);
    jQ('.slider-button-border-color').minicolors('value', color[0]);
    jQ('.slider-button-border-color').minicolors('opacity', color[1]);
    jQ('.slider-button-border-width').val(options[37]);
    jQ('.slider-button-border-width-number').val(options[37]);
});
jQ('.slider-button-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 35, inputValue, 'border-radius', '.ba-slider-caption .slider-button a', 'px');
            jQ('.slider-button-border-radius-number').val(inputValue);
        }, 12);
    jQ('.slider-button-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-button-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 35, value, 'border-radius', '.ba-slider-caption .slider-button a', 'px');
    jQ('.slider-button-border-radius').val(value);
    addHistory();
});
jQ('.slider-button-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-slider-options').val();
            options = options.split(';');
            options[36] = jQ(this).minicolors('rgbaString');
            currentItem.find('.ba-slider-caption .slider-button a').css('border', options[37]+'px solid '+options[36]);
            options = options.join(';')
            currentItem.find('.ba-slider-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slider-button-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-slider-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[37] = inputValue;
            currentItem.find('.ba-slider-caption .slider-button a').css('border', options[37]+'px solid '+options[36]);
            options = options.join(';');
            currentItem.find('.ba-slider-options').val(options);
            jQ('.slider-button-border-width-number').val(inputValue);
        }, 12);
    jQ('.slider-button-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-button-border-width-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    options[37] = value;
    currentItem.find('.ba-slider-caption .slider-button a').css('border', options[37]+'px solid '+options[36]);
    options = options.join(';');
    jQ('.slider-button-border-width').val(value);
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-button-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slider-button-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    jQ('.margin-top-slider-button').val(options[46]);
    jQ('.margin-top-slider-button-number').val(options[46]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-slider-button').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slider-options', 46, inputValue, 'margin-top', '.ba-slider-caption .slider-button a', 'px');
            jQ('.margin-top-slider-button-number').val(inputValue);
        }, 12);
    jQ('.margin-top-slider-button').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-slider-button-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slider-options', 46, value, 'margin-top', '.ba-slider-caption .slider-button a', 'px');
    jQ('.margin-top-slider-button').val(value);
    addHistory();
});
jQ('.slider-button-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slider-button-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slider-options').val();
    options = options.split(';');
    jQ('.slider-button-padding-vertical').val(options[38]);
    jQ('.slider-button-padding-vertical-number').val(options[38]);
    jQ('.slider-button-padding-horizontal').val(options[39]);
    jQ('.slider-button-padding-horizontal-number').val(options[39]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.slider-button-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            var options = currentItem.find('.ba-slider-options').val();
            inputValue = input.val();
            options = paddingAction(currentItem.find('.ba-slider-caption .slider-button a'), options, inputValue, 38, 38, 39, 38, 39);
            currentItem.find('.ba-slider-options').val(options);
            jQ('.slider-button-padding-vertical-number').val(inputValue);
        }, 12);
    jQ('.slider-button-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-button-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slider-options').val();
    options = paddingAction(currentItem.find('.ba-slider-caption .slider-button a'), options, value, 38, 38, 39, 38, 39);
    jQ('.slider-button-padding-vertical').val(value);
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-button-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-slider-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-slider-caption .slider-button a'), options, inputValue, 39, 38, 39, 38, 39);
        currentItem.find('.ba-slider-options').val(options);
        jQ('.slider-button-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.slider-button-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slider-button-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slider-options').val();
    options = paddingAction(currentItem.find('.ba-slider-caption .slider-button a'), options, value, 39, 38, 39, 38, 39);
    jQ('.slider-button-padding-horizontal').val(value);
    currentItem.find('.ba-slider-options').val(options);
    addHistory();
});
jQ('.slider-button-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slider-button-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slider-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[40]);
    jQ('.slider-button-text-color-hover').minicolors('value', color[0]);
    jQ('.slider-button-text-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[41]);
    jQ('.slider-button-bg-color-hover').minicolors('value', color[0]);
    jQ('.slider-button-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[42]);
    jQ('.slider-button-border-color-hover').minicolors('value', color[0]);
    jQ('.slider-button-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.slider-button-text-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-slider-options', 40, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slider-button-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-slider-options', 41, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slider-button-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-slider-options', 42, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});