<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

class bagridModelPage extends JModelItem
{
    public function getTable($type = 'Bagrids', $prefix = 'BagridTable', $config = array()) 
    {
        return JTable::getInstance($type, $prefix, $config);
    }

    public function getHits()
    {
        $input = JFactory::getApplication()->input;
        $db = $this->getDbo();
        $table = $this->getTable();
        $id = $input->get('id');
        $table->load($id);
        $table->hit($id);
    }
    
    public function getItem($id = null)
    {
        $input = JFactory::getApplication()->input;
        $db = $this->getDbo();
        $table = $this->getTable();
        $id = $input->get('id');
        if (empty($id)) {
            $id = 0;
        }
        $query = $db->getQuery(true);
        $query->select('*')
            ->from('`#__bagrid_bagrids`')
            ->where('`id`=' .$id*1)
            ->where('`language` in (' . $db->quote(JFactory::getLanguage()->getTag()) . ',' . $db->quote('*') . ')');
        $db->setQuery($query);
        $this->_item = $db->loadObject();
        
        return $this->_item;
    }
}
