<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

$app = JFactory::getApplication();
$input = $app->input;
$id = $input->get('id');
$url = JUri::root(). 'index.php?option=com_bagrid&view=bagrid&id=' .$id;
$doc = JFactory::getDocument();
$doc->addScriptDeclaration("
    jQuery(document).ready(function(){
        window.parent.postMessage('preloaderReady', '*');
        jQuery('#login-modal form').on('submit', function(){
            window.parent.postMessage('preloader', '*');
        });
    }); ");
?>
<div class="ba-modal-backdrop"></div>
<div id='login-modal' class='ba-modal-sm in modal ba-modal-dialog'>
    <div class='modal-header'>
        <h3 class='ba-modal-header'><?php echo JText::_('LOGIN'); ?></h3>
    </div>
    <div class='modal-body'>
        <form action='<?php echo $url; ?>' method='post'>
            <label>
                <?php echo JText::_('LOGIN'); ?>
            </label>
            <input name='ba-username' type='text' ><br>
            <label>
                <?php echo JText::_('PASSWORD'); ?>
            </label>
            <input name='ba-password' type='password'><br>
            <button type='submit' name='Submit' class='ba-btn-primary'>
                <?php echo JText::_('LOGIN'); ?>
            </button>
        </form>
    </div>
    <div class='modal-footer'>
        <a href='#' class='ba-btn' onclick="return false">
            <?php echo JText::_('CLOSE'); ?>
        </a>
    </div>
</div>