<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

?>
<form method="post" id="ba-grid-form" enctype="multipart/form-data"
      action="<?php echo JUri::base() ?>index.php?option=com_bagrid&view=fonts&task=fonts.addFont">
    <div class="fonts-table">
        <div class="search-bar">
            <input type="text" id="filter_search" placeholder="<?php echo JText::_('SEARCH_FONTS'); ?>">
            <input type="button" class="edit-fonts ba-btn-primary" value="<?php echo JText::_('ADD_FONT'); ?>">
            <button class="ba-btn delete-font"><i class="icon-trash"></i></button>
            <div class="edit-container" style="display:none">
                <input type="text" name="new_font" class="new-font" placeholder="<?php echo JText::_('ENTER_FONT_NAME'); ?>">
                <input type="text" name="font_style" class="font-style" placeholder="<?php echo JText::_('ENTER_FONT_STYLE'); ?>">
                <input type="button"  class="add-font ba-btn" value="<?php echo JText::_('UPLOAD') ?>">
            </div>
        </div>
        <div class="bagrid-table">
            <table class="bagrid-list">
                <tbody>
                    <?php foreach($this->item as $fonts) {?>
                    <tr>
                        <th class="ba-font-item">
                            <input type="checkbox" value="<?php echo $fonts->id; ?>" class="ba-items" name="ba-items">
                        </th>
                        <th class="ba-font-title">
                            <a class="send-message"
                               style="font-family: '<?php echo str_replace('+', ' ', $fonts->font); ?>';
                                      font-weight: <?php echo $fonts->styles ?>;">
                                <?php echo str_replace('+', ' ', $fonts->font); ?>
                            </a>
                            <input class="options" type="hidden" value="<?php echo $fonts->font; ?>; <?php echo $fonts->styles ?>">
                        </th>
                        <td class="bagrid-style">
                            <?php echo $fonts->styles; ?>
                        </td>
                    </tr>  
                    <?php } ?>
                </tbody>
            </table>
        </div>
    </div>
</form>