<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

class bagridViewFonts extends JViewLegacy
{
    protected $item;
    
    public function display($tpl = null)
    {
        $app = JFactory::getApplication();
        $input = JFactory::getApplication()->input;
        $doc = JFactory::getDocument();
        $doc->setTitle('Gridbox Editor');
        $doc->addScript(JUri::root(true) . '/media/jui/js/jquery.min.js');
        $doc->addScript(JUri::root(true) . '/media/jui/js/bootstrap.min.js');
        $doc->addScript(JURI::root() . 'components/com_bagrid/assets/js/ba-fonts.js');
        $doc->addStyleSheet(JURI::root() . 'components/com_bagrid/assets/css/ba-style.css');
        $item = $this->get('Item');
        $this->item = $item;
        $array = array();
        if (!empty($this->item)) {
            $link = 'https://fonts.googleapis.com/css?family=';
            foreach ($this->item as $fonts) {
                if (!in_array($fonts->font, $array)) {
                    $link .= $fonts->font;
                    foreach ($this->item as $style) {
                        if ($fonts->font == $style->font) {
                            if (!in_array($fonts->font, $array)) {
                                $link .= ':'.$style->styles;
                                $array[] = $fonts->font;
                            } else {
                                $link .= ','.$style->styles;
                            }
                        }
                    }
                    $link .= '%7C';
                }
            }
            $pos = strripos($link, '%7C');
            $link = substr($link, 0, $pos);
            $link .= '&subset=latin,cyrillic,greek,latin-ext,greek-ext,vietnamese,cyrillic-ext';
            $doc->addStyleSheet($link);
        }
        parent::display($tpl);
    }
}