<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla view library
jimport('joomla.application.component.view');

class bagridViewUploader extends JViewLegacy
{
    protected $_folders;
    protected $_images;
    protected $_parent;
    
    public function display ($tpl = null)
	{
        $doc = JFactory::getDocument();
		$doc->setTitle('Gridbox Editor');
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode('<br />', $errors));
			return false;
		}
		$this->addToolBar();
        $this->_folders = $this->get('Folders');
        $this->_images = $this->get('Images');
        $this->_parent = $this->get('parent');
		parent::display($tpl);
	}
    
    protected function addToolBar()
	{
		$input = JFactory::getApplication()->input;
		$input->set('hidemainmenu', true);
    }
}