/**
* @package   BaGallery
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQuery(document).ready(function(){
    
    jQuery('#show-upload').on('click', function(){
        var target = jQuery('#upload-control');
        if (target.prop('style').cssText != '') {
            target.removeAttr('style');
            jQuery('#folder-control').hide();
        } else {
            target.attr('style', 'display:none');
        }
    });
    
    jQuery('.ba-images').each(function(){
        jQuery(this).find('td').each(function(){
            var value = jQuery(this).find('.select-item').val();
            if (!value) {
                jQuery(this).on('click', function(){
                    jQuery('.select-item').removeAttr('checked');
                    if (jQuery(this).parent().find('.select-item').prop('checked')) {
                        jQuery(this).parent().find('.select-item').removeAttr('checked');
                    } else {
                        jQuery(this).parent().find('.select-item').attr('checked', true);
                    }
                });
            }
        });
        jQuery(this).find('.ba-preview').on('click', function(){
            jQuery('.select-item').removeAttr('checked');
            if (jQuery(this).parent().find('.select-item').prop('checked')) {
                jQuery(this).parent().find('.select-item').removeAttr('checked');
            } else {
                jQuery(this).parent().find('.select-item').attr('checked', true);
            }
        });
        jQuery(this).find('.select-item').on('click', function(){
            jQuery('.select-item').not(this).removeAttr('checked');
        });
    });
    
    jQuery('#show-folder').on('click', function(){
        var target = jQuery('#folder-control');
        if (target.prop('style').cssText != '') {
            target.removeAttr('style');
            jQuery('#upload-control').hide();
        } else {
            target.attr('style', 'display:none');
        }
    });
    jQuery('#checkall').on('click', function(){
        if (jQuery(this).prop('checked')) {
            jQuery('.select-item').each(function(){
                jQuery(this).attr('checked', true);
            });
        } else {
            jQuery('.select-item').each(function(){
                jQuery(this).removeAttr('checked');
            });
        }
    });
    
    function sendMessage()
    {
        var msg = '';
        jQuery('.select-item').each(function(){
            if (jQuery(this).prop('checked')) {
                var item = {};
                var value = jQuery(this).parent().find('.ba-obj').val();
                if (value) {
                    value = value.split('|||');
                    for (var i = 0; i < value.length ; i++) {
                        if (value[i] != '') {
                            var val = value[i].split('-_-');
                            item[val[0]] = val[1];
                        }
                    }
                    msg = item.url;
                }
                return false;
            }
        });
        window.parent.postMessage(msg, "*");
    }
    
    jQuery('#ba-apply').on('click', function(){
        sendMessage();
    });
    
    jQuery('#ba-close').on('click', function(){
        var msg = '';
        window.parent.postMessage(msg, "*");
    });
    
}); 
