<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla controllerform library
jimport('joomla.application.component.controllerform');

class bagridControllerTheme extends JControllerForm
{
    public function getModel($name = '', $prefix = '', $config = array('ignore_request' => true))
	{
		return parent::getModel($name, $prefix, array('ignore_request' => false));
	}
    
    public function updateParams()
    {
        $input = JFactory::getApplication()->input;
        $model = $this->getModel();
        $table = $model->getTable();
        $old = $input->get('old_default');
        $default = $input->get('default_theme');
        $id = $input->get('ba_id');
        $title = $_POST['theme_title'];
        if ($old != $default) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);
            $fields = array(
                $db->quoteName('home') . ' = 0'
            );
            $conditions = array(
                $db->quoteName('home') . ' = 1',
                $db->quoteName('client_id') . ' = 0',
            );
            $query->update($db->quoteName('#__template_styles'))
                ->set($fields)
                ->where($conditions);
            $db->setQuery($query)
                ->execute();
        }
        $table->load($id);
        $table->bind(array('title' => $title, 'home' => $default*1));
        $table->store();
        echo new JResponseJson(true, $id);
        exit;
    }
}