CREATE TABLE IF NOT EXISTS `#__bagrid_categories` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `title` varchar(255) NOT NULL,
    `alias` varchar(255) NOT NULL,
    `published` tinyint(1) NOT NULL DEFAULT 1,
    `access` tinyint(1) NOT NULL DEFAULT 1,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__bagrid_tags` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `title` varchar(255) NOT NULL,
    `hits` int(11) NOT NULL DEFAULT 0,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__bagrid_tags_map` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `tag_id` int(11) NOT NULL,
    `page_id` int(11) NOT NULL,
    PRIMARY KEY  (`id`)
) DEFAULT CHARSET=utf8;

ALTER TABLE `#__bagrid_bagrids` ADD `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00';
ALTER TABLE `#__bagrid_bagrids` ADD `hits` int(11) NOT NULL DEFAULT 0;
ALTER TABLE `#__bagrid_bagrids` CHANGE `page_access` `page_access` int(11) NOT NULL DEFAULT '1';
UPDATE `#__bagrid_bagrids` SET `page_access` = 1;
UPDATE `#__bagrid_bagrids` SET `page_alias` = `id`;