<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

use Joomla\Registry\Registry;

class bagridTableBagrids extends JTable
{
    public function __construct(&$db)
    {
        parent::__construct('#__bagrid_bagrids', 'id', $db);
    }

    public function check()
    {
        jimport('joomla.filter.output');
        if (empty($this->page_alias)) {
            $this->page_alias = $this->title;
        }
        $pk = $this->id;
        if (empty($pk)) {
            $pk = 0;
        }
        $this->page_alias = JFilterOutput::stringURLSafe($this->page_alias);
        $db = JFactory::getDbo();
        $query = $db->getQuery(true);
        $query->select('id')
            ->from('#__bagrid_bagrids')
            ->where('`page_alias` = ' .$db->Quote($this->page_alias))
            ->where('`id` <> '.$pk);
        $db->setQuery($query);
        $id = $db->loadResult();
        if (!empty($id)) {
            return false;
        }
        return true;
    }
}
