<?php
/**
* @package   Bagrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

JHtml::_('behavior.tooltip');
$sortFields = $this->getSortFields();
$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn  = $this->escape($this->state->get('list.direction'));
$user = JFactory::getUser();
$checkUpdate = bagridHelper::checkUpdate($this->about->version);
$language = JFactory::getLanguage();
$language->load('com_menus', JPATH_ADMINISTRATOR);
?>
<link rel="stylesheet" href="components/com_bagrid/assets/css/ba-admin.css" type="text/css"/>
<script src="components/com_bagrid/assets/js/ba-admin.js" type="text/javascript"></script>
<script type="text/javascript">
    Joomla.orderTable = function() {
        table = document.getElementById("sortTable");
        direction = document.getElementById("directionTable");
        order = table.options[table.selectedIndex].value;
        if (order != '<?php echo $listOrder; ?>') {
            dirn = 'asc';
        } else {
            dirn = direction.options[direction.selectedIndex].value;
        }
        Joomla.tableOrdering(order, dirn, '');
    }
    var str = "<div class='btn-wrapper' id='toolbar-about'>";
    str += "<button value='About' class='btn btn-small'><span class='icon-bookmark'>";
    str += "</span><?php echo JText::_('ABOUT') ?></button></div>";
    jQuery('#toolbar').append(str);
    var name = jQuery('#toolbar-new button').text();
    var link = "<a class='btn btn-small btn-success' target='_blank' href='"
    link += "<?php echo $url = JUri::root(). 'index.php?option=com_bagrid&view=editor&tmpl=component&id='; ?>'>";
    link += "<span class='icon-new icon-white'></span>"+name+"</a>";
    jQuery('#toolbar-new').html(link);
</script>
<div id="export-dialog" class="ba-modal-sm modal hide" style="display:none">
    <div class="modal-header">
            <a class="close" data-dismiss="modal">x</a>
            <h3 class="ba-modal-header"><?php echo JText::_('EXPORT'); ?></h3>
        </div>
    <div class="modal-body">
        <div>
            <ul>
                <li>
                    <label>
                    	<?php echo JText::_('PAGES'); ?>
                	</label>
                	<input type="checkbox" checked disabled>
                </li>
                <li>
                    <label>
                    	<?php echo JText::_('THEME'); ?>
                    </label>
                    <input type="checkbox" checked disabled>
                </li>
                <li>
                    <label>
                    	<?php echo $language->_('COM_MENUS'); ?>
                    </label>
                    <input type="checkbox" class="menu-export">
                </li>
            </ul>
        </div>
    </div>
    <div class="modal-footer">
        <a href="#" class="ba-btn-primary apply-export"><?php echo JText::_('APPLY') ?></a>
        <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
    </div>
</div>
<form action="<?php echo JRoute::_('index.php?option=com_bagrid'); ?>" method="post" name="adminForm" id="adminForm">
    <div id="about-dialog" class="ba-modal-md modal hide" style="display:none">
        <div class="modal-header">
            <a class="close" data-dismiss="modal">x</a>
            <h3><?php echo JText::_('ABOUT') ?></h3>
        </div>
        <div class="modal-body">
            <div id="form-about">
                <label><?php echo JText::_('WEBSITE') ?>:</label>
                <a target="_blank" href="<?php echo $this->about->authorUrl; ?>">www.balbooa.com</a><br>
                <label><?php echo JText::_('LICENSE') ?>:</label>
                GNU Public License version 2.0. <br>
                <label><?php echo JText::_('COPYRIGHT') ?>:</label>
                © 2016 Balbooa All Rights Reserved. <br>
                <label><?php echo JText::_('EMAIL') ?>:</label>
                <?php echo $this->about->authorEmail; ?><br>
                <label><?php echo JText::_('VERSION') ?>:</label>
                <span class="update"> <?php echo $this->about->version; ?>
                </span>
                <br>
            </div>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="uploader-modal" class="modal ba-modal-dialog hide" style="display:none">
        <div class="modal-header">
            <a class="close" data-dismiss="modal">x</a>
            <h3 class="ba-modal-header"><?php echo JText::_('SELECT_MEDIA'); ?></h3>
        </div>
        <div class="modal-body">
            <iframe src="<?php echo jUri::base(). 'index.php?option=com_bagrid&view=uploader&tmpl=component'; ?>"
                    width="100%" height="500"></iframe>
        </div>
    </div>
    <div id="error-dialog" class="ba-modal-sm modal hide" style="display:none">
        <div class="modal-body">
            <p class="not-selected"><?php echo JText::_('PAGE_NOT_SELECTED'); ?></p>
            <p class="many-selected"><?php echo JText::_('TOO_MANY_SELECTED'); ?></p>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="not-default-dialog" class="ba-modal-sm modal hide" style="display:none">
        <div class="modal-body">
            <p><?php echo JText::_('GRIDBOXCORE_NOT_DEFAULT'); ?></p>
            <input type="hidden" id="default-template" value="<?php echo $this->template; ?>">
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div id="settings-dialog" class="ba-modal-md modal hide" style="display:none">
        <div class="modal-header">
            <h3><?php echo JText::_('PAGE_SETTINGS') ?></h3>
        </div>
        <div class="modal-body">
            <ul class="nav nav-tabs">
                <li class="active"><a href="#general-options" data-toggle="tab"><?php echo JText::_('GENERAL_OPTIONS'); ?></a></li>
                <li><a href="#seo-options" data-toggle="tab"><?php echo JText::_('SEO_OPTIONS'); ?></a></li>
                <li><a href="#intro-options" data-toggle="tab"><?php echo JText::_('INTRO_OPTIONS'); ?></a></li>
            </ul>
            <div class="tab-content">
                <div id="general-options" class="row-fluid tab-pane active">
                    <label>
                        <?php echo JText::_('PAGE_NAME'); ?>
                    </label>
                    <input type="hidden" name="ba_id" class="page-id">
                    <input type="text" name="page_title" class="page-title">
                    <label>
                        <?php echo JText::_('ALIAS'); ?>
                    </label>
                    <input type="text" name="page_alias" class="page-alias">
                    <label>
                        <?php echo JText::_('CATEGORY'); ?>
                    </label>
                    <select name="page_category" class="page-category">
                        <option value=""><?php echo JText::_('UNCATEGORISED'); ?></option>
                        <?php foreach ($this->categories as $key => $category) { ?>
                        <option value="<?php echo $key; ?>"><?php echo $category; ?></option>
                        <?php } ?>
                    </select>
                    <div class="ba-tags">
                        <label>
                            <?php echo JText::_('TAGS'); ?>
                        </label>
                        <div class="meta-tags">
                            <select name="meta_tags[]" class="meta_tags" multiple></select>
                            <ul class="picked-tags">
                                <li class="search-tag">
                                    <span contenteditable="true"></span>
                                </li>
                            </ul>
                            <ul class="all-tags">
                                <?php foreach ($this->tags as $tag) {
                                    echo '<li data-id="'.$tag->id.'">'.$tag->title.'</li>';
                                } ?>
                            </ul>
                        </div>
                    </div>    
                    <label>
                        <?php echo JText::_('ACCESS'); ?>
                    </label>
                    <?php echo $this->form->getInput('access'); ?>
                    <label>
                        <?php echo JText::_('LANGUAGE'); ?>
                    </label>
                    <?php echo $this->form->getInput('language'); ?>
                    <label>
                        <?php echo JText::_('PUBLISHED_ON'); ?>
                    </label>
                    <?php echo $this->form->getInput('published_on'); ?>
                    <label>
                        <?php echo JText::_('THEME'); ?>
                    </label>
                    <select class="theme-list" name="theme_list">
                        <?php foreach ($this->themes as $theme) { ?>
                        <option value="<?php echo $theme->id; ?>"><?php echo $theme->title; ?></option>
                        <?php } ?>
                    </select>
                    <div style="display: none;">
                		<label>
	                        <?php echo JText::_('INTRO_IMAGE'); ?>
	                    </label>
	                    <input type="button" value="<?php echo JText::_('SELECT'); ?>" class="ba-btn select-intro-image">
	                    <input type="hidden" class="intro-image" name="intro_image">
	                    <a type="button" class="remove-intro-image icon-remove ba-btn"></a>
	                    <label>
	                        <?php echo JText::_('IMAGE_ALT'); ?>
	                    </label>
	                    <input type="text" name="image_alt" class="image-alt">
	                    <label>
	                        <?php echo JText::_('INTRO_TEXT'); ?>
	                    </label>
	                    <textarea name="intro_text" class="intro-text"></textarea>
                    </div>
                </div>
                <div id="seo-options" class="row-fluid tab-pane">
                    <label>
                        <?php echo JText::_('PAGE_TITLE'); ?>
                    </label>
                    <input type="text" name="page_meta_title" class="page-meta-title">
                    <label>
                        <?php echo JText::_('PAGE_META_DESCRIPTION'); ?>
                    </label>
                    <textarea name="page_meta_description" class="page-meta-description"></textarea>
                    <label>
                        <?php echo JText::_('PAGE_META_KEYWORDS'); ?>
                    </label>
                    <textarea name="page_meta_keywords" class="page-meta-keywords"></textarea>
                </div>
            </div>
        </div>
        <div class="modal-footer">
            <a href="#" class="ba-btn-primary settings-apply" ><?php echo JText::_('APPLY') ?></a>
            <a href="#" class="ba-btn" data-dismiss="modal"><?php echo JText::_('CLOSE') ?></a>
        </div>
    </div>
    <div class="row-fluid">
        <div class="span2" id="j-sidebar-container">
            <?php echo $this->sidebar; ?>
        </div>
        <div class="span10" id="j-main-container">
            <div id="filter-bar">
                <label for="filter_search" class="element-invisible">
                    <?php echo JText::_('SEARCH_FORM?') ?>
                </label>
                <input type="text" name="filter_search" id="filter_search"
                       value="<?php echo $this->escape($this->state->get('filter.search')); ?>"
                       placeholder="<?php echo JText::_('SEARCH') ?>">
                <button type="submit" class="ba-btn">
                    <i class="icon-search"></i>
                </button>
                <button type="button" class="ba-btn" onclick="document.id('filter_search').value = ''; this.form.submit();">
                    <i class="icon-remove"></i>
                </button>
                <div class="btn-group pull-right hidden-phone">
                    <label for="limit" class="element-invisible"><?php echo JText::_('JFIELD_PLG_SEARCH_SEARCHLIMIT_DESC');?></label>
                    <?php echo $this->pagination->getLimitBox(); ?>
                </div>
                <div class="btn-group pull-right hidden-phone">
                    <label for="directionTable" class="element-invisible"><?php echo JText::_('JFIELD_ORDERING_DESC');?></label>
                    <select name="directionTable" id="directionTable" class="input-medium" onchange="Joomla.orderTable()">
                        <option value=""><?php echo JText::_('JFIELD_ORDERING_DESC');?></option>
                        <option value="asc" <?php if ($listDirn == 'asc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_ASCENDING');?></option>
                        <option value="desc" <?php if ($listDirn == 'desc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_DESCENDING');?></option>
                    </select>
                </div>
                <div class="btn-group pull-right">
                    <label for="sortTable" class="element-invisible"><?php echo JText::_('JGLOBAL_SORT_BY');?></label>
                    <select name="sortTable" id="sortTable" class="input-medium" onchange="Joomla.orderTable()">
                        <option value=""><?php echo JText::_('JGLOBAL_SORT_BY');?></option>
                        <?php echo JHtml::_('select.options', $sortFields, 'value', 'text', $listOrder);?>
                    </select>
                </div>
                <div class="btn-group pull-right hidden-phone">
                    <select name="filter_state" onchange="this.form.submit()">
                        <option value=""><?php echo JText::_('SELECT_STATUS');?></option>
                        <?php echo JHtml::_('select.options', JHtml::_('bagridhtml.filters.stateOptions'),
                                            'value', 'text', $this->state->get('filter.state'), true);?>
                    </select>
                </div>
                <div class="btn-group pull-right">
                    <input type="button" class="ba-btn page-settings" value="<?php echo JText::_('SETTINGS'); ?>">
                </div>
                <div class="btn-group pull-right">
                    <input type="button" class="ba-btn page-export" value="<?php echo JText::_('EXPORT'); ?>">
                </div>
            </div>
            <div class="clearfix"> </div>
            <div>
                <table class="table table-striped">
                    <thead>
                        <tr>
                            <th width="1%">
                                <input type="checkbox" name="checkall-toggle" value=""
                                       title="<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
                            </th>
                            <th width="1%" class="nowrap center">
                                <?php echo JText::_('JSTATUS'); ?>
                            </th>
                            <th>
                                <?php echo JText::_('PAGES'); ?>
                            </th>
                            <th>
                                <?php echo JText::_('CATEGORY'); ?>
                            </th>
                            <th>
                                <?php echo JText::_('ACCESS'); ?>
                            </th>
                            <th>
                                <?php echo JText::_('THEME'); ?>
                            </th>
                            <th width="1%">
                                <?php echo JText::_('ID'); ?>
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                       <?php foreach ($this->items as $i => $item) { 
                   			    $str = json_encode($item);
                                $canChange = $user->authorise('core.edit.state', 'com_bagrid'); ?>
                        <tr>
                            <td>
                                <?php echo JHtml::_('grid.id', $i, $item->id); ?>
                                <input type="hidden"
                                       value='<?php echo htmlspecialchars($str, ENT_QUOTES); ?>'>
                            </td>
                            <td class="center">
                                <?php echo JHtml::_('jgrid.published', $item->published, $i, 'bagrids.', $canChange); ?>
                            </td>
                            <td class="title-cell">
                                <a target="_blank"
                                   href="<?php echo JRoute::_('index.php?option=com_bagrid&task=bagrid.edit&id='. $item->id); ?>">
                                    <?php echo $item->title; ?>
                                </a>
                            </td>
                            <td class="category-cell">
                                <?php
                                if (empty($item->page_category)) {
                                    echo JText::_('UNCATEGORISED');
                                } else {
                                    echo $this->categories[$item->page_category];
                                } ?>
                            </td>
                            <td class="access-cell">
                                <?php
                                    echo $this->access[$item->page_access];
                                ?>
                            </td>
                            <td class="page-theme" data-theme="<?php echo $item->theme; ?>">
                                <?php echo $item->themeName; ?>
                            </td>
                            <td>
                                <?php echo $item->id; ?>
                            </td>
                        </tr>
                        <?php } ?>
                    </tbody>
                    <tfoot>
                        <tr>
                            <td colspan="5">
                                <?php echo $this->pagination->getListFooter(); ?>
                            </td>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <div>
                <input type="hidden" name="task" value="" />
                <input type="hidden" name="boxchecked" value="0" />
                <input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
                <input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
                <?php echo JHtml::_('form.token'); ?>
            </div>
        </div>
    </div>
</form>