<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla view library
jimport('joomla.application.component.view');

class bagridViewUploader extends JViewLegacy
{
    protected $_folders;
    protected $_images;
    protected $_parent;
    
	/**
	 * display method
	 * @return void
	 */
	public function display ($tpl = null)
	{
		
		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode('<br />', $errors));
			return false;
		}
		
		// Set the toolbar
		$this->addToolBar();
        $this->_folders = $this->get('Folders');
        $this->_images = $this->get('Images');
        $this->_parent = $this->get('parent');
		// Display the template
		parent::display($tpl);
	}

	/**
	 * Setting the toolbar
	 */
	protected function addToolBar()
	{
		$input = JFactory::getApplication()->input;
		$input->set('hidemainmenu', true);
		
	}
}