<?php
/**
* @package   BaForms
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

// import Joomla controllerform library
jimport('joomla.application.component.controllerform');


class BagridControllerFonts extends JControllerForm
{
    public function getModel($name = '', $prefix = '', $config = array('ignore_request' => true))
	{
		return parent::getModel($name, $prefix, array('ignore_request' => false));
	}
    
    public function addFont()
    {
        $redirect = JUri::base(). 'index.php?option=com_bagrid&view=fonts&tmpl=component';
        $model = $this->getModel();
        if ($model->addFont()) {
            $this->setRedirect($redirect, JText::_('FONT_IS_ADDED'), 'success');
        } else {
            $this->setRedirect($redirect, JText::_('UNABLE_TO_UPLOAD_FONT'), 'error');
        }
    }
    
    public function delete()
    {
        $redirect = JUri::base(). 'index.php?option=com_bagrid&view=fonts&tmpl=component';
        $model = $this->getModel();
        if ($model->delete()) {
            $this->setRedirect($redirect, JText::_('COM_BAGRID_N_ITEMS_DELETED'), 'success');
        }
    }
}