/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.button-link').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.button-link-options').addClass('ba-fade');
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    jQ('.button-icon-position option').each(function(){
        if (jQ(this).val() == options[25]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (!options[26]) {
        options[26] = 24;
    }
    jQ('.button-icon-size').val(options[26]);
    jQ('.button-icon-size-number').val(options[26]);
    jQ('.ba-button-label').val(options[21]);
    jQ('.ba-button-link').val(options[0]);
    jQ('.button-target option').each(function(){
        if (jQ(this).val() == options[1]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-link').show().addClass('ba-active-options');
});
jQ('.button-select-icon').on('click', function(){
    uploadMode = 'buttonIconUpload';
    jQ('#icons-upload-modal').modal();
});
jQ('.button-icon-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-button-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[26] = inputValue;
        options = options.join(';');
        currentItem.find('.ba-buttons i').css('font-size', inputValue+'px')
        .parent().css('line-height', inputValue+'px');
        currentItem.find('.ba-button-options').val(options);
        jQ('.button-icon-size-number').val(inputValue);
    }, 12);
    jQ('.button-icon-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.button-icon-size-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    options[26] = value;
    options = options.join(';');
    currentItem.find('.ba-buttons i').css('font-size', value+'px')
    .parent().css('line-height', value+'px');
    currentItem.find('.ba-button-options').val(options);
    jQ('.button-icon-size').val(value);
    addHistory();
});
jQ('.clear-button-icon').on('click', function(){
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    options[24] = '';
    options = options.join(';');
    currentItem.find('.ba-buttons a').css('line-height', '')
    currentItem.find('.ba-buttons i').remove();
    currentItem.find('.ba-buttons').removeClass(options[25]);
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});
jQ('.button-icon-position').on('change', function(){
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    currentItem.find('.ba-buttons').removeClass(options[25]);
    options[25] = jQ(this).val();
    if (options[25] == 'after') {
        currentItem.find('.ba-buttons').addClass(options[25]);
    }
    options = options.join(';');
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});
jQ('.ba-button-label').on('keyup', function(){
    var label = jQ(this).val(),
        a = currentItem.find('.ba-buttons a'),
        childNodes = a[0].childNodes;
    label = label.replace(new RegExp(";",'g'), '');
    setValue('.ba-button-options', 21, label);
    for (var i = 0; i < childNodes.length; i++) {
        if (childNodes[i].nodeType == 3) {
            a[0].removeChild(childNodes[i]);
            break;
        }
    }
    if (label) {
        if (currentItem.find('.ba-buttons a > span').length == 0) {
            a.append('<span></span>');
        }
        currentItem.find('.ba-buttons a > span').text(label);
    } else {
        currentItem.find('.ba-buttons a > span').remove();
    }    
    addHistory();
});
jQ('.ba-button-link').on('keyup', function(){
    var link = jQ(this).val();
    setValue('.ba-button-options', 0, link);
    currentItem.find('.ba-buttons a').attr('href', link);
    addHistory();
});
jQ('.button-target').on('change', function(){
    var target = jQ(this).val();
    setValue('.ba-button-options', 1, target);
    currentItem.find('.ba-buttons a').attr('target', target);
    addHistory();
});
jQ('.button-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.button-style-options').addClass('ba-fade');
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    jQ('.button-font-family').val(options[22].replace(new RegExp('\\+','g'), ' ')+' '+options[7]);
    jQ('.button-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).attr('checked', true);
            jQ(this).closest('.button-alignment').addClass('active');
        } else {
            jQ(this).removeAttr('checked');
            jQ(this).closest('.button-alignment').removeClass('active');
        }
    });
    if (!options[27]) {
        options[27] = 0;
    }
    jQ('.button-letter-spacing').val(options[27]);
    jQ('.button-letter-spacing-number').val(options[27]);
    var color = rgb2hex(options[4]);
    jQ('.button-bg-color').minicolors('value', color[0]);
    jQ('.button-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[5]);
    jQ('.button-text-color').minicolors('value', color[0]);
    jQ('.button-text-color').minicolors('opacity', color[1]);
    jQ('.button-font-size').val(options[6]);
    jQ('.button-font-size-number').val(options[6]);
    if (options[23] == 'underline') {
        jQ('.button-font-style[value=underline]').closest('.ba-btn').addClass('active');
        jQ('.button-font-style[value=underline]').attr('checked', true);
    } else {
        jQ('.button-font-style[value=underline]').closest('.ba-btn').removeClass('active');
        jQ('.button-font-style[value=underline]').removeAttr('checked', true);
    }
    if (options[8] == 'uppercase') {
        jQ('.button-font-style[value=uppercase]').closest('.ba-btn').addClass('active');
        jQ('.button-font-style[value=uppercase]').attr('checked', true);
    } else {
        jQ('.button-font-style[value=uppercase]').closest('.ba-btn').removeClass('active');
        jQ('.button-font-style[value=uppercase]').removeAttr('checked', true);
    }
    if (options[9] == 'italic') {
        jQ('.button-font-style[value=italic]').closest('.ba-btn').addClass('active');
        jQ('.button-font-style[value=italic]').attr('checked', true);
    } else {
        jQ('.button-font-style[value=italic]').closest('.ba-btn').removeClass('active');
        jQ('.button-font-style[value=italic]').removeAttr('checked', true);
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-button').show().addClass('ba-active-options');
});
jQ('.button-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-button-options', 27, inputValue, 'letter-spacing', '.ba-buttons a', 'px');
            jQ('.button-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.button-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.button-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-button-options', 27, value, 'letter-spacing', '.ba-buttons a', 'px');
    jQ('.button-letter-spacing').val(value);
    addHistory();
});
jQ('.select-button-family').on('click', function(){
    uploadMode = 'buttonFontUpload';
    jQ('#fonts-modal').modal();
});
jQ('.button-align').on('click', function(){
    jQ('.button-alignment').removeClass('active');
    jQ(this).closest('.button-alignment').addClass('active');
    setValue('.ba-button-options', 3, jQ(this).val(), 'text-align', currentItem, '');
    addHistory();
});
jQ('.button-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != ''){
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-button-options', 4, hex, 'background', '.ba-buttons a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.button-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-button-options', 5, hex, 'color', '.ba-buttons a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.button-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-button-options', 6, inputValue, 'font-size', '.ba-buttons a', 'px');
            jQ('.button-font-size-number').val(inputValue);
        }, 12);
    jQ('.button-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.button-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-button-options', 6, value, 'font-size', '.ba-buttons a', 'px');
    jQ('.button-font-size').val(value);
    addHistory();
});
jQ('.button-font-style').on('change', function(){
    var value = jQ(this).val();
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (jQ(this).prop('checked')) {
            jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-buttons a').css('text-decoration', value);
            options[23] = value;
        } else {
             jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-buttons a').css('text-decoration', 'none');
            options[23] = 'none';
        }
    } else if (value == 'uppercase') {
        if (jQ(this).prop('checked')) {
             jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-buttons a').css('text-transform', value);
            options[8] = value;
        } else {
             jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-buttons a').css('text-transform', 'none');
            options[8] = 'none';
        }
    } else {
        if (jQ(this).prop('checked')) {
             jQ(this).closest('.ba-btn').addClass('active');
            currentItem.find('.ba-buttons a').css('font-style', value);
            options[9] = value;
        } else {
             jQ(this).closest('.ba-btn').removeClass('active');
            currentItem.find('.ba-buttons a').css('font-style', 'normal');
            options[9] = 'normal';
        }
    }
    options = options.join(';');
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});
jQ('.button-border').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.button-border-options').addClass('ba-fade');
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    jQ('.button-border-radius').val(options[10]);
    jQ('.button-border-radius-number').val(options[10]);
    var color = rgb2hex(options[11]);
    jQ('.button-border-color').minicolors('value', color[0]);
    jQ('.button-border-color').minicolors('opacity', color[1]);
    jQ('.button-border-width').val(options[12]);
    jQ('.button-border-width-number').val(options[12]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
});
jQ('.button-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-button-options', 10, inputValue, 'border-radius', '.ba-buttons a', 'px');
            jQ('.button-border-radius-number').val(inputValue);
        }, 12);
    jQ('.button-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.button-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-button-options', 10, value, 'border-radius', '.ba-buttons a', 'px');
    jQ('.button-border-radius').val(value);
    addHistory();
});
jQ('.button-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-button-options').val();
            options = options.split(';');
            options[11] = jQ(this).minicolors('rgbaString');
            currentItem.find('.ba-buttons a').css('border', options[12]+'px solid '+options[11]);
            options = options.join(';')
            currentItem.find('.ba-button-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.button-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-button-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[12] = inputValue;
            currentItem.find('.ba-buttons a').css('border', options[12]+'px solid '+options[11]);
            options = options.join(';');
            currentItem.find('.ba-button-options').val(options);
            jQ('.button-border-width-number').val(inputValue);
        }, 12);
    jQ('.button-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.button-border-width-number').on('click keyup', function(){
    var value = jQ(this).val();
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    options[12] = value;
    currentItem.find('.ba-buttons a').css('border', options[12]+'px solid '+options[11]);
    options = options.join(';');
    jQ('.button-border-width').val(value);
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});
jQ('.button-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.button-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    var color = rgb2hex(options[13]);
    jQ('.button-text-color-hover').minicolors('value', color[0]);
    jQ('.button-text-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[14]);
    jQ('.button-bg-color-hover').minicolors('value', color[0]);
    jQ('.button-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[15]);
    jQ('.button-border-color-hover').minicolors('value', color[0]);
    jQ('.button-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.button-text-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-button-options', 13, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.button-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-button-options', 14, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.button-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-button-options', 15, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.button-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.button-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    jQ('.padding-vertical').val(options[16]);
    jQ('.padding-vertical-number').val(options[16]);
    jQ('.padding-horizontal').val(options[17]);
    jQ('.padding-horizontal-number').val(options[17]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-button-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-buttons a'), options, inputValue, 16, 16, 17, 16, 17);
        currentItem.find('.ba-button-options').val(options);
        jQ('.padding-vertical-number').val(inputValue);
    }, 12);
    jQ('.padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-button-options').val();
    options = paddingAction(currentItem.find('.ba-buttons a'), options, value, 16, 16, 17, 16, 17);
    jQ('.padding-vertical').val(value);
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});
jQ('.padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-button-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-buttons a'), options, inputValue, 17, 16, 17, 16, 17);
        currentItem.find('.ba-button-options').val(options);
        jQ('.padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-button-options').val();
    options = paddingAction(currentItem.find('.ba-buttons a'), options, value, 17, 16, 17, 16, 17);
    jQ('.padding-horizontal').val(value);
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});
jQ('.button-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.button-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    jQ('.margin-top-button').val(options[18]);
    jQ('.margin-top-button-number').val(options[18]);
    jQ('.margin-bottom-button').val(options[19]);
    jQ('.margin-bottom-button-number').val(options[19]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-button').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-button-options').val();
        inputValue = input.val();
        options = marginAction(currentItem.find('.ba-buttons'), options, inputValue, 18, 18, 19);
        currentItem.find('.ba-button-options').val(options);
        jQ('.margin-top-button-number').val(inputValue);
    }, 12);
    jQ('.margin-top-button').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-button-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-button-options').val();
    options = marginAction(currentItem.find('.ba-buttons'), options, value, 18, 18, 19);
    jQ('.margin-top-button').val(value);
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});
jQ('.margin-bottom-button').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-button-options').val();
        inputValue = input.val();
        options = marginAction(currentItem.find('.ba-buttons'), options, inputValue, 19, 18, 19);
        currentItem.find('.ba-button-options').val(options);
        jQ('.margin-bottom-button-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-button').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-button-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-button-options').val();
    options = marginAction(currentItem.find('.ba-buttons'), options, value, 19, 18, 19);
    jQ('.margin-bottom-button').val(value);
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});
jQ('.button-css').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.button-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-button-options').val();
    options = options.split(';');
    jQ('.custom-suffix-button').val(options[20]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-button').on('keyup', function(){
    var value = jQ(this).val(),
        options = customSuffix(currentItem.find('.ba-buttons'), currentItem.find('.ba-button-options').val(), value, 20);
    currentItem.find('.ba-button-options').val(options);
    addHistory();
});