/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.counter-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.counter-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-counter-options').val();
    options = options.split(';');
    jQ('.counter-target-number').val(options[3]);
    jQ('.counter-animation-speed').val(options[4]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.counter-target-number').on('keyup', function(){
    var value = jQ(this).val();
    setValue('.ba-counter-options', 3, value);
    currentItem.find('.counter.number').text(value);
    initCounter(currentItem);
});
jQ('.counter-animation-speed').on('keyup', function(){
    var value = jQ(this).val();
    setValue('.ba-counter-options', 4, value);
    initCounter(currentItem);
});
jQ('.counter-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.counter-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-counter').show().addClass('ba-active-options');
});
jQ('.nav-style-counter').on('click', function(){
    jQ('.ba-gb-options.ba-fade').removeClass('ba-fade');
    jQ('.counter-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-counter ~ a').hide()
    jQ('.nav-style-counter').show().addClass('ba-active-options');
});
jQ('.counter-numbers').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.counter-numbers-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-counter').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-counter-options').val(),
        color;
    options = options.split(';');
    if (!options[15]) {
        options[15] = 0;
    }
    jQ('.counter-letter-spacing').val(options[15]);
    jQ('.counter-letter-spacing-number').val(options[15]);
    jQ('.counter-align').each(function(){
        if (jQ(this).val() == options[5]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.counter-font-family').val(options[6].replace(new RegExp('\\+','g'), ' ')+' '+options[7]);
    color = rgb2hex(options[8]);
    jQ('.counter-text-color').minicolors('value', color[0]);
    jQ('.counter-text-color').minicolors('opacity', color[1]);
    jQ('.counter-font-size').val(options[9]);
    jQ('.counter-font-size-number').val(options[9]);
});
jQ('.counter-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-counter-options', 5, jQ(this).val(), 'text-align', '.ba-counter', '');
});
jQ('.select-counter-family').on('click', function(){
    uploadMode = 'counterFamily';
    jQ('#fonts-modal').modal();
});
jQ('.counter-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-counter-options', 15, inputValue, 'letter-spacing', '.counter.number', 'px');
            jQ('.counter-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.counter-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.counter-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-counter-options', 15, value, 'letter-spacing', '.counter.number', 'px');
    jQ('.counter-letter-spacing').val(value);
    addHistory();
});
jQ('.counter-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString')
            setValue('.ba-counter-options', 8, hex, 'color', '.counter.number', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.counter-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-counter-options', 9 , inputValue, 'font-size', '.counter.number', 'px');
        jQ('.counter-font-size-number').val(inputValue);
    }, 12);
    jQ('.counter-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.counter-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-counter-options', 9 , value, 'font-size', '.counter.number', 'px');
    jQ('.counter-font-size').val(value);
    addHistory();
});
jQ('.counter-background').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.counter-background-options').addClass('ba-fade');
    var options = currentItem.find('.ba-counter-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[10]);
    jQ('.counter-padding').val(options[13]);
    jQ('.counter-padding-number').val(options[13]);
    jQ('.counter-width').val(options[14]);
    jQ('.counter-width-number').val(options[14]);
    jQ('.counter-bg-color').minicolors('value', color[0]);
    jQ('.counter-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[11]);
    jQ('.counter-border-color').minicolors('value', color[0]);
    jQ('.counter-border-color').minicolors('opacity', color[1]);
    jQ('.counter-border-radius').val(options[12]);
    jQ('.counter-border-radius-number').val(options[12]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-background').show().addClass('ba-active-options');
});
jQ('.counter-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-counter-options', 10, hex, 'background-color', '.counter.number', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.counter-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-counter-options', 11 , hex);
            currentItem.find('.counter.number').css('border', '1px solid '+hex);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.counter-padding').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-counter-options', 13 , inputValue, 'padding', '.counter.number', 'px');
        jQ('.counter-padding-number').val(inputValue);
    }, 12);
    jQ('.counter-padding').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.counter-padding-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-counter-options', 13 , value, 'padding', '.counter.number', 'px');
    jQ('.counter-padding').val(value);
    addHistory();
});
jQ('.counter-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-counter-options', 14 , inputValue);
        currentItem.find('.counter.number').css({
            'width' : inputValue+'px',
            'line-height' : inputValue+'px'
        });
        jQ('.counter-width-number').val(inputValue);
    }, 12);
    jQ('.counter-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.counter-width-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-counter-options', 14 , value);
    currentItem.find('.counter.number').css({
        'width' : value+'px',
        'line-height' : value+'px'
    });
    jQ('.counter-width').val(value);
    addHistory();
});
jQ('.counter-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-counter-options', 12 , inputValue, 'border-radius', '.counter.number', 'px');
        jQ('.counter-border-radius-number').val(inputValue);
    }, 12);
    jQ('.counter-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.counter-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-counter-options', 12 , value, 'border-radius', '.counter.number', 'px');
    jQ('.counter-border-radius').val(value);
    addHistory();
});
jQ('.counter-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.counter-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-counter-options').val();
    options = options.split(';');
    jQ('.margin-top-counter').val(options[0]);
    jQ('.margin-top-counter-number').val(options[0]);
    jQ('.margin-bottom-counter').val(options[1]);
    jQ('.margin-bottom-counter-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-counter').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-counter-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-counter-options').val(options);
        jQ('.margin-top-counter-number').val(inputValue);
    }, 12);
    jQ('.margin-top-counter').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-counter').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-counter-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-counter-options').val(options);
        jQ('.margin-bottom-counter-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-counter').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-counter-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-counter-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-counter-options').val(options);
    jQ('.margin-top-counter').val(value);
    addHistory();
});
jQ('.margin-bottom-counter-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-counter-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-counter-options').val(options);
    jQ('.margin-bottom-counter').val(value);
    addHistory();
});
jQ('.counter-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.counter-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-counter-options').val();
    options = options.split(';');
    jQ('.custom-suffix-counter').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-counter').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-counter-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-counter-options').val(options);
    addHistory();
});