/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.disqus-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.disqus-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-disqus-options').val();
    options = options.split(';');
    jQ('.disqus-subdomain').val(options[3]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.disqus-subdomain').on('keyup', function(){
    setValue('.ba-disqus-options', 3, jQ(this).val());
    clearTimeout(delay);
    delay = setTimeout(function(){
        initDisqus();
    }, 500);
});
jQ('.disqus-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.disqus-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-disqus-options').val();
    options = options.split(';');
    jQ('.margin-top-disqus').val(options[0]);
    jQ('.margin-top-disqus-number').val(options[0]);
    jQ('.margin-bottom-disqus').val(options[1]);
    jQ('.margin-bottom-disqus-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-disqus').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-disqus-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-disqus-options').val(options);
        jQ('.margin-top-disqus-number').val(inputValue);
    }, 12);
    jQ('.margin-top-disqus').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-disqus').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-disqus-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-disqus-options').val(options);
        jQ('.margin-bottom-disqus-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-disqus').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-disqus-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-disqus-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-disqus-options').val(options);
    jQ('.margin-top-disqus').val(value);
    addHistory();
});
jQ('.margin-bottom-disqus-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-disqus-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-disqus-options').val(options);
    jQ('.margin-bottom-disqus').val(value);
    addHistory();
});
jQ('.disqus-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.disqus-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-disqus-options').val();
    options = options.split(';');
    jQ('.custom-suffix-disqus').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-disqus').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-disqus-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-disqus-options').val(options);
    addHistory();
});