/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.gallery-margin-button').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.gallery-margin-options').addClass('ba-fade');
    var options = currentItem.find('.bagallery-options').val();
    options = options.split(';');
    jQ('.margin-top-gallery').val(options[0]);
    jQ('.margin-bottom-gallery').val(options[1]);
    jQ('.margin-top-number-gallery').val(options[0]);
    jQ('.margin-bottom-number-gallery').val(options[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-gallery').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.bagallery-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.bagallery-options').val(options);
        jQ('.margin-top-number-gallery').val(inputValue);
    }, 12);
    jQ('.margin-top-gallery').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-gallery').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.bagallery-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.bagallery-options').val(options);
        jQ('.margin-bottom-number-gallery').val(inputValue);
    }, 12);
    jQ('.margin-bottom-gallery').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-number-gallery').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.bagallery-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    jQ('.margin-top-gallery').val(value);
    currentItem.find('.bagallery-options').val(options);
    addHistory();
});
jQ('.margin-bottom-number-gallery').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.bagallery-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    jQ('.margin-bottom-bagallery').val(value);
    currentItem.find('.bagallery-options').val(options);
    addHistory();
});
jQ('.gallery-css-button').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.gallery-css-options').addClass('ba-fade');
    var options = currentItem.find('.bagallery-options').val();
    options = options.split(';');
    jQ('.custom-suffix-gallery').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-gallery').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.bagallery-options').val(), jQ(this).val(), 2);
    currentItem.find('.bagallery-options').val(options);
    addHistory();
});