/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.logo-width-number').on('click keyup',function(){
    var value = jQ(this).val();
    if (value*1 > 1000) {
        jQ(this).val(1000);
    }
});
jQ('.logo-options-options').on('click', function(){
    if (!globalParams.logo) {
        globalParams.logo = {
            img: sitePath+'components/com_bagrid/assets/images/gridbox.png',
            link: window.location.pathname,
            width : '75',
            alt : ''
        }
    }
    var options = currentItem.find('.ba-logo-options').val();
    options = options.split(';');
    jQ('.logo-width-image').val(globalParams.logo.width);
    jQ('.logo-width-number').val(globalParams.logo.width);
    jQ('.logo-link-image').val(globalParams.logo.link);
    jQ('.logo-alt-image').val(globalParams.logo.alt)
    jQ('.logo-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.logo-options-cell').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.logo-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-logo-options', 3, jQ(this).val(), 'text-align', currentItem, '');
});
jQ('.logo-alt-image').on('keyup', function(){
    var alt = jQ(this).val();
    globalParams.logo.alt = alt;
    jQ('.logo img').attr('alt', alt);
    addHistory();
});
jQ('.logo-link-image').on('keyup', function(){
    var link = jQ(this).val();
    globalParams.logo.link = link;
    jQ('.logo > a').attr('href', link);
    addHistory();
});
jQ('.logo-select-img').on('click', function(){
    uploadMode = 'logoUpload';
    jQ('#uploader-modal').modal();
});
jQ('.logo-width-image').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
        inputValue = input.val();
        globalParams.logo.width = inputValue;
        jQ('.logo img').css('width', globalParams.logo.width+'px');
        jQ('.logo-width-number').val(inputValue);
    }, 100);
    jQ('.logo-width-image').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.logo-width-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    globalParams.logo.width = value;
    jQ('.logo img').css('width', globalParams.logo.width+'px');
    jQ('.logo-width-image').val(value);
    addHistory();
});
jQ('.logo-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.logo-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-logo-options').val();
    options = options.split(';');
    jQ('.margin-top-logo').val(options[0]);
    jQ('.margin-top-logo-number').val(options[0]);
    jQ('.margin-bottom-logo').val(options[1]);
    jQ('.margin-bottom-logo-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-logo').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-logo-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-logo-options').val(options);
        jQ('.margin-top-logo-number').val(inputValue);
    }, 12);
    jQ('.margin-top-logo').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-logo').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-logo-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-logo-options').val(options);
        jQ('.margin-bottom-logo-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-logo').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-logo-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-logo-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-logo-options').val(options);
    jQ('.margin-top-logo').val(value);
    addHistory();
});
jQ('.margin-bottom-logo-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-logo-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-logo-options').val(options);
    jQ('.margin-bottom-logo').val(value);
    addHistory();
});
jQ('.logo-css').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.logo-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-logo-options').val();
    options = options.split(';');
    jQ('.custom-suffix-logo').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-logo').on('keyup', function(){
    options = customSuffix(currentItem, currentItem.find('.ba-logo-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-logo-options').val(options);
    addHistory();
});