/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.overlay-section-button').on('click', function(){
	jQ('.nav-overlay-section').removeClass('ba-active-options');
	jQ('.nav-overlay-section-button').show().addClass('ba-active-options');
	jQ('.overlay-section-options').removeClass('ba-in').addClass('ba-out');
	jQ('.overlay-section-button-options').addClass('ba-in');
});
jQ('.nav-overlay-section-button').on('click', function(){
	jQ('.workspace-nav-bar .ba-active-options').removeClass('ba-active-options');
	jQ('.nav-overlay-section-button').nextAll().hide().addClass('ba-active-options');
	jQ('.ba-gb-options.ba-fade').removeClass('ba-fade');
	jQ('.overlay-section-button-options').addClass('ba-in');
});
jQ('.overlay-section-label').on('click', function(){
	jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.overlay-section-label-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-label').show().addClass('ba-active-options');
    var label = currentItem.find('> a span').text(),
    	options = currentItem.find('.ba-overlay-section-options').val();
	options = options.split(';');
    jQ('.overlay-section-icon-position option').each(function(){
        if (jQ(this).val() == options[21]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.ba-overlay-section-label').val(label);
    jQ('.overlay-section-icon-size').val(options[26]);
    jQ('.overlay-section-icon-size-number').val(options[26]);
});
jQ('.overlay-section-icon-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-overlay-section-options', 26, inputValue);
        currentItem.find('> a > i.zmdi').css({
            'width' : inputValue+'px',
            'height' : inputValue+'px',
            'font-size' : inputValue+'px'
        });
        currentItem.find('> a').css({
            'line-height' : inputValue+'px'
        });
        jQ('.overlay-section-icon-size-number').val(inputValue);
    }, 12);
    jQ('.overlay-section-icon-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.overlay-section-icon-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-overlay-section-options', 26, value);
    currentItem.find('> a > i.zmdi').css({
        'width' : value+'px',
        'height' : value+'px',
        'font-size' : value+'px'
    });
    currentItem.find('> a').css({
        'line-height' : value+'px'
    });
    jQ('.overlay-section-icon-size').val(value);
    addHistory();
});
jQ('.overlay-section-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.overlay-section-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-overlay-section-options').val(),
        color;
    options = options.split(';');    
    color = rgb2hex(options[25]);
    jQ('.overlay-section-layout option').each(function(){
        if (jQ(this).val() == options[6]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[6] == 'vertical') {
        jQ('.overlay-section-width').show();
        jQ('.overlay-section-height').hide();
        jQ('.overlay-section-vertical').show();
        jQ('.overlay-section-horizontal').hide();
    } else if (options[6] == 'horizontal') {
        jQ('.overlay-section-width').hide();
        jQ('.overlay-section-height').show();
        jQ('.overlay-section-vertical').hide();
        jQ('.overlay-section-horizontal').show();
    } else {
        jQ('.overlay-section-width').show();
        jQ('.overlay-section-height').hide();
        jQ('.overlay-section-vertical').hide();
        jQ('.overlay-section-horizontal').hide();
    }
    jQ('.ba-overlay-section-width').val(options[12]);
    jQ('.ba-overlay-section-width-number').val(options[12]);
    jQ('.ba-overlay-section-height').val(options[24]);
    jQ('.ba-overlay-section-height-number').val(options[24]);
    jQ('.overlay-section-vertical-slide option, .overlay-section-horizontal-slide option').each(function(){
        if (jQ(this).val() == options[13]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.background-overlay-color').minicolors('value', color[0]);
    jQ('.background-overlay-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[27]);
    jQ('.overlay-close-color').minicolors('value', color[0]);
    jQ('.overlay-close-color').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.overlay-close-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-overlay-section-options', 27, hex);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.background-overlay-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-overlay-section-options', 25, hex);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.overlay-section-layout').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-overlay-section-options').val(),
        ind = currentItem.find('> a').attr('data-overlay'),
        overlay = jQ('.overlay-section[data-overlay="'+ind+'"]');
    options = options.split(';');
    overlay.removeClass(options[6]).removeClass(options[13]).addClass(value);
    options[6] = value;
    var ovOprions = overlay.find('> .ba-section > .ba-options').val().split(';');
    if (ovOprions[0] == 0) {
        overlay.addClass('ba-container');
    }
    if (ovOprions[1] == 1) {
        overlay.find('> .ba-section').addClass('ba-fullscreen');
    }
    if (value == 'vertical') {
        overlay.find('> .ba-section').removeClass('ba-fullscreen');
        value += '-right';
        overlay[0].style.height = '';
        overlay[0].style.width = options[12]+'px';
    } else if (value == 'horizontal') {
        overlay.removeClass('ba-container');
        value += '-top';
        overlay[0].style.height = options[24]+'px';
        overlay[0].style.width = '';
    } else {
        overlay[0].style.height = '';
        overlay[0].style.width = options[12]+'px';
    }
    options[13] = value;
    overlay.addClass(value);
    if (options[6] == 'vertical') {
        jQ('.overlay-section-width').show();
        jQ('.overlay-section-height').hide();
        jQ('.overlay-section-vertical').show();
        jQ('.overlay-section-horizontal').hide();
    } else if (options[6] == 'horizontal') {
        jQ('.overlay-section-width').hide();
        jQ('.overlay-section-height').show();
        jQ('.overlay-section-vertical').hide();
        jQ('.overlay-section-horizontal').show();
    } else {
        jQ('.overlay-section-width').show();
        jQ('.overlay-section-height').hide();
        jQ('.overlay-section-vertical').hide();
        jQ('.overlay-section-horizontal').hide();
    }
    jQ('.overlay-section-vertical-slide option, .overlay-section-horizontel-slide option').each(function(){
        if (jQ(this).val() == options[13]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    options = options.join(';');
    currentItem.find('.ba-overlay-section-options').val(options);
});
jQ('.overlay-section-vertical-slide, .overlay-section-horizontal-slide').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-overlay-section-options').val(),
        ind = currentItem.find('> a').attr('data-overlay'),
        overlay = jQ('.overlay-section[data-overlay="'+ind+'"]');
    options = options.split(';');
    overlay.removeClass(options[13]).addClass(value);
    setValue('.ba-overlay-section-options', 13, value);
});
jQ('.ba-overlay-section-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        ind = currentItem.find('> a').attr('data-overlay'),
        overlay = jQ('.overlay-section[data-overlay="'+ind+'"]');
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-overlay-section-options', 12, inputValue);
        overlay.width(inputValue);
        jQ('.ba-overlay-section-width-number').val(inputValue);
    }, 12);
    jQ('.ba-overlay-section-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.ba-overlay-section-width-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        ind = currentItem.find('> a').attr('data-overlay'),
        overlay = jQ('.overlay-section[data-overlay="'+ind+'"]');
    setValue('.ba-overlay-section-options', 12, value);
    overlay.width(value);
    jQ('.ba-overlay-section-width').val(value);
    addHistory();
});
jQ('.ba-overlay-section-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        ind = currentItem.find('> a').attr('data-overlay'),
        overlay = jQ('.overlay-section[data-overlay="'+ind+'"]');
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-overlay-section-options', 24, inputValue);
        overlay.height(inputValue);
        jQ('.ba-overlay-section-height-number').val(inputValue);
    }, 12);
    jQ('.ba-overlay-section-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.ba-overlay-section-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        ind = currentItem.find('> a').attr('data-overlay'),
        overlay = jQ('.overlay-section[data-overlay="'+ind+'"]');
    setValue('.ba-overlay-section-options', 24, value);
    overlay.height(value);
    jQ('.ba-overlay-section-height').val(value);
    addHistory();
});
jQ('.ba-overlay-section-label').on('keyup', function(){
    var label = jQ(this).val();
    if (currentItem.find('> a span').length == 0) {
        if (currentItem.find('> a > i.zmdi')) {
            currentItem.find('> a > i.zmdi').before('<span></span>');
        } else {
            currentItem.find('> a').append('<span></span>');
        }
    }
    currentItem.find('> a span').text(label);
    if (label == '') {
        currentItem.find('> a span').remove()
    }
});
jQ('.overlay-section-icon-position').on('change', function(){
    var options = currentItem.find('.ba-overlay-section-options').val(),
        value = jQ(this).val();
    options = options.split(';');
    currentItem.removeClass(options[21]);
    options[21] = value;
    if (value != 'before') {
        currentItem.addClass(value)
    }
    options = options.join(';');
    currentItem.find('.ba-overlay-section-options').val(options);
});
jQ('.select-overlay-section').on('click', function(){
    uploadMode = 'reselectOverlaySection';
    jQ('#icons-upload-modal').modal();
});
jQ('.clear-overlay-section-icon').on('click', function(){
    currentItem.find('> a')[0].style.lineHeight = '';
    currentItem.find('> a > i.zmdi').remove();
})
jQ('.overlay-section-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.overlay-section-style-options').addClass('ba-fade');
    var options = currentItem.find('.ba-overlay-section-options').val();
    options = options.split(';');
    if (!options[28]) {
        options[28] = 0;
    }
    jQ('.overlay-section-letter-spacing').val(options[28]);
    jQ('.overlay-section-letter-spacing-number').val(options[28]);
    jQ('.overlay-section-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    if (options[18] == 'underline') {
        jQ('.overlay-section-font-style[value=underline]').closest('.ba-btn').addClass('active');
        jQ('.overlay-section-font-style[value=underline]').attr('checked', true);
    } else {
        jQ('.overlay-section-font-style[value=underline]').closest('.ba-btn').removeClass('active');
        jQ('.overlay-section-font-style[value=underline]').removeAttr('checked', true);
    }
    if (options[19] == 'uppercase') {
        jQ('.overlay-section-font-style[value=uppercase]').closest('.ba-btn').addClass('active');
        jQ('.overlay-section-font-style[value=uppercase]').attr('checked', true);
    } else {
        jQ('.overlay-section-font-style[value=uppercase]').closest('.ba-btn').removeClass('active');
        jQ('.overlay-section-font-style[value=uppercase]').removeAttr('checked', true);
    }
    if (options[20] == 'italic') {
        jQ('.overlay-section-font-style[value=italic]').closest('.ba-btn').addClass('active');
        jQ('.overlay-section-font-style[value=italic]').attr('checked', true);
    } else {
        jQ('.overlay-section-font-style[value=italic]').closest('.ba-btn').removeClass('active');
        jQ('.overlay-section-font-style[value=italic]').removeAttr('checked', true);
    }
    jQ('.overlay-section-font-family').val(options[22].replace(new RegExp('\\+','g'), ' ')+' '+options[23]);
    color = rgb2hex(options[8]);
    jQ('.overlay-section-bg-color').minicolors('value', color[0]);
    jQ('.overlay-section-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[4]);
    jQ('.overlay-section-text-color').minicolors('value', color[0]);
    jQ('.overlay-section-text-color').minicolors('opacity', color[1]);
    jQ('.overlay-section-font-size').val(options[5]);
    jQ('.overlay-section-font-size-number').val(options[5]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-scroll').show().addClass('ba-active-options');
});
jQ('.overlay-section-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-overlay-section-options').val();
    options = options.split(';');
    if (jQ(this).val() == 'underline') {
        if (options[18] != value) {
            jQ(this).closest('label').addClass('active');
            options[18] = value;

        } else {
            jQ(this).closest('label').removeClass('active');
            options[18] = 'none';
        }
    } else if (jQ(this).val() == 'uppercase') {
        if (options[19] != value) {
            jQ(this).closest('label').addClass('active');
            options[19] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[19] = 'none';
        }
    } else {
        if (options[20] != value) {
            jQ(this).closest('label').addClass('active');
            options[20] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[20] = 'normal';
        }
    }
    currentItem.find('> a').css({
        'text-decoration' : options[18],
        'text-transform' : options[19],
        'font-style' : options[20]
    });
    options = options.join(';');
    currentItem.find('.ba-overlay-section-options').val(options);
    addHistory();
});
jQ('.select-overlay-section-family').on('click', function(){
    uploadMode = 'overlaySectionFamily';
    jQ('#fonts-modal').modal();
});
jQ('.overlay-section-align').on('click', function(){
    setValue('.ba-overlay-section-options', 3, jQ(this).val(), 'text-align', currentItem, '');
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    addHistory()
});
jQ('.overlay-section-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-overlay-section-options', 8, hex, 'background-color', '> a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.overlay-section-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-overlay-section-options', 4, hex, 'color', '> a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.overlay-section-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-overlay-section-options', 28, inputValue, 'letter-spacing', '> a', 'px');
            jQ('.overlay-section-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.overlay-section-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.overlay-section-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-overlay-section-options', 28, value, 'letter-spacing', '> a', 'px');
    jQ('.overlay-section-letter-spacing').val(value);
    addHistory();
});
jQ('.overlay-section-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-overlay-section-options', 5, inputValue, 'font-size', '> a', 'px');
        jQ('.overlay-section-font-size-number').val(inputValue);
    }, 100);
    jQ('.overlay-section-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.overlay-section-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-overlay-section-options', 5, value, 'font-size', '> a', 'px');
    jQ('.overlay-section-font-size').val(value);
    addHistory();
});
jQ('.overlay-section-border').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.overlay-section-border-options').addClass('ba-fade');
    var options = currentItem.find('.ba-overlay-section-options').val();
    options = options.split(';');
    var color = rgb2hex(options[9]);
    jQ('.overlay-section-border-color').minicolors('value', color[0]);
    jQ('.overlay-section-border-color').minicolors('opacity', color[1]);
    jQ('.overlay-section-border-radius').val(options[10]);
    jQ('.overlay-section-border-radius-number').val(options[10]);
    jQ('.overlay-section-border-width').val(options[11]);
    jQ('.overlay-section-border-width-number').val(options[11]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
});
jQ('.overlay-section-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-overlay-section-options', 10, inputValue, 'border-radius', '> a', 'px');
        jQ('.overlay-section-border-radius-number').val(inputValue);
    }, 12);
    jQ('.overlay-section-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.overlay-section-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-overlay-section-options', 10, value, 'border-radius', '> a', 'px');
    jQ('.overlay-section-border-radius').val(value);
    addHistory();
});
jQ('.overlay-section-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            var value = jQ(this).minicolors('rgbaString'),
                options = currentItem.find('.ba-overlay-section-options').val();
            options = options.split(';');
            options[9] = value;
            currentItem.find('> a').css('border', options[11]+'px solid '+value);
            options = options.join(';');
            currentItem.find('.ba-overlay-section-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.overlay-section-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-overlay-section-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[11] = inputValue;
            currentItem.find('> a').css('border', options[11]+'px solid '+options[9]);
            options = options.join(';');
            currentItem.find('.ba-overlay-section-options').val(options);
            jQ('.overlay-section-border-width-number').val(inputValue);
        }, 12);
    jQ('.overlay-section-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.overlay-section-border-width-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-overlay-section-options').val();
    options = options.split(';');
    options[11] = value;
    currentItem.find('> a').css('border', options[11]+'px solid '+options[9]);
    options = options.join(';');
    jQ('.overlay-section-border-width').val(value);
    currentItem.find('.ba-overlay-section-options').val(options);
    addHistory();
});
jQ('.overlay-section-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.overlay-section-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-overlay-section-options').val();
    options = options.split(';');
    var color = rgb2hex(options[7]);
    jQ('.overlay-section-hover-color').minicolors('value', color[0]);
    jQ('.overlay-section-hover-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[14]);
    jQ('.overlay-section-bg-color-hover').minicolors('value', color[0]);
    jQ('.overlay-section-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[15]);
    jQ('.overlay-section-border-color-hover').minicolors('value', color[0]);
    jQ('.overlay-section-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.overlay-section-hover-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-overlay-section-options', 7, hex);
            overlaySectionHover(currentItem.find('> a'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.overlay-section-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-overlay-section-options', 14, hex);
            overlaySectionHover(currentItem.find('> a'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.overlay-section-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-overlay-section-options', 15, hex);
            overlaySectionHover(currentItem.find('> a'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.overlay-section-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.overlay-section-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-overlay-section-options').val();
    options = options.split(';');
    jQ('.overlay-section-padding-vertical').val(options[16]);
    jQ('.overlay-section-padding-vertical-number').val(options[16]);
    jQ('.overlay-section-padding-horizontal').val(options[17]);
    jQ('.overlay-section-padding-horizontal-number').val(options[17]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.overlay-section-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-overlay-section-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('> a'), options, inputValue, 16, 16, 17, 16, 17);
        currentItem.find('.ba-overlay-section-options').val(options);
        jQ('.overlay-section-padding-vertical-number').val(inputValue);
    }, 12);
    jQ('.overlay-section-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.overlay-section-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-overlay-section-options').val();
    options = paddingAction(currentItem.find('> a'), options, value, 16, 16, 17, 16, 17);
    jQ('.overlay-section-padding-vertical').val(value);
    currentItem.find('.ba-overlay-section-options').val(options);
    addHistory();
});
jQ('.overlay-section-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-overlay-section-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('> a'), options, inputValue, 17, 16, 17, 16, 17);
        currentItem.find('.ba-overlay-section-options').val(options);
        jQ('.overlay-section-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.overlay-section-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.overlay-section-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-overlay-section-options').val();
    options = paddingAction(currentItem.find('> a'), options, value, 17, 16, 17, 16, 17);
    jQ('.padding-horizontal').val(value);
    currentItem.find('.ba-overlay-section-options').val(options);
    addHistory();
});
jQ('.overlay-section-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.overlay-section-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-overlay-section-options').val();
    options = options.split(';');
    jQ('.margin-top-overlay-section').val(options[0]);
    jQ('.margin-top-overlay-section-number').val(options[0]);
    jQ('.margin-bottom-overlay-section').val(options[1]);
    jQ('.margin-bottom-overlay-section-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-overlay-section').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-overlay-section-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-overlay-section-options').val(options);
        jQ('.margin-top-overlay-section-number').val(inputValue);
    }, 12);
    jQ('.margin-top-overlay-section').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-overlay-section').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-overlay-section-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-overlay-section-options').val(options);
        jQ('.margin-bottom-overlay-section-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-overlay-section').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-overlay-section-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-overlay-section-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-overlay-section-options').val(options);
    jQ('.margin-top-overlay-section').val(value);
    addHistory();
});
jQ('.margin-bottom-overlay-section-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-overlay-section-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-overlay-section-options').val(options);
    jQ('.margin-bottom-overlay-section').val(value);
    addHistory();
});
jQ('.overlay-section-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.overlay-section-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-overlay-section-options').val();
    options = options.split(';');
    jQ('.custom-suffix-overlay-section').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-overlay-section').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-overlay-section-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-overlay-section-options').val(options);
    addHistory();
});