/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.scroll-to-top-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-top-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-top-options').val(),
        color;
    options = options.split(';');
    jQ('.scroll-to-top-speed').val(options[12]);
    jQ('.scroll-to-top-animation option').each(function(){
        if (jQ(this).val() == options[13]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    })
    jQ('.scroll-to-top-offset').val(options[6]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.scroll-to-top-speed').on('keyup', function() {
    setValue('.ba-scroll-to-top-options', 12, jQ(this).val());
    initScrollTop(currentItem);
    addHistory();
});
jQ('.scroll-to-top-animation').on('change', function() {
    setValue('.ba-scroll-to-top-options', 13, jQ(this).val());
    initScrollTop(currentItem);
    addHistory();
});
jQ('.scroll-to-top-offset').on('keyup', function(){
    setValue('.ba-scroll-to-top-options', 6, jQ(this).val());
    addHistory();
});
jQ('.select-scroll-to-top').on('click', function(){
    uploadMode = "reselectScrollTop"
    jQ('#icons-upload-modal').modal();
});
jQ('.scroll-to-top-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-top-style-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-top-options').val();
    options = options.split(';');
    jQ('.scroll-to-top-align').each(function(){
        if (jQ(this).val() == options[3]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    color = rgb2hex(options[8]);
    jQ('.scroll-to-top-bg-color').minicolors('value', color[0]);
    jQ('.scroll-to-top-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[4]);
    jQ('.scroll-to-top-text-color').minicolors('value', color[0]);
    jQ('.scroll-to-top-text-color').minicolors('opacity', color[1]);
    jQ('.scroll-to-top-font-size').val(options[5]);
    jQ('.scroll-to-top-font-size-number').val(options[5]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-scroll').show().addClass('ba-active-options');
});
jQ('.scroll-to-top-align').on('click', function(){
    var options = currentItem.find('.ba-scroll-to-top-options').val(),
        val = jQ(this).val();
    options = options.split(';');
    currentItem.removeClass('scroll-btn-'+options[3]);
    options[3] = val;
    options = options.join(';');
    currentItem.find('.ba-scroll-to-top-options').val(options);
    currentItem.addClass('scroll-btn-'+val);
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    addHistory()
});
jQ('.scroll-to-top-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-top-options', 8, hex, 'background-color', 'i.zmdi', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-top-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-top-options', 4, hex, 'color', 'i.zmdi', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-top-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-scroll-to-top-options', 5, inputValue);
        currentItem.find('i.zmdi').css({
            'font-size' : inputValue+'px',
            'width' : inputValue+'px',
            'height' : inputValue+'px'
        });
        jQ('.scroll-to-top-font-size-number').val(inputValue);
    }, 12);
    jQ('.scroll-to-top-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-top-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-scroll-to-top-options', 5, value);
    currentItem.find('i.zmdi').css({
        'font-size' : value+'px',
        'width' : value+'px',
        'height' : value+'px'
    });
    jQ('.scroll-to-top-font-size').val(value);
    addHistory();
});
jQ('.scroll-to-top-border').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-top-border-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-top-options').val();
    options = options.split(';');
    var color = rgb2hex(options[9]);
    jQ('.scroll-to-top-border-color').minicolors('value', color[0]);
    jQ('.scroll-to-top-border-color').minicolors('opacity', color[1]);
    jQ('.scroll-to-top-border-radius').val(options[10]);
    jQ('.scroll-to-top-border-radius-number').val(options[10]);
    jQ('.scroll-to-top-border-width').val(options[11]);
    jQ('.scroll-to-top-border-width-number').val(options[11]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
});
jQ('.scroll-to-top-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-scroll-to-top-options', 10, inputValue, 'border-radius', 'i.zmdi', 'px');
        jQ('.scroll-to-top-border-radius-number').val(inputValue);
    }, 12);
    jQ('.scroll-to-top-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-top-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-scroll-to-top-options', 10, value, 'border-radius', 'i.zmdi', 'px');
    jQ('.scroll-to-top-border-radius').val(value);
    addHistory();
});
jQ('.scroll-to-top-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            var value = jQ(this).minicolors('rgbaString'),
                options = currentItem.find('.ba-scroll-to-top-options').val();
            options = options.split(';');
            options[9] = value;
            currentItem.find('i.zmdi').css('border', options[11]+'px solid '+value);
            options = options.join(';');
            currentItem.find('.ba-scroll-to-top-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-top-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-scroll-to-top-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[11] = inputValue;
            currentItem.find('i.zmdi').css('border', options[11]+'px solid '+options[9]);
            options = options.join(';');
            currentItem.find('.ba-scroll-to-top-options').val(options);
            jQ('.scroll-to-top-border-width-number').val(inputValue);
        }, 12);
    jQ('.scroll-to-top-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-top-border-width-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-scroll-to-top-options').val();
    options = options.split(';');
    options[11] = value;
    currentItem.find('i.zmdi').css('border', options[11]+'px solid '+options[9]);
    options = options.join(';');
    jQ('.scroll-to-top-border-width').val(value);
    currentItem.find('.ba-scroll-to-top-options').val(options);
    addHistory();
});
jQ('.scroll-to-top-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-top-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-top-options').val();
    options = options.split(';');
    var color = rgb2hex(options[7]);
    jQ('.scroll-to-top-hover-color').minicolors('value', color[0]);
    jQ('.scroll-to-top-hover-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[14]);
    jQ('.scroll-to-top-bg-color-hover').minicolors('value', color[0]);
    jQ('.scroll-to-top-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[15]);
    jQ('.scroll-to-top-border-color-hover').minicolors('value', color[0]);
    jQ('.scroll-to-top-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.scroll-to-top-hover-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-top-options', 7, hex);
            scrolltoTopHover(currentItem);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-top-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-top-options', 14, hex);
            scrolltoTopHover(currentItem);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-top-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-scroll-to-top-options', 15, hex);
            scrolltoTopHover(currentItem);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.scroll-to-top-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-top-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-top-options').val();
    options = options.split(';');
    jQ('.scroll-to-top-padding-vertical').val(options[0]);
    jQ('.scroll-to-top-padding-vertical-number').val(options[0]);
    jQ('.scroll-to-top-padding-horizontal').val(options[1]);
    jQ('.scroll-to-top-padding-horizontal-number').val(options[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.scroll-to-top-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-scroll-to-top-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('i.zmdi'), options, inputValue, 0, 0, 1, 0, 1);
        currentItem.find('.ba-scroll-to-top-options').val(options);
        jQ('.scroll-to-top-padding-vertical-number').val(inputValue);
    }, 12);
    jQ('.scroll-to-top-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-top-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-scroll-to-top-options').val();
    options = paddingAction(currentItem.find('i.zmdi'), options, value, 0, 0, 1, 0, 1);
    jQ('.scroll-to-top-padding-vertical').val(value);
    currentItem.find('.ba-scroll-to-top-options').val(options);
    addHistory();
});
jQ('.scroll-to-top-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-scroll-to-top-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('i.zmdi'), options, inputValue, 1, 0, 1, 0, 1);
        currentItem.find('.ba-scroll-to-top-options').val(options);
        jQ('.scroll-to-top-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.scroll-to-top-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.scroll-to-top-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-scroll-to-top-options').val();
    options = paddingAction(currentItem.find('i.zmdi'), options, value, 1, 0, 1, 0, 1);
    jQ('.padding-horizontal').val(value);
    currentItem.find('.ba-scroll-to-top-options').val(options);
    addHistory();
});
jQ('.scroll-to-top-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.scroll-to-top-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-scroll-to-top-options').val();
    options = options.split(';');
    jQ('.custom-suffix-scroll-to-top').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-scroll-to-top').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-scroll-to-top-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-scroll-to-top-options').val(options);
    addHistory();
});