/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.slideset-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-slideset-options-cell').addClass('ba-fade');
    var options = currentItem.find('.ba-slideset-options').val(),
        color;
    options = options.split(';');
    if (options[2] == 'single') {
        jQ('.slideset-dot-navigation').attr('disabled', true);
    } else {
        jQ('.slideset-dot-navigation').removeAttr('disabled');
    }
    jQ('.slideset-images-count').val(options[0]);
    jQ('.slideset-mode option').each(function(){
        if (jQ(this).val() == options[2]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.slideset-animation option').each(function(){
        if (jQ(this).val() == options[8]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[52] == 1) {
        jQ('.slideset-column-gutter').attr('checked', true);
    } else {
        jQ('.slideset-column-gutter').removeAttr('checked');
    }
    jQ('.slideset-height').val(options[1]);
    jQ('.slideset-height-number').val(options[1]);
    if (options[3] == 1) {
        jQ('.slideset-autoplay').attr('checked', true);
    } else {
        jQ('.slideset-autoplay').removeAttr('checked');
    }
    jQ('.slideset-delay').val(options[5]);
    if (options[6] == 1) {
        jQ('.slideset-dot-navigation').attr('checked', true);
    } else {
        jQ('.slideset-dot-navigation').removeAttr('checked');
    }
    if (options[7] == 1) {
        jQ('.slideset-nav-mouseover').attr('checked', true);
    } else {
        jQ('.slideset-nav-mouseover').removeAttr('checked');
    }
    jQ('.slideset-caption-position option').each(function(){
        if (jQ(this).val() == options[51]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[51] == 'over') {
        jQ('.caption-hover').removeAttr('disabled');
    } else {
        jQ('.caption-hover').attr('disabled', true);
    }
    if (options[9] == 1) {
        jQ('.caption-hover').attr('checked', true);
    } else {
        jQ('.caption-hover').removeAttr('checked');
    }
    color = rgb2hex(options[10]);
    jQ('.slideset-caption-color').minicolors('value', color[0]);
    jQ('.slideset-caption-color').minicolors('opacity', color[1]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options)
});
jQ('.slideset-images-count').on('click keyup', function(){
    var val = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val(),
        item = currentItem.find('.ba-slideset');
    if (val < 1) {
        return false;
    }
    options = options.split(';');
    options[0] = val;
    drawSlideset(item, options[2], options[0], options[1]);
    initialSlideset(item, options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';')
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-delay').on('keyup', function(){
    var val = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val(),
        item = currentItem.find('.ba-slideset');
    options = options.split(';');
    options[5] = val;
    drawSlideset(item, options[2], options[0], options[1]);
    initialSlideset(item, options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';')
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-mode').on('change', function(){
    var val = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val(),
        item = currentItem.find('.ba-slideset');
    options = options.split(';');
    options[2] = val;
    drawSlideset(item, options[2], options[0], options[1]);
    initialSlideset(item, options[0], options[2], options[3], options[5], options[8]);
    if (options[2] == 'single') {
        jQ('.slideset-dot-navigation').attr('disabled', true);
    } else {
        jQ('.slideset-dot-navigation').removeAttr('disabled');
    }
    options = options.join(';')
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-animation').on('change', function(){
    var val = val = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    currentItem.find('.ba-slideset').removeClass(options[8]);
    currentItem.find('.ba-slideset').addClass(val);
    options[8] = val;
    options = options.join(';')
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-column-gutter').on('click', function(){
    var val = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val(),
        item = currentItem.find('.ba-slideset');
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[52] = 1;
        item.addClass('slideset-gutter');
    } else {
        options[52] = 0;
        item.removeClass('slideset-gutter');
    }
    drawSlideset(item, options[2], options[0], options[1]);
    initialSlideset(item, options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        item = currentItem.find('.ba-slideset');
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-slideset-options').val();
        inputValue = input.val();
        options = options.split(';');
        options[1] = inputValue;
        item.find('.slideset-content .ba-slideset-img').height(options[1]);
        initialSlideset(item, options[0], options[2], options[3], options[5], options[8]);
        options = options.join(';');
        currentItem.find('.ba-slideset-options').val(options);
        jQ('.slideset-height-number').val(inputValue);
    }, 12);
    jQ('.slideset-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-height-number').on('click keyup', function(){
    var options = currentItem.find('.ba-slideset-options').val(),
        value = jQ(this).val(),
        item = currentItem.find('.ba-slideset');
    options = options.split(';');
    options[1] = value;
    item.find('.slideset-content .ba-slideset-img').height(options[1]);
    initialSlideset(item, options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    jQ('.slideset-height').val(value);
    addHistory();
});
jQ('.slideset-autoplay').on('click', function(){
    var options = currentItem.find('.ba-slideset-options').val(),
        item = currentItem.find('.ba-slideset');
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[3] = 1;
    } else {
        options[3] = 0;
    }
    initialSlideset(item, options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-dot-navigation').on('click', function(){
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[6] = 1;
        currentItem.find('ul.ba-slideset').removeClass('hide-dots');
    } else {
        options[6] = 0;
        currentItem.find('ul.ba-slideset').addClass('hide-dots');
    }
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-nav-mouseover').on('click', function(){
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[7] = 1;
        currentItem.find('ul.ba-slideset').addClass('nav-hover');
    } else {
        options[7] = 0;
        currentItem.find('ul.ba-slideset').removeClass('nav-hover');
    }
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-caption-position').on('change', function(){
    var options = currentItem.find('.ba-slideset-options').val(),
        value = jQ(this).val(),
        item = currentItem.find('.ba-slideset');
    options = options.split(';');
    if (value == 'over') {
        currentItem.find('.ba-slideset').addClass('caption-over');
        jQ('.caption-hover').removeAttr('disabled');
    } else {
        currentItem.find('.ba-slideset').removeClass('caption-over');
        currentItem.find('.ba-slideset').removeClass('caption-hover');
        jQ('.caption-hover').attr('disabled', true);
    }
    options[51] = value;
    drawSlideset(item, options[2], options[0], options[1]);
    initialSlideset(item, options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.caption-hover').on('click', function(){
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[9] = 1;
        currentItem.find('.ba-slideset').addClass('caption-hover');
    } else {
        options[9] = 0;
        currentItem.find('.ba-slideset').removeClass('caption-hover');
    }
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-caption-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slideset-options', 10, hex, 'background-color', '.ba-slideset-caption', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-slides').on('click', function(){
    var items = {},
        name,
        str;
    jQ('.slideset-slides-options .slides-list tbody').empty();
    currentItem.find('.slideset-content li.item').each(function(){
        var url = jQ(this).find('.ba-slideset-img').attr('data-img-url');
        name = url.split('/');
        name = name[name.length - 1];
        items.url = url;
        items.h = jQ(this).find('.ba-slideset-caption .ba-slideset-title').html();
        items.p = jQ(this).find('.ba-slideset-caption .ba-slideset-description').html();
        if (!items.h) {
            items.h = '';
        }
        if (!items.p) {
            items.p = '';
        }
        items.label = jQ(this).find('.ba-slideset-caption .slideset-button a').text();
        items.link = jQ(this).find('.ba-slideset-caption .slideset-button a').attr('href');
        items.target = jQ(this).find('.ba-slideset-caption .slideset-button a').attr('target');
        str = '<tr><td><input type="checkbox" class="slides-items"';
        str += " value=''>";
        str += '</td><td><img src="'+url+'"></td><td width="60%">';
        str += name+'</td></tr>';
        jQ('.slideset-slides-options .slides-list tbody').append(str);
        jQ('.slideset-slides-options .slides-list tbody tr').last().find('.slides-items').val(JSON.stringify(items));
        items = {};
    });
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slideset-slides-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slides').show().addClass('ba-active-options');
});
jQ('.slideset-add').on('click', function(){
    uploadMode = 'slidesetUpload'
    jQ('#uploader-modal').modal();
});
jQ('.slideset-delete').on('click', function(){
    deleteItem = 'slideset';
    jQ('.slideset-slides-options .slides-items').each(function(){
        if (jQ(this).prop('checked')) {
            jQ('#login-modal').modal();
            return false;
        }
    });
});
jQ('.slideset-edit').on('click', function(){
    var count = 0,
        item;
    jQ('.slideset-slides-options .slides-items').each(function(){
        if (jQ(this).prop('checked')) {
            item = jQ(this).val();
            count++;
        }
    });
    if (count === 1) {
        tabMode = 'slideset'
        jQ('.slideshow-video-options').hide();
        jQ('.slideshow-image-reselect').show();
        jQ('.slide-item').val(item);
        item = JSON.parse(item);
        jQ('.slide-title').val(item.h);
        jQ('.slide-description').val(item.p);
        jQ('.slide-label').val(item.label);
        jQ('.slide-link').val(item.link);
        jQ('.slide-target option').each(function(){
            if (item.target != 'undefined') {
                if (jQ(this).val() == item.target) {
                    jQ(this).attr('selected', true);
                } else {
                    jQ(this).removeAttr('selected');
                }
            } else {
                if (jQ(this).val() == '_blank') {
                    jQ(this).attr('selected', true);
                } else {
                    jQ(this).removeAttr('selected');
                }
            }
        });
        jQ('#slides-caption-modal').modal();
    } else if (count > 1) {
        jQ('#notification-modal .item-notification').show();
        jQ('#notification-modal .select-item').hide();
        jQ('#notification-modal').modal();
    } else if (count === 0) {
        jQ('#notification-modal .item-notification').hide();
        jQ('#notification-modal .select-item').show();
        jQ('#notification-modal').modal();
    }
});
jQ('.slideset-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slideset-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.ba-workspace .nav-style-slideset').show().addClass('ba-active-options');
});
jQ('.nav-style-slideset').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-element-options .ba-fade').removeClass('ba-fade')
    jQ('.slideset-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-slideset ~ a').hide();
    jQ('.nav-style-slideset').addClass('ba-active-options');
});
jQ('.slideset-style-title').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-slideset-style-title').addClass('ba-fade');
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-title').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    if (!options[53]) {
        options[53] = 0;
    }
    jQ('.slideset-title-letter-spacing').val(options[53]);
    jQ('.slideset-title-letter-spacing-number').val(options[53]);
    jQ('.slideset-title-align').each(function(){
        if (jQ(this).val() == options[14]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.slideset-title-font-family').val(options[15].replace(new RegExp('\\+','g'), ' ')+' '+options[16]);
    var color = rgb2hex(options[17]);
    jQ('.slideset-title-text-color').minicolors('value', color[0]);
    jQ('.slideset-title-text-color').minicolors('opacity', color[1]);
    jQ('.slideset-title-font-size').val(options[18]);
    jQ('.slideset-title-font-size-number').val(options[18]);
    jQ('.slideset-title-line-height').val(options[19]);
    jQ('.slideset-title-line-height-number').val(options[19]);
    jQ('.slideset-title-font-style').each(function(){
        if (jQ(this).val() == 'underline') {
            if (options[20] == 'underline') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'uppercase') {
            if (options[21] == 'uppercase') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'italic') {
            if (options[22] == 'italic') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
    jQ('.slideset-title-margin-bottom').val(options[23]);
    jQ('.slideset-title-margin-bottom-number').val(options[23]);
});
jQ('.slideset-title-margin-bottom').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            var options = currentItem.find('.ba-slideset-options').val();
            options = options.split(';');
            options[23] = inputValue;
            currentItem.find('.ba-slideset-caption .ba-slideset-title').css('margin-bottom', inputValue+'px');
            initialSlideset(currentItem.find('.ba-slideset'), options[0], options[2], options[3],
                            options[5], options[8]);
            options = options.join(';');
            currentItem.find('.ba-slideset-options').val(options);
            jQ('.slideset-title-margin-bottom-number').val(inputValue);
        }, 12);
    jQ('.slideset-title-margin-bottom').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-title-margin-bottom-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    options[23] = value;
    currentItem.find('.ba-slideset-caption .ba-slideset-title').css('margin-bottom', value+'px');
    initialSlideset(currentItem.find('.ba-slideset'), options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    jQ('.slideset-title-margin-bottom').val(value);
    addHistory();
});
jQ('.select-slideset-title-family').on('click', function(){
    uploadMode = 'slidesetTitle';
    jQ('#fonts-modal').modal();
});
jQ('.select-slideset-description-family').on('click', function(){
    uploadMode = 'slidesetDescription';
    jQ('#fonts-modal').modal();
});
jQ('.select-slideset-button-family').on('click', function(){
    uploadMode = 'slidesetButton';
    jQ('#fonts-modal').modal();
});
jQ('.slideset-title-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-slideset-options', 14, jQ(this).val(), 'text-align', '.ba-slideset-caption .ba-slideset-title', '');
    addHistory();
});
jQ('.slideset-title-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slideset-options', 53, inputValue, 'letter-spacing', '.ba-slideset-caption .ba-slideset-title', 'px');
            jQ('.slideset-title-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.slideset-title-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-title-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slideset-options', 53, value, 'letter-spacing', '.ba-slideset-caption .ba-slideset-title', 'px');
    jQ('.slideset-title-letter-spacing').val(value);
    addHistory();
});
jQ('.slideset-title-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slideset-options', 17, hex, 'color', '.ba-slideset-caption .ba-slideset-title', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-title-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slideset-options', 18, inputValue, 'font-size', '.ba-slideset-caption .ba-slideset-title', 'px');
            jQ('.slideset-title-font-size-number').val(inputValue);
        }, 12);
    jQ('.slideset-title-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-title-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slideset-options', 18, value, 'font-size', '.ba-slideset-caption .ba-slideset-title', 'px');
    jQ('.slideset-title-font-size').val(value);
    addHistory();
});
jQ('.slideset-title-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        var options = currentItem.find('.ba-slideset-options').val();
        options = options.split(';');
        options[19] = inputValue;
        currentItem.find('.ba-slideset-caption .ba-slideset-title').css('line-height', inputValue+'px');
        initialSlideset(currentItem.find('.ba-slideset'), options[0], options[2],
                        options[3], options[5], options[8]);
        options = options.join(';');
        currentItem.find('.ba-slideset-options').val(options);
        jQ('.slideset-title-line-height-number').val(inputValue);
    }, 12);
    jQ('.slideset-title-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-title-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    options[19] = value;
    currentItem.find('.ba-slideset-caption .ba-slideset-title').css('line-height', value+'px');
    initialSlideset(currentItem.find('.ba-slideset'), options[0], options[2],
                    options[3], options[5], options[8]);
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    jQ('.slideset-title-line-height').val(value);
    addHistory();
});
jQ('.slideset-title-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[20] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[20] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[20] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[21] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[21] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[21] = 'none';
        }
    } else {
        if (options[22] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[22] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[22] = 'normal';
        }
    }
    currentItem.find('.ba-slideset-caption .ba-slideset-title').css({
        'text-decoration' : options[20],
        'text-transform' : options[21],
        'font-style' : options[22]
    });
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-style-description').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-slideset-style-description').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-description').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    if (!options[54]) {
        options[54] = 0;
    }
    jQ('.slideset-description-letter-spacing').val(options[54]);
    jQ('.slideset-description-letter-spacing-number').val(options[54]);
    jQ('.slideset-description-align').each(function(){
        if (jQ(this).val() == options[24]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.slideset-description-font-family').val(options[25].replace(new RegExp('\\+','g'), ' ')+' '+options[26]);
    var color = rgb2hex(options[27]);
    jQ('.slideset-description-text-color').minicolors('value', color[0]);
    jQ('.slideset-description-text-color').minicolors('opacity', color[1]);
    jQ('.slideset-description-font-size').val(options[28]);
    jQ('.slideset-description-font-size-number').val(options[28]);
    jQ('.slideset-description-line-height').val(options[29]);
    jQ('.slideset-description-line-height-number').val(options[29]);
    jQ('.slideset-description-font-style').each(function(){
        if (jQ(this).val() == 'underline') {
            if (options[30] == 'underline') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'uppercase') {
            if (options[31] == 'uppercase') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
        if (jQ(this).val() == 'italic') {
            if (options[32] == 'italic') {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.slideset-description-align').on('click', function(){
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
    setValue('.ba-slideset-options', 24, jQ(this).val(), 'text-align', '.ba-slideset-caption .ba-slideset-description', '');
    addHistory();
});
jQ('.slideset-description-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slideset-options', 54, inputValue, 'letter-spacing', '.ba-slideset-caption .ba-slideset-description', 'px');
            jQ('.slideset-description-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.slideset-description-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-description-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slideset-options', 54, value, 'letter-spacing', '.ba-slideset-caption .ba-slideset-description', 'px');
    jQ('.slideset-description-letter-spacing').val(value);
    addHistory();
});
jQ('.slideset-description-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slideset-options', 27, hex, 'color', '.ba-slideset-caption .ba-slideset-description', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-description-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slideset-options', 28, inputValue, 'font-size', '.ba-slideset-caption .ba-slideset-description', 'px');
            jQ('.slideset-description-font-size-number').val(inputValue);
        }, 12);
    jQ('.slideset-description-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-description-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slideset-options', 28, value, 'font-size', '.ba-slideset-caption .ba-slideset-description', 'px');
    jQ('.slideset-description-font-size').val(value);
    addHistory();
});
jQ('.slideset-description-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        var options = currentItem.find('.ba-slideset-options').val();
        options = options.split(';');
        options[29] = inputValue;
        currentItem.find('.ba-slideset-caption .ba-slideset-description').css('line-height', inputValue+'px');
        initialSlideset(currentItem.find('.ba-slideset'), options[0], options[2],
                        options[3], options[5], options[8]);
        options = options.join(';');
        currentItem.find('.ba-slideset-options').val(options);
        jQ('.slideset-description-line-height-number').val(inputValue);
    }, 12);
    jQ('.slideset-description-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-description-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    options[29] = value;
    currentItem.find('.ba-slideset-caption .ba-slideset-description').css('line-height', value+'px');
    initialSlideset(currentItem.find('.ba-slideset'), options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    jQ('.slideset-description-line-height').val(value);
    addHistory();
});
jQ('.slideset-description-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[30] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[30] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[30] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[31] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[31] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[31] = 'none';
        }
    } else {
        if (options[32] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[32] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[32] = 'normal';
        }
    }
    currentItem.find('.ba-slideset-caption .ba-slideset-description').css({
        'text-decoration' : options[30],
        'text-transform' : options[31],
        'font-style' : options[32]
    });
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-style-button').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slideset-style-button-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slideset-button').show().addClass('ba-active-options');
});
jQ('.nav-slideset-button').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-element-options .ba-fade').removeClass('ba-fade');
    jQ('.slideset-style-button-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slideset-button').show().addClass('ba-active-options');
    jQ('.nav-slideset-button ~ a').hide();
});
jQ('.slideset-button-font').on('click', function(){
    jQ('.slideset-style-button-options').removeClass('ba-in');
    jQ('.slideset-button-font-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-font').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-slideset-options').val(),
        color;
    options = options.split(';');
    if (!options[55]) {
        options[55] = 0;
    }
    jQ('.slideset-button-letter-spacing').val(options[55]);
    jQ('.slideset-button-letter-spacing-number').val(options[55]);
    jQ('.slideset-button-align').each(function(){
        if (jQ(this).val() == options[33]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.slideset-button-font-family').val(options[34].replace(new RegExp('\\+','g'), ' ')+' '+options[35]);
    color = rgb2hex(options[36]);
    jQ('.slideset-button-bg-color').minicolors('value', color[0]);
    jQ('.slideset-button-bg-color').minicolors('opacity', color[1]);
    color = rgb2hex(options[37]);
    jQ('.slideset-button-text-color').minicolors('value', color[0]);
    jQ('.slideset-button-text-color').minicolors('opacity', color[1]);
    jQ('.slideset-button-font-size').val(options[38]);
    jQ('.slideset-button-font-size-number').val(options[38]);
    jQ('.slideset-button-font-style').each(function(){
        var value = jQ(this).val();
        if (jQ(this).val() == 'underline') {
            if (options[39] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        } else if (jQ(this).val() == 'uppercase') {
            if (options[40] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        } else {
            if (options[41] == value) {
                jQ(this).closest('label').addClass('active');
            } else {
                jQ(this).closest('label').removeClass('active');
            }
        }
    });
});
jQ('.slideset-button-align').on('click', function(){
    jQ('.button-alignment').removeClass('active');
    jQ(this).closest('.button-alignment').addClass('active');
    setValue('.ba-slideset-options', 33, jQ(this).val(), 'text-align', '.ba-slideset-caption .slideset-button', '');
    addHistory();
});
jQ('.slideset-button-bg-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != ''){
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slideset-options', 36, hex, 'background', '.ba-slideset-caption .slideset-button a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-button-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slideset-options', 55, inputValue, 'letter-spacing', '.ba-slideset-caption .slideset-button a', 'px');
            jQ('.slideset-button-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.slideset-button-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-button-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slideset-options', 55, value, 'letter-spacing', '.ba-slideset-caption .slideset-button a', 'px');
    jQ('.slideset-button-letter-spacing').val(value);
    addHistory();
});
jQ('.slideset-button-text-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-slideset-options', 37, hex, 'color', '.ba-slideset-caption .slideset-button a', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-button-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slideset-options', 38, inputValue, 'font-size', '.ba-slideset-caption .slideset-button a', 'px');
            jQ('.slideset-button-font-size-number').val(inputValue);
        }, 12);
    jQ('.slideset-button-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-button-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slideset-options', 38, value, 'font-size', '.ba-slideset-caption .slideset-button a', 'px');
    jQ('.slideset-button-font-size').val(value);
    addHistory();
});
jQ('.slideset-button-font-style').on('change', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    if (jQ(this).val() == 'underline') {
        if (options[39] != value) {
            jQ(this).closest('label').addClass('active');
            options[39] = value;

        } else {
            jQ(this).closest('label').removeClass('active');
            options[39] = 'none';
        }
    } else if (jQ(this).val() == 'uppercase') {
        if (options[40] != value) {
            jQ(this).closest('label').addClass('active');
            options[40] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[40] = 'none';
        }
    } else {
        if (options[41] != value) {
            jQ(this).closest('label').addClass('active');
            options[41] = value;
        } else {
            jQ(this).closest('label').removeClass('active');
            options[41] = 'normal';
        }
    }
    currentItem.find('.ba-slideset-caption .slideset-button a').css({
        'text-decoration' : options[39],
        'text-transform' : options[40],
        'font-style' : options[41]
    });
    options = options.join(';');
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-button-border').on('click', function(){
    jQ('.slideset-style-button-options').removeClass('ba-in');
    jQ('.slideset-button-border-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-border').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-slideset-options').val(),
        color;
    options = options.split(';');
    jQ('.slideset-button-border-radius').val(options[42]);
    jQ('.slideset-button-border-radius-number').val(options[42]);
    color = rgb2hex(options[43]);
    jQ('.slideset-button-border-color').minicolors('value', color[0]);
    jQ('.slideset-button-border-color').minicolors('opacity', color[1]);
    jQ('.slideset-button-border-width').val(options[44]);
    jQ('.slideset-button-border-width-number').val(options[44]);
});
jQ('.slideset-button-border-radius').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-slideset-options', 42, inputValue, 'border-radius', '.ba-slideset-caption .slideset-button a', 'px');
            jQ('.slideset-button-border-radius-number').val(inputValue);
        }, 12);
    jQ('.slideset-button-border-radius').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-button-border-radius-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-slideset-options', 42, inputValue, 'border-radius', '.ba-slideset-caption .slideset-button a', 'px');
    jQ('.slideset-button-border-radius').val(value);
    addHistory();
});
jQ('.slideset-button-border-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            var options = currentItem.find('.ba-slideset-options').val();
            options = options.split(';');
            options[43] = jQ(this).minicolors('rgbaString');
            currentItem.find('.ba-slideset-caption .slideset-button a').css('border', options[44]+'px solid '+options[43]);
            options = options.join(';')
            currentItem.find('.ba-slideset-options').val(options);
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-button-border-width').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            var options = currentItem.find('.ba-slideset-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[44] = inputValue;
            currentItem.find('.ba-slideset-caption .slideset-button a').css('border', options[44]+'px solid '+options[43]);
            options = options.join(';');
            currentItem.find('.ba-slideset-options').val(options);
            jQ('.slideset-button-border-width-number').val(inputValue);
        }, 12);
    jQ('.slideset-button-border-width').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-button-border-width-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    options[44] = value;
    currentItem.find('.ba-slideset-caption .slideset-button a').css('border', options[44]+'px solid '+options[43]);
    options = options.join(';');
    jQ('.slideset-button-border-width').val(value);
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-button-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slideset-button-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    jQ('.margin-top-slideset-button').val(options[50]);
    jQ('.margin-top-slideset-button-number').val(options[50]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-slideset-button').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            var options = currentItem.find('.ba-slideset-options').val();
            options = options.split(';');
            inputValue = input.val();
            options[50] = inputValue;
            currentItem.find('.slideset-button a').css('margin-top', inputValue+'px');
            initialSlideset(currentItem.find('.ba-slideset'), options[0], options[2], options[3], options[5], options[8]);
            options = options.join(';');
            currentItem.find('.ba-slideset-options').val(options);
            jQ('.margin-top-slideset-button-number').val(inputValue);
        }, 12);
    jQ('.margin-top-slideset-button').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-slideset-button-number').on('click keyup', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    options[50] = value;
    currentItem.find('.slideset-button a').css('margin-top', value+'px');
    initialSlideset(currentItem.find('.ba-slideset'), options[0], options[2], options[3], options[5], options[8]);
    options = options.join(';');
    jQ('.margin-top-slideset-button').val(value);
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-button-padding').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slideset-button-padding-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    jQ('.slideset-button-padding-vertical').val(options[48]);
    jQ('.slideset-button-padding-vertical-number').val(options[48]);
    jQ('.slideset-button-padding-horizontal').val(options[49]);
    jQ('.slideset-button-padding-horizontal-number').val(options[49]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-padding').show().addClass('ba-active-options');
});
jQ('.slideset-button-padding-vertical').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '',
        interval = setInterval(function(){
            var options = currentItem.find('.ba-slideset-options').val();
            inputValue = input.val();
            options = paddingAction(currentItem.find('.ba-slideset-caption .slideset-button a'), options, inputValue, 48, 48, 49, 48, 49);
            currentItem.find('.ba-slideset-options').val(options);
            jQ('.slideset-button-padding-vertical-number').val(inputValue);
        }, 12);
    jQ('.slideset-button-padding-vertical').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-button-padding-vertical-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slideset-options').val();
    options = paddingAction(currentItem.find('.ba-slideset-caption .slideset-button a'), options, value, 48, 48, 49, 48, 49);
    jQ('.slideset-button-padding-vertical').val(value);
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-button-padding-horizontal').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-slideset-options').val();
        inputValue = input.val();
        options = paddingAction(currentItem.find('.ba-slideset-caption .slideset-button a'), options, inputValue, 49, 48, 49, 48, 49);
        currentItem.find('.ba-slideset-options').val(options);
        jQ('.slideset-button-padding-horizontal-number').val(inputValue);
    }, 12);
    jQ('.slideset-button-padding-horizontal').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.slideset-button-padding-horizontal-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slideset-options').val();
    options = paddingAction(currentItem.find('.ba-slideset-caption .slideset-button a'), options, value, 49, 48, 49, 48, 49);
    jQ('.slideset-button-padding-horizontal').val(value);
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});
jQ('.slideset-button-hover').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slideset-button-hover-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slideset-options').val(),
        color;
    options = options.split(';');
    color = rgb2hex(options[45]);
    jQ('.slideset-button-text-color-hover').minicolors('value', color[0]);
    jQ('.slideset-button-text-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[46]);
    jQ('.slideset-button-bg-color-hover').minicolors('value', color[0]);
    jQ('.slideset-button-bg-color-hover').minicolors('opacity', color[1]);
    color = rgb2hex(options[47]);
    jQ('.slideset-button-border-color-hover').minicolors('value', color[0]);
    jQ('.slideset-button-border-color-hover').minicolors('opacity', color[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-hover').show().addClass('ba-active-options');
});
jQ('.slideset-button-text-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-slideset-options', 45, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-button-bg-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            setValue('.ba-slideset-options', 46, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-button-border-color-hover').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '' || opacity != '') {
            setValue('.ba-slideset-options', 47, jQ(this).minicolors('rgbaString'));
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.slideset-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slideset-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    jQ('.margin-top-slideset').val(options[11]);
    jQ('.margin-top-slideset-number').val(options[11]);
    jQ('.margin-bottom-slideset').val(options[12]);
    jQ('.margin-bottom-slideset-number').val(options[12]);
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-slideset').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-slideset-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 11, 11, 12);
        currentItem.find('.ba-slideset-options').val(options);
        jQ('.margin-top-slideset-number').val(inputValue);
    }, 12);
    jQ('.margin-top-slideset').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-slideset').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-slideset-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 12, 11, 12);
        currentItem.find('.ba-slideset-options').val(options);
        jQ('.margin-bottom-slideset-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-slideset').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-slideset-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slideset-options').val();
    options = marginAction(currentItem, options, value, 11, 11, 12);
    currentItem.find('.ba-slideset-options').val(options);
    jQ('.margin-top-slideset').val(value);
    addHistory();
});
jQ('.margin-bottom-slideset-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-slideset-options').val();
    options = marginAction(currentItem, options, value, 12, 11, 12);
    currentItem.find('.ba-slideset-options').val(options);
    jQ('.margin-bottom-slideset').val(value);
    addHistory();
});
jQ('.slideset-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.slideset-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-slideset-options').val();
    options = options.split(';');
    jQ('.custom-suffix-slideset').val(options[13]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-slideset').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-slideset-options').val(), jQ(this).val(), 13);
    currentItem.find('.ba-slideset-options').val(options);
    addHistory();
});