/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

jQ('.social-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.social-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-social-options').val();
    options = options.split(';');
    jQ('.social-align').each(function(){
        if (jQ(this).val() == options[9]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.social-type option').each(function(){
        if (jQ(this).val() == options[11]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.social-size option').each(function(){
        if (jQ(this).val() == options[10]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.social-view option').each(function(){
        if (jQ(this).val() == options[8]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[3] == 1) {
        jQ('.show-counters').attr('checked', true);
    } else {
        jQ('.show-counters').removeAttr('checked');
    }
    if (options[4] == 1) {
        jQ('.show-facebook').attr('checked', true);
    } else {
        jQ('.show-facebook').removeAttr('checked');
    }
    if (options[5] == 1) {
        jQ('.show-twitter').attr('checked', true);
    } else {
        jQ('.show-twitter').removeAttr('checked');
    }
    if (options[6] == 1) {
        jQ('.show-google').attr('checked', true);
    } else {
        jQ('.show-google').removeAttr('checked');
    }
    if (options[12] == 1) {
        jQ('.show-linkedin').attr('checked', true);
    } else {
        jQ('.show-linkedin').removeAttr('checked');
    }
    if (options[13] == 1) {
        jQ('.show-vkontakte').attr('checked', true);
    } else {
        jQ('.show-vkontakte').removeAttr('checked');
    }
    if (options[7] == 1) {
        jQ('.show-pinterest').attr('checked', true);
    } else {
        jQ('.show-pinterest').removeAttr('checked');
    }
    if (introImage == '') {
        jQ('.show-pinterest').attr('disabled', true);
    } else {
        jQ('.show-pinterest').removeAttr('disabled');
    }
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.social-align').on('click', function(){
    setValue('.ba-social-options', 9, jQ(this).val(), 'text-align', '.ba-social', '');
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).closest('label').addClass('active');
});
jQ('.social-size').on('change', function(){
    var options = currentItem.find('.ba-social-options').val(),
        value = jQ(this).val();
    options = options.split(';');
    currentItem.find('.ba-social').removeClass(options[10]);
    currentItem.find('.ba-social').addClass(value);
    options[10] = value;
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.social-type').on('change', function(){
    var options = currentItem.find('.ba-social-options').val(),
        value = jQ(this).val();
    options = options.split(';');
    currentItem.removeClass(options[11]);
    currentItem.addClass(value);
    options[11] = value;
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.social-view').on('change', function(){
    var options = currentItem.find('.ba-social-options').val(),
        value = jQ(this).val();
    options = options.split(';');
    currentItem.find('.ba-social').removeClass(options[8]);
    currentItem.find('.ba-social').addClass(value);
    options[8] = value;
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.show-counters').on('click', function(){
    var options = currentItem.find('.ba-social-options').val(),
        item = currentItem.find('.ba-social');
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[3] = 1;
        currentItem.find('.ba-social .social-counter').show();
    } else {
        options[3] = 0;
        currentItem.find('.ba-social .social-counter').hide();
    }
    initSocial(item, options[3], options[4], options[5], options[6], options[7], options[12], options[13]);
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.show-facebook').on('click', function(){
    var options = currentItem.find('.ba-social-options').val(),
        item = currentItem.find('.ba-social');
    options = options.split(';');
    if (options[5] != 1 && options[6] != 1 && options[7] != 1 && options[12] != 1 && options[13] != 1) {
        jQ(this).attr('checked', true);
        return;
    }
    if (jQ(this).prop('checked')) {
        options[4] = 1;
        currentItem.find('.ba-social .facebook').show();
    } else {
        options[4] = 0;
        currentItem.find('.ba-social .facebook').hide();
    }
    initSocial(item, options[3], options[4], options[5], options[6], options[7], options[12], options[13]);
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.show-vkontakte').on('click', function(){
    var options = currentItem.find('.ba-social-options').val(),
        item = currentItem.find('.ba-social');
    options = options.split(';');
    if (options[5] != 1 && options[6] != 1 && options[7] != 1 && options[12] != 1 && options[4] != 1) {
        jQ(this).attr('checked', true);
        return;
    }
    if (jQ(this).prop('checked')) {
        options[13] = 1;
        currentItem.find('.ba-social .vk').show();
    } else {
        options[13] = 0;
        currentItem.find('.ba-social .vk').hide();
    }
    initSocial(item, options[3], options[4], options[5], options[6], options[7], options[12], options[13]);
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.show-twitter').on('click', function(){
    var options = currentItem.find('.ba-social-options').val(),
        item = currentItem.find('.ba-social');
    options = options.split(';');
    if (options[4] != 1 && options[6] != 1 && options[7] != 1 && options[12] != 1 && options[13] != 1) {
        jQ(this).attr('checked', true);
        return;
    }
    if (jQ(this).prop('checked')) {
        options[5] = 1;
        currentItem.find('.ba-social .twitter').show();
    } else {
        options[5] = 0;
        currentItem.find('.ba-social .twitter').hide();
    }
    initSocial(item, options[3], options[4], options[5], options[6], options[7], options[12], options[13]);
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.show-google').on('click', function(){
    var options = currentItem.find('.ba-social-options').val(),
        item = currentItem.find('.ba-social');
    options = options.split(';');
    if (options[4] != 1 && options[5] != 1 && options[7] != 1 && options[12] != 1 && options[13] != 1) {
        jQ(this).attr('checked', true);
        return;
    }
    if (jQ(this).prop('checked')) {
        options[6] = 1;
        currentItem.find('.ba-social .google-plus').show();
    } else {
        options[6] = 0;
        currentItem.find('.ba-social .google-plus').hide();
    }
    initSocial(item, options[3], options[4], options[5], options[6], options[7], options[12], options[13]);
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.show-linkedin').on('click', function(){
    var options = currentItem.find('.ba-social-options').val(),
        item = currentItem.find('.ba-social');
    options = options.split(';');
    if (options[4] != 1 && options[5] != 1 && options[7] != 1 && options[6] != 1 && options[13] != 1) {
        jQ(this).attr('checked', true);
        return;
    }
    if (jQ(this).prop('checked')) {
        options[12] = 1;
        currentItem.find('.ba-social .linkedin').show();
    } else {
        options[12] = 0;
        currentItem.find('.ba-social .linkedin').hide();
    }
    initSocial(item, options[3], options[4], options[5], options[6], options[7], options[12], options[13]);
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.show-pinterest').on('click', function(){
    var options = currentItem.find('.ba-social-options').val(),
        item = currentItem.find('.ba-social');
    options = options.split(';');
    if (options[4] != 1 && options[5] != 1 && options[6] != 1 && options[12] != 1 && options[13] != 1) {
        jQ(this).attr('checked', true);
        return;
    }
    if (jQ(this).prop('checked')) {
        options[7] = 1;
        currentItem.find('.ba-social .pinterest').show();
    } else {
        options[7] = 0;
        currentItem.find('.ba-social .pinterest').hide();
    }
    initSocial(item, options[3], options[4], options[5], options[6], options[7], options[12], options[13]);
    options = options.join(';');
    currentItem.find('.ba-social-options').val(options);
});
jQ('.social-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.social-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-social-options').val();
    options = options.split(';');
    jQ('.margin-top-social').val(options[0]);
    jQ('.margin-top-social-number').val(options[0]);
    jQ('.margin-bottom-social').val(options[1]);
    jQ('.margin-bottom-social-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-social').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-social-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-social-options').val(options);
        jQ('.margin-top-social-number').val(inputValue);
    }, 12);
    jQ('.margin-top-social').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-social').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-social-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-social-options').val(options);
        jQ('.margin-bottom-social-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-social').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-social-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-social-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-social-options').val(options);
    jQ('.margin-top-social').val(value);
    addHistory();
});
jQ('.margin-bottom-social-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-social-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-social-options').val(options);
    jQ('.margin-bottom-social').val(value);
    addHistory();
});
jQ('.social-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.social-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-social-options').val();
    options = options.split(';');
    jQ('.custom-suffix-social').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-social').on('keyup', function(){
    options = customSuffix(currentItem, currentItem.find('.ba-social-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-social-options').val(options);
    addHistory();
});