/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

var link = document.createElement('link');
link.rel = 'stylesheet';
link.href = 'https://cdnjs.cloudflare.com/ajax/libs/weather-icons/2.0.9/css/weather-icons.min.css';
document.getElementsByTagName('head')[0].appendChild(link);

function showWeather(item)
{
    var options = item.find('.ba-weather-options').val();
    options = options.split(';');
    if (options[8] == 1) {
        item.find('.weather-info .wind').show();
    } else {
        item.find('.weather-info .wind').hide();
    }
    if (options[9] == 1) {
        item.find('.weather-info .humidity').show();
    } else {
        item.find('.weather-info .humidity').hide();
    }
    if (options[10] == 1) {
        item.find('.weather-info .pressure').show();
    } else {
        item.find('.weather-info .pressure').hide();
    }
    if (options[11] == 1) {
        item.find('.weather-info .sunrise').show();
    } else {
        item.find('.weather-info .sunrise').hide();
    }
}

jQ('.weather-options-cell').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.weather-options-options').addClass('ba-fade');
    var options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    jQ('.weather-unit option').each(function(){
        if (jQ(this).val() == options[5]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.weather-leanguage option').each(function(){
        if (jQ(this).val() == options[4]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.weather-forecast option').each(function(){
        if (jQ(this).val() == options[6]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    jQ('.weather-layout option').each(function(){
        if (jQ(this).val() == options[7]) {
            jQ(this).attr('selected', true);
        } else {
            jQ(this).removeAttr('selected');
        }
    });
    if (options[8] == 1) {
        jQ('.weather-wind').attr('checked', true);
    } else {
        jQ('.weather-wind').removeAttr('checked');
    }
    if (options[9] == 1) {
        jQ('.weather-humidity').attr('checked', true);
    } else {
        jQ('.weather-humidity').removeAttr('checked');
    }
    if (options[10] == 1) {
        jQ('.weather-pressure').attr('checked', true);
    } else {
        jQ('.weather-pressure').removeAttr('checked');
    }
    if (options[11] == 1) {
        jQ('.weather-sunset').attr('checked', true);
    } else {
        jQ('.weather-sunset').removeAttr('checked');
    }
    jQ('.weather-location').val(options[3]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-slider-options').show().addClass('ba-active-options');
});
jQ('.weather-leanguage').on('change', function(){
    setValue('.ba-weather-options', 4, jQ(this).val());
    initWeather(currentItem);
    addHistory();
});
jQ('.weather-location').on('keyup', function() {
    var value = jQ(this).val()
    clearTimeout(delay)
    delay = setTimeout(function(){
        setValue('.ba-weather-options', 3, value);
        initWeather(currentItem);
        addHistory();
    }, 300);
});
jQ('.weather-unit').on('change', function(){
    setValue('.ba-weather-options', 5, jQ(this).val());
    initWeather(currentItem);
    addHistory();
});
jQ('.weather-forecast').on('change', function(){
    setValue('.ba-weather-options', 6, jQ(this).val());
    initWeather(currentItem);
    addHistory();
});
jQ('.weather-layout').on('change', function(){
    var options = currentItem.find('.ba-weather-options').val(),
        forecast;
    options = options.split(';');
    forecast = currentItem.find('.forecast-'+options[7]);
    forecast.removeClass('forecast-'+options[7]);
    options[7] = jQ(this).val();
    forecast.addClass('forecast-'+options[7]);
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    addHistory();
});
jQ('.weather-wind').on('click', function(){
    var options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[8] = 1;
    } else {
        options[8] = 0;
    }
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    showWeather(currentItem);
    addHistory();
});
jQ('.weather-humidity').on('click', function(){
    var options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[9] = 1;
    } else {
        options[9] = 0;
    }
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    showWeather(currentItem);
    addHistory();
});
jQ('.weather-pressure').on('click', function(){
    var options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[10] = 1;
    } else {
        options[10] = 0;
    }
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    showWeather(currentItem);
    addHistory();
});
jQ('.weather-sunset').on('click', function(){
    var options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    if (jQ(this).prop('checked')) {
        options[11] = 1;
    } else {
        options[11] = 0;
    }
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    showWeather(currentItem);
    addHistory();
});
jQ('.weather-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.weather-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-weather').show().addClass('ba-active-options');
});
jQ('.nav-style-weather').on('click', function(){
    jQ('.ba-gb-options.ba-fade').removeClass('ba-fade');
    jQ('.weather-style-options').addClass('ba-in');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-style-weather ~ a').hide()
    jQ('.nav-style-weather').show().addClass('ba-active-options');
});
jQ('.weather-city').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.weather-city-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-weather-city').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-weather-options').val(),
        color;
    options = options.split(';');
    if (!options[48]) {
        options[48] = 0;
    }
    jQ('.weather-city-letter-spacing').val(options[48]);
    jQ('.weather-city-letter-spacing-number').val(options[48]);
    jQ('.weather-city-align').each(function(){
        if (jQ(this).val() == options[12]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.weather-city-family').val(options[13].replace(new RegExp('\\+','g'), ' ')+' '+options[14]);
    color = rgb2hex(options[15]);
    jQ('.weather-city-color').minicolors('value', color[0]);
    jQ('.weather-city-color').minicolors('opacity', color[1]);
    jQ('.weather-city-font-size').val(options[16]);
    jQ('.weather-city-font-size-number').val(options[16]);
    jQ('.weather-city-line-height').val(options[17]);
    jQ('.weather-city-line-height-number').val(options[17]);
    jQ('.weather-city-font-style').each(function(){
        if (jQ(this).val() == 'underline' && options[18] == 'underline') {
            jQ(this).parent().addClass('active');
        } else if (jQ(this).val() == 'uppercase' && options[19] == 'uppercase') {
            jQ(this).parent().addClass('active');
        } else if (jQ(this).val() == 'italic' && options[20] == 'italic') {
            jQ(this).parent().addClass('active');
        } else {
            jQ(this).parent().removeClass('active');
        }
    });
});
jQ('.weather-city-align').on('click', function(){
    setValue('.ba-weather-options', 12, jQ(this).val(), 'text-align', '.weather .city', '');
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).parent().addClass('active');
});
jQ('.select-weather-city-family').on('click', function(){
    uploadMode = 'weatherCityFamily';
    jQ('#fonts-modal').modal();
});
jQ('.weather-city-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-weather-options', 48, inputValue, 'letter-spacing', '.weather .city', 'px');
            jQ('.weather-city-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.weather-city-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-city-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 48, value, 'letter-spacing', '.weather .city', 'px');
    jQ('.weather-city-letter-spacing').val(value);
    addHistory();
});
jQ('.weather-city-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-weather-options', 15, hex, 'color', '.weather .city', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.weather-city-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-weather-options', 16, inputValue, 'font-size', '.weather .city', 'px');
        jQ('.weather-city-font-size-number').val(inputValue);
    }, 12);
    jQ('.weather-city-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-city-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 16, value, 'font-size', '.weather .city', 'px');
    jQ('.weather-city-font-size').val(value);
    addHistory();
});
jQ('.weather-city-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-weather-options', 17, inputValue, 'line-height', '.weather .city', 'px');
        jQ('.weather-city-line-height-number').val(inputValue);
    }, 12);
    jQ('.weather-city-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-city-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 17, value, 'line-height', '.weather .city', 'px');
    jQ('.weather-city-line-height').val(value);
    addHistory();
});
jQ('.weather-city-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[18] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[18] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[18] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[19] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[19] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[19] = 'none';
        }
    } else {
        if (options[20] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[20] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[20] = 'normal';
        }
    }
    currentItem.find('.weather .city').css({
        'text-decoration' : options[18],
        'text-transform' : options[19],
        'font-style' : options[20]
    });
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    addHistory();
});
jQ('.weather-condition').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.weather-condition-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-weather-condition').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-weather-options').val(),
        color;
    options = options.split(';');
    if (!options[49]) {
        options[49] = 0;
    }
    jQ('.weather-condition-letter-spacing').val(options[49]);
    jQ('.weather-condition-letter-spacing-number').val(options[49]);
    jQ('.weather-condition-align').each(function(){
        if (jQ(this).val() == options[21]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.weather-condition-family').val(options[22].replace(new RegExp('\\+','g'), ' ')+' '+options[23]);
    color = rgb2hex(options[24]);
    jQ('.weather-condition-color').minicolors('value', color[0]);
    jQ('.weather-condition-color').minicolors('opacity', color[1]);
    jQ('.weather-condition-font-size').val(options[25]);
    jQ('.weather-condition-font-size-number').val(options[25]);
    jQ('.weather-condition-line-height').val(options[26]);
    jQ('.weather-condition-line-height-number').val(options[26]);
    jQ('.weather-condition-font-style').each(function(){
        if (jQ(this).val() == 'underline' && options[27] == 'underline') {
            jQ(this).parent().addClass('active');
        } else if (jQ(this).val() == 'uppercase' && options[28] == 'uppercase') {
            jQ(this).parent().addClass('active');
        } else if (jQ(this).val() == 'italic' && options[29] == 'italic') {
            jQ(this).parent().addClass('active');
        } else {
            jQ(this).parent().removeClass('active');
        }
    });
});
jQ('.weather-condition-align').on('click', function(){
    setValue('.ba-weather-options', 21, jQ(this).val(), 'text-align', '.weather .condition', '');
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).parent().addClass('active');
});
jQ('.select-weather-condition-family').on('click', function(){
    uploadMode = 'weatherConditionFamily';
    jQ('#fonts-modal').modal();
});
jQ('.weather-condition-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-weather-options', 49, inputValue, 'letter-spacing', '.weather .condition', 'px');
            jQ('.weather-condition-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.weather-condition-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-condition-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 49, value, 'letter-spacing', '.weather .condition', 'px');
    jQ('.weather-condition-letter-spacing').val(value);
    addHistory();
});
jQ('.weather-condition-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-weather-options', 24, hex, 'color', '.weather .condition', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.weather-condition-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-weather-options', 25, inputValue, 'font-size', '.weather .condition', 'px');
        jQ('.weather-condition-font-size-number').val(inputValue);
    }, 12);
    jQ('.weather-condition-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-condition-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 25, value, 'font-size', '.weather .condition', 'px');
    jQ('.weather-condition-font-size').val(value);
    addHistory();
});
jQ('.weather-condition-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-weather-options', 26, inputValue, 'line-height', '.weather .condition', 'px');
        jQ('.weather-condition-line-height-number').val(inputValue);
    }, 12);
    jQ('.weather-condition-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-condition-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 26, value, 'line-height', '.weather .condition', 'px');
    jQ('.weather-condition-line-height').val(value);
    addHistory();
});
jQ('.weather-condition-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[27] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[27] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[27] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[28] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[28] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[28] = 'none';
        }
    } else {
        if (options[29] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[29] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[29] = 'normal';
        }
    }
    currentItem.find('.weather .condition').css({
        'text-decoration' : options[27],
        'text-transform' : options[28],
        'font-style' : options[29]
    });
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    addHistory();
});
jQ('.ba-workspace .weather-info').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.weather-info-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-weather-info').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-weather-options').val(),
        color;
    options = options.split(';');
    if (!options[50]) {
        options[50] = 0;
    }
    jQ('.weather-info-letter-spacing').val(options[50]);
    jQ('.weather-info-letter-spacing-number').val(options[50]);
    jQ('.weather-info-align').each(function(){
        if (jQ(this).val() == options[30]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.weather-info-family').val(options[31].replace(new RegExp('\\+','g'), ' ')+' '+options[32]);
    color = rgb2hex(options[33]);
    jQ('.weather-info-color').minicolors('value', color[0]);
    jQ('.weather-info-color').minicolors('opacity', color[1]);
    jQ('.weather-info-font-size').val(options[34]);
    jQ('.weather-info-font-size-number').val(options[34]);
    jQ('.weather-info-line-height').val(options[35]);
    jQ('.weather-info-line-height-number').val(options[35]);
    jQ('.weather-info-font-style').each(function(){
        if (jQ(this).val() == 'underline' && options[36] == 'underline') {
            jQ(this).parent().addClass('active');
        } else if (jQ(this).val() == 'uppercase' && options[37] == 'uppercase') {
            jQ(this).parent().addClass('active');
        } else if (jQ(this).val() == 'italic' && options[38] == 'italic') {
            jQ(this).parent().addClass('active');
        } else {
            jQ(this).parent().removeClass('active');
        }
    });
});
jQ('.weather-info-align').on('click', function(){
    setValue('.ba-weather-options', 30, jQ(this).val(), 'text-align', '.weather .date, .weather-info > div', '');
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).parent().addClass('active');
});
jQ('.select-weather-info-family').on('click', function(){
    uploadMode = 'weatherInfoFamily';
    jQ('#fonts-modal').modal();
});
jQ('.weather-info-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-weather-options', 50, inputValue, 'letter-spacing', '.weather .date, .weather-info > div', 'px');
            jQ('.weather-info-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.weather-info-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-info-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 50, value, 'letter-spacing', '.weather .date, .weather-info > div', 'px');
    jQ('.weather-info-letter-spacing').val(value);
    addHistory();
});
jQ('.weather-info-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-weather-options', 33, hex, 'color', '.weather .date, .weather-info > div', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.weather-info-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-weather-options', 34, inputValue, 'font-size', '.weather .date, .weather-info > div', 'px');
        jQ('.weather-info-font-size-number').val(inputValue);
    }, 12);
    jQ('.weather-info-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-info-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 34, value, 'font-size', '.weather .date, .weather-info > div', 'px');
    jQ('.weather-info-font-size').val(value);
    addHistory();
});
jQ('.weather-info-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-weather-options', 35, inputValue, 'line-height', '.weather .date, .weather-info > div', 'px');
        jQ('.weather-info-line-height-number').val(inputValue);
    }, 12);
    jQ('.weather-info-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-info-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 35, value, 'line-height', '.weather .date, .weather-info > div', 'px');
    jQ('.weather-info-line-height').val(value);
    addHistory();
});
jQ('.weather-info-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[36] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[36] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[36] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[37] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[37] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[37] = 'none';
        }
    } else {
        if (options[38] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[38] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[38] = 'normal';
        }
    }
    currentItem.find('.weather .date, .weather-info > div').css({
        'text-decoration' : options[36],
        'text-transform' : options[37],
        'font-style' : options[38]
    });
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    addHistory();
});
jQ('.weather-forecast-style').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.weather-forecast-options').addClass('ba-fade');
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-weather-forecast').show().addClass('ba-active-options');
    var options = currentItem.find('.ba-weather-options').val(),
        color;
    options = options.split(';');
    if (!options[51]) {
        options[51] = 0;
    }
    jQ('.weather-forecast-letter-spacing').val(options[51]);
    jQ('.weather-forecast-letter-spacing-number').val(options[51]);
    jQ('.weather-forecast-align').each(function(){
        if (jQ(this).val() == options[39]) {
            jQ(this).closest('label').addClass('active');
        } else {
            jQ(this).closest('label').removeClass('active');
        }
    });
    jQ('.weather-forecast-family').val(options[40].replace(new RegExp('\\+','g'), ' ')+' '+options[41]);
    color = rgb2hex(options[42]);
    jQ('.weather-forecast-color').minicolors('value', color[0]);
    jQ('.weather-forecast-color').minicolors('opacity', color[1]);
    jQ('.weather-forecast-font-size').val(options[43]);
    jQ('.weather-forecast-font-size-number').val(options[43]);
    jQ('.weather-forecast-line-height').val(options[44]);
    jQ('.weather-forecast-line-height-number').val(options[44]);
    jQ('.weather-forecast-font-style').each(function(){
        if (jQ(this).val() == 'underline' && options[45] == 'underline') {
            jQ(this).parent().addClass('active');
        } else if (jQ(this).val() == 'uppercase' && options[46] == 'uppercase') {
            jQ(this).parent().addClass('active');
        } else if (jQ(this).val() == 'italic' && options[47] == 'italic') {
            jQ(this).parent().addClass('active');
        } else {
            jQ(this).parent().removeClass('active');
        }
    });
});
jQ('.weather-forecast-align').on('click', function(){
    setValue('.ba-weather-options', 39, jQ(this).val(), 'text-align', '[class^="forecast-"] span', '');
    jQ(this).closest('.btn-alignment-options').find('.active').removeClass('active');
    jQ(this).parent().addClass('active');
});
jQ('.select-weather-forecast-family').on('click', function(){
    uploadMode = 'weatherForecastFamily';
    jQ('#fonts-modal').modal();
});
jQ('.weather-forecast-letter-spacing').on('mousedown', function(){
    var input = jQ(this),
        inputValue,
        interval = setInterval(function(){
            inputValue = input.val();
            setValue('.ba-weather-options', 51, inputValue, 'letter-spacing', '[class^="forecast-"] span', 'px');
            jQ('.weather-forecast-letter-spacing-number').val(inputValue);
        }, 100);
    jQ('.weather-forecast-letter-spacing').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-forecast-letter-spacing-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 51, value, 'letter-spacing', '[class^="forecast-"] span', 'px');
    jQ('.weather-forecast-letter-spacing').val(value);
    addHistory();
});
jQ('.weather-forecast-color').minicolors({
    opacity: true,
    change: function(hex, opacity) {
        if (hex != '') {
            hex = jQ(this).minicolors('rgbaString');
            setValue('.ba-weather-options', 42, hex, 'color', '[class^="forecast-"] span', '');
        }
    },
    show:function(){
        jQ('.ba-workspace').draggable( "option", "disabled", true );
    },
    hide: function(){
        jQ('.ba-workspace').draggable( "option", "disabled", false );
        addHistory();
    }
});
jQ('.weather-forecast-font-size').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-weather-options', 43, inputValue, 'font-size', '[class^="forecast-"] span', 'px');
        jQ('.weather-forecast-font-size-number').val(inputValue);
    }, 12);
    jQ('.weather-forecast-font-size').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-forecast-font-size-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 43, value, 'font-size', '[class^="forecast-"] span', 'px');
    jQ('.weather-forecast-font-size').val(value);
    addHistory();
});
jQ('.weather-forecast-line-height').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        inputValue = input.val();
        setValue('.ba-weather-options', 44, inputValue, 'line-height', '[class^="forecast-"] span', 'px');
        jQ('.weather-forecast-line-height-number').val(inputValue);
    }, 12);
    jQ('.weather-forecast-line-height').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.weather-forecast-line-height-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val());
    setValue('.ba-weather-options', 44, value, 'line-height', '[class^="forecast-"] span', 'px');
    jQ('.weather-forecast-line-height').val(value);
    addHistory();
});
jQ('.weather-forecast-font-style').on('click', function(){
    var value = jQ(this).val(),
        options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    if (value == 'underline') {
        if (options[45] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[45] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[45] = 'none';
        }
    } else if (value == 'uppercase') {
        if (options[46] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[46] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[46] = 'none';
        }
    } else {
        if (options[47] != value) {
            jQ(this).closest('.ba-btn').addClass('active');
            options[47] = value;
        } else {
            jQ(this).closest('.ba-btn').removeClass('active');
            options[47] = 'normal';
        }
    }
    currentItem.find('[class^="forecast-"] span').css({
        'text-decoration' : options[45],
        'text-transform' : options[46],
        'font-style' : options[47]
    });
    options = options.join(';');
    currentItem.find('.ba-weather-options').val(options);
    addHistory();
});
jQ('.weather-margin').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.weather-margin-options').addClass('ba-fade');
    var options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    jQ('.margin-top-weather').val(options[0]);
    jQ('.margin-top-weather-number').val(options[0]);
    jQ('.margin-bottom-weather').val(options[1]);
    jQ('.margin-bottom-weather-number').val(options[1]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-margin').show().addClass('ba-active-options');
});
jQ('.margin-top-weather').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-weather-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 0, 0, 1);
        currentItem.find('.ba-weather-options').val(options);
        jQ('.margin-top-weather-number').val(inputValue);
    }, 12);
    jQ('.margin-top-weather').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-bottom-weather').on('mousedown', function(){
    var input = jQ(this),
        inputValue = '';
    var interval = setInterval(function(){
        var options = currentItem.find('.ba-weather-options').val();
        inputValue = input.val();
        options = marginAction(currentItem, options, inputValue, 1, 0, 1);
        currentItem.find('.ba-weather-options').val(options);
        jQ('.margin-bottom-weather-number').val(inputValue);
    }, 12);
    jQ('.margin-bottom-weather').on('mouseup', function(){
        clearInterval(interval);
        addHistory();
    });
});
jQ('.margin-top-weather-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-weather-options').val();
    options = marginAction(currentItem, options, value, 0, 0, 1);
    currentItem.find('.ba-weather-options').val(options);
    jQ('.margin-top-weather').val(value);
    addHistory();
});
jQ('.margin-bottom-weather-number').on('click keyup', function(){
    var value = checkEmptyValue(jQ(this).val()),
        options = currentItem.find('.ba-weather-options').val();
    options = marginAction(currentItem, options, value, 1, 0, 1);
    currentItem.find('.ba-weather-options').val(options);
    jQ('.margin-bottom-weather').val(value);
    addHistory();
});
jQ('.weather-custom').on('click', function(){
    jQ('.ba-in').removeClass('ba-in').addClass('ba-out');
    jQ('.weather-css-options').addClass('ba-fade');
    var options = currentItem.find('.ba-weather-options').val();
    options = options.split(';');
    jQ('.custom-suffix-weather').val(options[2]);
    jQ('.ba-active-options').removeClass('ba-active-options');
    jQ('.nav-custom').show().addClass('ba-active-options');
});
jQ('.custom-suffix-weather').on('keyup', function(){
    var options = customSuffix(currentItem, currentItem.find('.ba-weather-options').val(), jQ(this).val(), 2);
    currentItem.find('.ba-weather-options').val(options);
    addHistory();
});