<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_content
 *
 * @copyright   Copyright (C) 2005 - 2015 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;

class bagridRouter extends JComponentRouterBase
{
    public function build(&$query)
    {
        $segments = array();
        if (!empty($query['Itemid'])) {
            if (isset($query['view'])) {
                unset($query['view']);
            }
            if (isset($query['id'])) {
                unset($query['id']);
            }
        } else {
            if (isset($query['view'])) {
                unset($query['view']);
            }
            /*
            if (isset($query['category'])) {
                $id = $query['category'];
                $db = JFactory::getDbo();
                $q = $db->getQuery(true);
                $q->select('alias')
                    ->from('#__bagrid_categories')
                    ->where('`id` = '.$id);
                $db->setQuery($q);
                $alias = $db->loadResult();
                if (!empty($alias)) {
                    $query['category'] = $alias;
                }
                $segments[] = $query['category'];
                unset($query['category']);
            }*/
            if (isset($query['id'])) {
                $id = $query['id'];
                if (!empty($id)) {
                    $db = JFactory::getDbo();
                    $q = $db->getQuery(true);
                    $q->select('page_alias')
                        ->from('#__bagrid_bagrids')
                        ->where('`id` = '.$id);
                    $db->setQuery($q);
                    $alias = $db->loadResult();
                    if (!empty($alias)) {
                        $query['id'] = $alias;
                    }
                }
                $segments[] = $query['id'];
                unset($query['id']);
            }
        }
        return $segments;
    }

    public function parse(&$segments)
    {
        $vars = array();
        $count = count($segments);
        $vars['view'] = 'page';
        $vars['id'] = end($segments);
        if (!is_numeric($vars['id'])) {
            $alias = $vars['id'];
            $db = JFactory::getDbo();
            $q = $db->getQuery(true);
            $q->select('id')
                ->from('#__bagrid_bagrids')
                ->where('`page_alias` = '.$db->Quote($alias));
            $db->setQuery($q);
            $id = $db->loadResult();
            $vars['id'] = $id;
        }
        
        return $vars;
    }
}

function bagridBuildRoute(&$query)
{
    $router = new bagridRouter;

    return $router->build($query);
}

function bagridParseRoute($segments)
{
    $router = new bagridRouter;

    return $router->parse($segments);
}
