<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

$app = JFactory::getApplication();
$doc = JFactory::getDocument();
$input = $app->input;
$id = $input->get('id');
$url = JUri::root(). 'index.php?option=com_bagrid&view=bagrid&id=' .$id;
$themes = $this->get('Themes');
?>
<script type="text/javascript">
	jQuery(document).ready(function(){
        window.parent.postMessage('preloaderReady', '*');
        var theme = '';
        jQuery('#theme-modal .ba-column').on('click', function(){
            theme = jQuery(this).data('theme');
            jQuery('#theme-modal').addClass('hide').removeClass('in');
            jQuery('#page_theme').val(theme);
            jQuery('#title-modal').addClass('in').removeClass('hide');
        });
        jQuery('#title-modal').on('submit', function(event){
            if (jQuery.trim(jQuery('#ba-title').val()) == '') {
                jQuery('#ba-title').addClass('ba-alert');
                event.stopPropagation();
                event.preventDefault();
            } else {
                jQuery('#ba-title').removeClass('ba-alert');
                window.parent.postMessage('preloader', '*');
            }
        });
    });
</script>
<div class="ba-modal-backdrop"></div>
<div id='title-modal' class='ba-modal-sm modal hide ba-modal-dialog'>
	<div class='modal-header'>
		<h3 class='ba-modal-header'>
			<?php echo JText::_('ENTER_PAGE_TITLE'); ?>
		</h3>
	</div>
	<div class='modal-body'>
        <form action='<?php echo $url; ?>' method='post'>
        	<label>
        		<?php echo JText::_('PAGE_TITLE'); ?>
    		</label>
        	<input name='ba-title' type='text' id='ba-title'><br>
        	<input type='hidden' name='page_theme' id='page_theme'>
        	<button type='submit' name='Submit' class='ba-btn-primary'>
        		<?php echo JText::_('CREATE_PAGE'); ?>
    		</button>
		</form>
	</div>
	<div class='modal-footer'>
		<a href='#' class='ba-btn' onclick="return false"><?php echo JText::_('CLOSE'); ?></a>
	</div>
</div>
<div id='theme-modal' class='ba-modal-l modal ba-modal-dialog in'>
	<div class='modal-header'>
		<h3 class='ba-modal-header'>
			<?php echo JText::_('SELECT_THEME'); ?>
		</h3>
	</div>
	<div class='modal-body'>
    	<div class='tab-content'>
    	<?php
    		$str = '';
    		foreach ($themes as $key => $theme) {
                $str .= "<label class='ba-column'";
                if ($key === 0) {
                    $str .= " id='default-theme'";
                }
                $str .= " data-theme='".$theme->id;
                $str .= "'><img src='" .$theme->image. "' width='175' height='110'><p>";
                $str .= $theme->title."</p>";
                if ($theme->home == 1) {
                    $str .= "<i class='icon-star'></i>";
                }
                $str .= "</label>";
            }
            echo $str;
        ?>
        </div>
    </div>
    <div class='modal-footer'>
    	<a href='#' class='ba-btn' onclick="return false"><?php echo JText::_('CLOSE'); ?></a>
	</div>
</div>
