<?php
/**
* @package   BaGrid
* @author    Balbooa http://www.balbooa.com/
* @copyright Copyright @ Balbooa
* @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
*/

defined('_JEXEC') or die;

class bagridViewEditor extends JViewLegacy
{
    public function display($tpl = null)
    {
        $app = JFactory::getApplication();
        $input = $app->input;
        $layout = $input->get('layout');
        if ($layout != 'upload') {
            if (!isset($_GET['id'])) {
                return JError::raiseError(404, JText::_('NOT_FOUND'));
            }
            $doc = JFactory::getDocument();
            $doc->setTitle('Gridbox Editor');
            $doc->addStyleSheet(JURI::root() . 'components/com_bagrid/assets/css/ba-style.css');
            $doc->addScript(JUri::root(true) . '/media/jui/js/jquery.min.js');
            $doc->addScript(JUri::root(true) . '/media/jui/js/bootstrap.min.js');
            $doc->addScript(JUri::root(true) . '/media/jui/js/jquery.minicolors.min.js');
            $doc->addStyleSheet(JUri::root(true) . '/media/jui/css/jquery.minicolors.css');
            $doc->addScript(JURI::root() . 'components/com_bagrid/assets/js/ba-editor.js');
        }
        
        parent::display($tpl);
    }
}